#!/bin/bash

clear


echo 
echo -e "\033[4mBlendigo Installer for Linux.\033[0m"
echo 
echo
tput sgr0

BL=~/.blender/scripts

if [ -e "$BL" ]
then
	echo This installer copies Blendigo and its support files to ~/.blender/scripts/
	echo
	echo
	echo "Type the path to the Indigo directory and press enter to continue. Press ctrl-c to abort."
	
	read -p "] " answer

	if [ -e "$answer/inifile.xml" ]
	then
		echo
	else
		echo
		echo "Error - could not find inifile.xml at the directory '$answer'."
		echo
		exit -1
	fi

	if [ -e "~/.indigo/location" ]
	then
		rm ~/.indigo/location
	else
		mkdir ~/.indigo 2>/dev/null
	fi
	
	echo $answer > ~/.indigo/location
	
	cp sources/blendigo.py "$BL/" 
	
	if [ -e "$BL/blendigopkg/" ]
	then
		mv -f "$BL/blendigopkg/" /tmp/blendigopkg_old
	fi
	
	mkdir "$BL/blendigopkg/"
	cp -r sources/blendigopkg/* "$BL/blendigopkg/"
	
	echo
	echo
	echo "Installation completed. Enjoy using Indigo!"
	echo
	echo

else
	echo "Sorry, we have a problem, we could not find the \"$BL\" directory on your system. Create "
	echo "this directory and then re-run this installer."
	echo
	echo "Installation terminated."
	echo
	echo
	exit -1
fi
