'''
Created on 10 Nov 2009

@author: doug
'''
import httplib, urllib

import sys
PY25 = sys.version_info[0] == 2 and sys.version_info[1] == 5

class connector:
    
    def get_request(self, query):
        if PY25:
            connection = httplib.HTTPConnection('www.indigorenderer.com')
        else:
            connection = httplib.HTTPConnection('www.indigorenderer.com', timeout=15)
            
        connection.request('GET', '/materials/materials/search.xml?%s'%query.params)
        response = connection.getresponse()
        
        if response.status != 200:
            raise Exception('%i %s'%(response.status, response.reason))
        else:
            rsp = response.read()
            connection.close()
            return rsp

import socket
class query:
    con = None
    params = None
    def __init__(self, connector):
        self.con = connector
        
    def fulltext(self, string):
        self.params = urllib.urlencode({'q': '%s'%string})
        try:
            return resultset(self.con.get_request(self))
        except socket.timeout, err:
            print 'Timeout contacting materials DB: %s' % err
            return []
        except SyntaxError, err:
            print 'Bad XML reponse: %s' % err
            return []
        except Exception, err:
            print 'Bad response: %s' % err
            return []

import xml.etree.cElementTree

class resultset(list):
    def __init__(self, xmlresponse):
        for mat in xml.etree.cElementTree.fromstring(xmlresponse):
            self.append(result(mat))
            
    def __repr__(self):
        return '<matdblib.resultset of %i items>' % len(self)

import os
from utils import makeSafeFilename
class result(dict):
    downloaded = False
    cb = None
    cba = None
    
    def __init__(self, matelement):
        self.clear()
        for c in matelement:
            self[c.tag] = c.text
            
    def _download_report(self, block_count, block_size, total_size):
        #print '%ik ...'%(block_count*block_size/1024) ,
        self['pc'] = (100*(block_count*block_size)/total_size)
        if self['pc']-self._last_pc > 10 and self['pc']<=100:
            self._last_pc = self['pc']
            if self.cb is None: print '%i%%...' % self['pc'],
        if self.cb is not None:
            self.cb(*self.cba)
        
    def download_pigm(self, folder='./', cb=None, cba=None):
        self.cb = cb
        self.cba = cba
        pigm = self.download_file('public-url', 'pigm', folder)
        self.downloaded = True
        return pigm
        
    def is_downloaded(self, path):
        filename = makeSafeFilename(self['name'])
        save_to = os.sep.join([path, '.'.join([filename, 'pigm'])])
        self.downloaded = os.path.exists(save_to)
        return self.downloaded
        
    def download_image(self, folder='./'):
        try:
            ext = os.path.splitext(self['image-url'])[1][1:]
            return self.download_file('image-url', ext, folder)
        except KeyError:
            raise Exception('Invalid result data')
    
    def download_file(self, keyname, fileext, folder):
        iks = self.keys()
        if keyname in iks and 'filename' in iks:
            filename = makeSafeFilename(self['name'])
            save_to = os.sep.join([folder, '.'.join([filename, fileext])])
            
            if not os.path.exists(save_to):
                if self.cb is None: print 'Downloading %s (%ik) :' % (save_to, int(self['size'])/1024),
                self._last_pc = 0
                f, h = urllib.urlretrieve(self[keyname], save_to, self._download_report)
                if self.cb is None: print 'done'
                del self['pc']
            
            return save_to
        else:
            raise Exception('Invalid result data')
    
    def __repr__(self):
        return '<matdblib.result %s (%s)>' % (self['id'], self['name'])
