
class lampspectrum(object):

    @staticmethod
    def get_tree():
        return lampspectrum_tree
    
    @staticmethod
    def get_names():
        return lampspectrum_names
    
    @staticmethod
    def get_data(name):
        if name in lampspectrum.get_names().values():
            return getattr(lampspectrum_data_interpolated, name)
        else:
            raise Exception("Invalid Lampspectrum name: %s"%name)
        
    @staticmethod
    def get_rgb(name):
        if name in lampspectrum.get_names().values():
            rgbval = getattr(lampspectrum_data_rgb, name)
            
            r = (rgbval & 0xFF0000) >> 16
            g = (rgbval & 0x00FF00) >> 8
            b = (rgbval & 0x0000FF)
            r,g,b = [i/256.0 for i in (r,g,b)]
            return (r,g,b)
        else:
            return (0.0,0.0,0.0)
        

lampspectrum_tree = [
        ("Natural", [
            ("Natural Daylight", 1)
        ] ),
        ("Incandescent", [
            ("Paraffin Candle Flame", 2),
            ("Generic 7W Incandescent Lamp", 3),
            ("PHILIPS [Argenta] 200W Incandescent Lamp", 4),
            ("Welsbach Gas Mantle (modern, without Thorium)", 5),
            ("Incandescent Anti-Insect Lamp", 6)
        ] ),
        ("Fluorescent", [
            ("PHILIPS [TL-D 30W/55] Regular Daylight Fluorescent", 7),
            ("Sylvania [F4T5 4W] Regular Warm White Fluorescent", 8),
            ("OSRAM [DULUXSTAR 21W/827] Regular Compact Triphosphor Fluorescent", 9),
            ("Cold Cathode Warm White CFL Triphosphor Fluorescent.", 10),
            ("NARVA [COLOURLUX plus daylight 20W/860] Daylight CFL Triphosphor Fluorescent", 11),
            ("Sylvania [GroLux] Fluorescent Aquarium/Plant Lamp", 12),
            ("Laptop LCD Screen", 13),
            ("PHILIPS [ActiViva] \"Natural\" Triphosphor Fluorescent", 14),
            ("PHILIPS [ActiViva] \"Active\" Triphosphor Fluorescent", 16)
        ] ),
        ("High Pressure Mercury", [
            ("OSRAM [HQA 80W] Clear HPM Lamp", 17),
            ("PHILIPS [HPL 125W] HPM Lamp with improved color", 18),
            ("OSRAM [HQL 80W] HPM Lamp with improved warm deluxe color", 19),
            ("PHILIPS [ML 160W] Self-Ballasted HPM Vapor Lamp", 20),
            ("NARVA [160W] Self-ballasted HPM Vapor Lamp", 21)
        ] ),
        ("Sodium Discharge", [
            ("Regular High Pressure Sodium Lamp, warmup after 5-7 sec", 22),
            ("Regular High Pressure Sodium Lamp, warmup after 10-12 sec", 23),
            ("SOX Low Pressure Sodium Discharge Lamp", 24),
            ("Medium Pressure Sodium Discharge Lamp, warmup after ~35 sec", 25),
            ("GE [Lucalox 35W] High Pressure Sodium Lamp", 26),
            ("PHILIPS [SDW-T 100W] Super High Pressure White Sodium Lamp", 27)
        ] ),
        ("Metal Halide", [
            ("PHILIPS [HPI-T 400W] MH Lamp with Mercury, Sodium, Thallium and Indium iodides", 28),
            ("OSRAM [HQI-TS 75W/WDL] Metal Halide lamp with Mercury, sodium, thallium, indium and tin iodides, from ", 29),
            ("GE [MVR325IUWM 325 Watt I-Line Multi-Vapor Metal Halide - Clear Watt Miser] MH Lamp with Mercury, Sodium and Scandium iodides", 30),
            ("OSRAM [HQI-T 400W/D] MH Lamp with Mercury, Thallium, Dysprosium, Holmium, Thulium and Caesium iodides", 31),
            ("PHILIPS Diazo MH Lamp with Mercury, iron and cobalt iodides", 32),
            ("Sylvania Diazo MH Lamp with Mercury, gallium and lead iodides", 33),
            ("OSRAM [HQI-T 400W/Blau] Blue colored MH Lamp with Mercury and indium iodides", 34),
            ("RADIUM [HRI-T 400W/Planta] Plant growing MH Lamp with Mercury, indium and sodium iodides", 35),
            ("OSRAM [HQI-T 400W/Grun] Green colored MH Lamp with Mercury and thallium iodides", 36)
        ] ),
        ("Diode", [
            ("Regular High Brightness Blue LED", 37),
            ("Monochromatic emission from a Red Laser diode", 38),
            ("Monochromatic emission from a Green Laser diode.", 39)
        ] ),
        ("Spectral", [
            ("PHILIPS Spectral Xenon Lamp - Continuous Xenon low pressure thermionic discharge", 40),
            ("PHILIPS spectral Rubidium Lamp - Continuous Rubidium low pressure thermionic discharge", 41),
            ("PHILIPS spectral Cadmium Lamp - Continuous Cadmium low pressure thermionic discharge", 42),
            ("PHILIPS spectral zinc Lamp - Continuous Zinc low pressure thermionic discharge", 43)
        ] ),
        ("Glow Discharge", [
            ("Neon glow discharge", 44),
            ("Neon and Krypton glow discharge and green phosphor (night-lights/indicators)", 45),
            ("Neon and Xenon glow discharge and green phosphor (night-lights/indicators)", 46),
            ("Neon and Xenon glow discharge and blue phosphor (night-lights/indicators)", 48),
            ("Argon glow discharge", 49),
            ("Self-ballasted High Pressure Mercury Vapor Lamp, with yttrium vanadate phosphate fluorescent phosphors, in glow discharge mode", 50)
        ] ),
        ("Molecular", [
            ("Butane Gas Flame", 51),
            ("Alcohol Flame", 52)
        ] ),
        ("Fluorescence", [
            ("Print quality A4 Xerox paper wrapped around a blacklight Lamp", 53),
            ("Neon green dye, bombarded with black light", 54),
            ("Regular Modern Color TV CRT", 55)
        ] ),
        ("Various", [
            ("Stroboscopic flash. Xenon I, likely II and perhaps III", 56),
            ("Carbon Arc Spectrum", 57),
            ("OSRAM [XBO 75W/2] Short Arc Xenon Lamp", 58)
        ] ),
        ("Blacklight/UV", [
            ("Sylvania [G8T5 8W] Germicidal lamp", 59),
            ("Sylvania [F6T5/BLB 8W] Black light blue fluorescent", 60),
#            ("PHILIPS [HPW 125W] High Pressure Mercury Black Light", 61),
            ("Sylvania [Blacklite 350 F8W/BL350] Black Light fluorescent", 62)
        ] ),
        ("Mercury UV", [
            ("The near visible UVA emissions from a high pressure Mercury clear lamp", 63)
        ] ),
        ("Absorption/Mixed", [
            ("High Pressure Mercury Warm Deluxe light ([1.4.3]) absorbed through blue Cobalt glass", 64),
            ("Incandescent light ([1.2.3]) absorbed through blue Cobalt glass", 65),
            ("High Pressure Mercury Warm Deluxe light ([1.4.3]) absorbed through ciel dye #42053", 66),
            ("Incandescent light ([1.2.3]) absorbed through ciel dye #42053", 67),
            ("High Pressure Mercury Warm Deluxe light ([1.4.3]) absorbed through red glass", 68),
            ("Incandescent light ([1.2.3]) absorbed through red glass.m", 69),
            ("Incandescent light ([1.2.3]) absorbed through olive oil. ", 70)
        ] )
    ]

lampspectrum_names  = {
    1:"Daylight", 2:"Candle", 3:"Incandescent1", 4:"Incandescent2",
    5:"Welsbach", 6:"AntiInsect", 7:"FLD2", 8:"FL37K",
    9:"CFL27K", 10:"CFL4K", 11:"CFL6K", 12:"GroLux",
    13:"LCDS", 14:"FLAV8K",  16:"FLAV17K",
    17:"HPM2", 18:"HPMFL1", 19:"HPMFL2", 20:"HPMSB",
    21:"HPMSBFL", 22:"SS1", 23:"SS2", 24:"LPS",
    25:"MPS", 26:"HPS", 27:"SHPS", 28:"MHN",
    29:"MHWWD", 30:"MHSc", 31:"MHD", 32:"FeCo",
    33:"GaPb", 34:"BLAU", 35:"PLANTA", 36:"GRUN",
    37:"LEDB", 38:"RedLaser", 39:"GreenLaser", 40:"XeI",
    41:"Rb", 42:"Cd", 43:"Zn", 44:"Ne",
    45:"NeKrFL", 46:"NeXeFL1", 48:"NeXeFL2",
    49:"Ar", 50:"HPMFL2Glow", 51:"Butane", 52:"Alcohol",
    53:"BLP", 54:"BLNG", 55:"TV", 56:"Xe",
    57:"CarbonArc", 58:"HPX", 59:"LPM2", 60:"FLBLB",
#    61:"HPMBL", 
    62:"FLBL", 63:"UVA", 64:"HPMFLCobaltGlass",
    65:"CobaltGlass", 66:"HPMFLCL42053", 67:"CL42053", 68:"HPMFLRedGlass",
    69:"RedGlass", 70:"OliveOil"
}

# RGB values of lamp spectra, calculated using D65 illuminant
#    @staticmethod
#    def get_rgb(name):
#        try:
#            import numpy, colormath.color_objects
#        except:
#            raise Exception("This method requires extra python packages installed: Numpy and Colormath")
#        
#        spec = lampspectrum.get_data(name)
#        spec_interp = numpy.interp(range(340,840,10), range(400,700), spec, 0, 0)
#        
#        spec_color = colormath.color_objects.SpectralColor()
#        for i, wl in enumerate(range(340,840,10)):
#            setattr(spec_color, 'spec_%inm'%wl, spec_interp[i])
#        
#        spec_color.illuminant = 'd65'
#        
#        spec_color.calc_density()
#        spec_rgb = spec_color.convert_to('RGB')
#        return spec_rgb.get_rgb_hex()
class lampspectrum_data_rgb(object):
    Daylight = 0xb7bdcc
    Candle = 0xadc8a2
    Incandescent1 = 0xabf467
    Incandescent2 = 0xabf2b1
    Welsbach = 0xb0c3bd
    AntiInsect = 0xc7b300
    FLD2 = 0xb4c0d0
    FL37K = 0xafc1be
    CFL27K = 0xb38f5e
    CFL4K = 0xb39dcb
    CFL6K = 0xacafd6
    GroLux = 0x875b6d
    LCDS = 0x957a89
    FLAV8K = 0xb194ca
    FLAV17K = 0xb099cf
    HPM2 = 0xa5bb3c
    HPMFL1 = 0xc3a3cd
    HPMFL2 = 0xb386ba
    HPMSB = 0xbfa7bd
    HPMSBFL = 0xc49ebc
    SS1 = 0xc7a400
    SS2 = 0xcc9400
    LPS = 0x995100
    MPS = 0xcea33e
    HPS = 0xc29790
    SHPS = 0xa9c6c6
    MHN = 0xb07a49
    MHWWD = 0xbfa5b7
    MHSc = 0xadb1b9
    MHD = 0xbda4b7
    FeCo = 0x6ab1c3
    GaPb = 0xa08690
    BLAU = 0x7e7bbc
    PLANTA = 0xc194b0
    GRUN = 0x788a36
    LEDB = 0x0069f6
    RedLaser = 0x960100
    GreenLaser = 0x008500
    XeI = 0x9ba587
    Rb = 0x78666d
    Cd = 0x00568f
    Zn = 0x523075
    Ne = 0xd26000
    NeKrFL = 0xa0c43b
    NeXeFL1 = 0x6ad04b
    NeXeFL2 = 0x7767a3
    Ar = 0xb795ca
    HPMFL2Glow = 0xb0581f
    Butane = 0x628a86
    Alcohol = 0x94ce54
    BLP = 0x0080d7
    BLNG = 0x00647a
    TV = 0x94a791
    Xe = 0x87b785
    CarbonArc = 0xc0b6b8
    HPX = 0x9dbdd4
    LPM2 = 0x3a2c4a
    FLBLB = 0x2c008a
    FLBL = 0x402d67
    UVA = 0x97cf5f
    HPMFLCobaltGlass = 0x5f89d7
    CobaltGlass = 0x478cde
    HPMFLCL42053 = 0x00abd0
    CL42053 = 0x00b9d5
    HPMFLRedGlass = 0xe67c00
    RedGlass = 0xe36400
    OliveOil = 0xc3bd00


#/***************************************************************************
# *   Spectral data Copyright (c) 1998-2009 by I.N. Galidakis               *
# *                                                                         *
# *   Extracted from page:                                                  *
# *   <http://ioannis.virtualcomposer2000.com/spectroscope/amici.html>      *
# *                                                                         *
# *   This data is distributed in the hope that it will be useful,          *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   CCL 3.0 Creative Commons License 3.0 for more details.                *
# *                                                                         *
# *   You should have received a copy of the CCL 3.0                        *
# *   along with this program.  If not, see:                                *
# *   <http://creativecommons.org/licenses/by/3.0/>.                        *
# ***************************************************************************/  

# Adapted/Generated by Radiance for LuxRender
# Adapted by Doug Hammond for Blendigo
class lampspectrum_data_interpolated(object):
    # start_wavelenth = 4e-7
    # end_wavelength = 7e-7
    # num_values = 300
    Alcohol = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000148992, 0.00113196, 0.000333238, 0.000395889, 0.00327719, 0.00692417, 0.0126196, 0.0288224, 0.110521, 0.22054, 0.255674, 0.231915, 0.148617, 0.0603034, 0.0438392, 0.0614296, 0.0861301, 0.0767062, 0.0588304, 0.0371905, 0.0407541, 0.0435789, 0.0301176, 0.0474285, 0.0561338, 0.0510432, 0.0497891, 0.0571668, 0.079659, 0.0671215, 0.0669046, 0.0694218, 0.0799052, 0.0923642, 0.103113, 0.104165, 0.109621, 0.110088, 0.0994557, 0.0922567, 0.090867, 0.109412, 0.115291, 0.127334, 0.156897, 0.170013, 0.217699, 0.251105, 0.261108, 0.268766, 0.279704, 0.279505, 0.291511, 0.272436, 0.230614, 0.213944, 0.205018, 0.202899, 0.189267, 0.187955, 0.199942, 0.208799, 0.221325, 0.233089, 0.241878, 0.258322, 0.249011, 0.232337, 0.223244, 0.21849, 0.218751, 0.222437, 0.227822, 0.227306, 0.229517, 0.239889, 0.251991, 0.270043, 0.295889, 0.317693, 0.335881, 0.353748, 0.378312, 0.415258, 0.457789, 0.496519, 0.539762, 0.601336, 0.667487, 0.7251, 0.777351, 0.823802, 0.845327, 0.845449, 0.827599, 0.798373, 0.763884, 0.715542, 0.663425, 0.613197, 0.575222, 0.553161, 0.544775, 0.551685, 0.561361, 0.570057, 0.576925, 0.584672, 0.591611, 0.596657, 0.600379, 0.604745, 0.608052, 0.610703, 0.612535, 0.610822, 0.609334, 0.609124, 0.612506, 0.617074, 0.621151, 0.623738, 0.627229, 0.630843, 0.634432, 0.633872, 0.632199, 0.629638, 0.631067, 0.6325, 0.629401, 0.624061, 0.617322, 0.612757, 0.609367, 0.607935, 0.602415, 0.595232, 0.586074, 0.571728, 0.548278, 0.527368, 0.507826, 0.476513, 0.447207, 0.434228, 0.423397, 0.416055, 0.400437, 0.378828, 0.365159, 0.354053, 0.354093, 0.35543, 0.361216, 0.368726, 0.386393, 0.407398, 0.439769, 0.47464, 0.515818, 0.557625, 0.600787, 0.645988, 0.695443, 0.728921, 0.726164, 0.722562, 0.716587, 0.711728, 0.711536, 0.712105, 0.719754, 0.727403, 0.72414, 0.720586, 0.674481, 0.619287, 0.566917, 0.516093, 0.487593, 0.48739, 0.486554, 0.483286, 0.480019, 0.476771, 0.473525, 0.461629, 0.445138, 0.429258, 0.414602, 0.399947, 0.387223, 0.374533, 0.363793, 0.354343, 0.345387, 0.33851, 0.331634, 0.325873, 0.320483, 0.314224, 0.305711, 0.297198, 0.2853, 0.272413, 0.260003, 0.249118, 0.238233, 0.229914, 0.222859, 0.215699, 0.207128, 0.198557, 0.189633, 0.180249, 0.170865, 0.162839, 0.155226, 0.147503, 0.138223, 0.128943, 0.118742, 0.106672, 0.0946019, 0.0832909, 0.0725763, 0.0618616, 0.052485, 0.043545, 0.0346049, 0.0290923, 0.0239021, 0.0187475, 0.014519, 0.0102904, 0.00646153, 0.00545601, 0.00445048, 0.00363455, 0.00371871, 0.00380287, 0.00397389, 0.00452254, 0.0050712, 0.00557324, 0.00583595, 0.00609866, 0.00630536, 0.00601353, 0.00572169, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    AntiInsect = [0, 0, 0, 0, 0, 0.00471522, 0.00382794, 0.0031904, 0.00326797, 0.00524779, 0.00377074, 0.00460461, 0.00384188, 0.00389453, 0.00381586, 0.00421169, 0.00500538, 0.00344097, 0.00497922, 0.00453677, 0.00484857, 0.00592579, 0.00462664, 0.00475084, 0.00487682, 0.00468432, 0.00428, 0.00507419, 0.00537174, 0.00518558, 0.00662966, 0.00512945, 0.0045218, 0.00634855, 0.00638667, 0.00481938, 0.00540026, 0.00659261, 0.00730708, 0.00928401, 0.0107841, 0.0104383, 0.0113808, 0.0113963, 0.0131353, 0.0143643, 0.0135647, 0.0146859, 0.015595, 0.0167641, 0.0173208, 0.0207693, 0.0205368, 0.0221494, 0.0253552, 0.0255277, 0.0299496, 0.0299811, 0.0326514, 0.0354345, 0.0388821, 0.0423529, 0.0462755, 0.0505448, 0.0545083, 0.05603, 0.0596986, 0.0613826, 0.0630922, 0.0682071, 0.0737778, 0.0746914, 0.0771391, 0.0757438, 0.0791307, 0.0877773, 0.0910227, 0.098199, 0.105175, 0.110606, 0.109803, 0.115801, 0.118812, 0.116463, 0.119777, 0.125559, 0.125527, 0.129706, 0.132508, 0.13496, 0.135859, 0.137681, 0.1406, 0.143693, 0.150862, 0.152477, 0.147487, 0.149951, 0.154346, 0.157604, 0.160661, 0.168178, 0.182122, 0.199337, 0.217458, 0.235683, 0.255579, 0.273959, 0.293395, 0.315202, 0.336312, 0.353224, 0.370128, 0.386867, 0.399621, 0.415176, 0.431415, 0.448109, 0.462567, 0.474463, 0.485379, 0.491535, 0.498198, 0.505209, 0.511341, 0.512607, 0.514915, 0.518545, 0.521109, 0.515596, 0.513219, 0.509792, 0.504632, 0.500847, 0.498747, 0.496678, 0.492145, 0.483255, 0.474099, 0.466474, 0.464615, 0.461672, 0.455392, 0.4545, 0.454637, 0.455059, 0.454361, 0.453377, 0.452555, 0.451451, 0.450181, 0.451168, 0.452391, 0.454006, 0.454603, 0.454841, 0.455554, 0.458139, 0.464009, 0.467496, 0.4697, 0.467001, 0.464012, 0.461863, 0.458087, 0.451666, 0.444733, 0.437428, 0.432806, 0.42905, 0.424871, 0.420719, 0.418277, 0.415649, 0.411927, 0.409655, 0.41232, 0.415774, 0.421219, 0.425977, 0.429256, 0.432781, 0.436817, 0.442073, 0.450095, 0.457503, 0.463186, 0.469523, 0.47859, 0.487149, 0.490986, 0.494822, 0.503395, 0.512094, 0.519712, 0.527098, 0.532747, 0.537444, 0.541311, 0.544124, 0.547114, 0.550781, 0.554448, 0.558568, 0.562714, 0.566148, 0.569204, 0.571242, 0.571242, 0.571242, 0.575061, 0.578946, 0.582916, 0.586943, 0.590457, 0.591816, 0.593174, 0.595467, 0.59807, 0.600229, 0.601233, 0.602236, 0.603, 0.603694, 0.604013, 0.603132, 0.602251, 0.601416, 0.600605, 0.59972, 0.597849, 0.595979, 0.594635, 0.593975, 0.593316, 0.594233, 0.595629, 0.597026, 0.598441, 0.599856, 0.600169, 0.598245, 0.596321, 0.596127, 0.597292, 0.598456, 0.598596, 0.598401, 0.598207, 0.595315, 0.592169, 0.588837, 0.580656, 0.572475, 0.563306, 0.547149, 0.530992, 0.514455, 0.496108, 0.477762, 0.457965, 0.431862, 0.40576, 0.380773, 0.361512, 0.342252, 0.323123, 0.305159, 0.287195, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Ar = [0, 0, 0, 0, 0, 0.590512, 0.524582, 0.282102, 0.265007, 0.299452, 0.458065, 0.562595, 0.544479, 0.569034, 0.552176, 0.560435, 0.594407, 0.653275, 0.586281, 0.561858, 0.605155, 0.617332, 0.603057, 0.622009, 0.660688, 0.647402, 0.602312, 0.619327, 0.636572, 0.633984, 0.629821, 0.668741, 0.717709, 0.564615, 0.534327, 0.581696, 0.539603, 0.530238, 0.573238, 0.562515, 0.589552, 0.593955, 0.539124, 0.550091, 0.581589, 0.633758, 0.666216, 0.589194, 0.581787, 0.59813, 0.573389, 0.635168, 0.680837, 0.654941, 0.681412, 0.667992, 0.633944, 0.633554, 0.671865, 0.623541, 0.629086, 0.634783, 0.659747, 0.708389, 0.597432, 0.52009, 0.581884, 0.581993, 0.585241, 0.632074, 0.576206, 0.531137, 0.641245, 0.63315, 0.493438, 0.536038, 0.628259, 0.561121, 0.352878, 0.421752, 0.499123, 0.476751, 0.557049, 0.606641, 0.544675, 0.5114, 0.469814, 0.348369, 0.270664, 0.310194, 0.394527, 0.375682, 0.274672, 0.263285, 0.331005, 0.370434, 0.317015, 0.246401, 0.246898, 0.286427, 0.277907, 0.234946, 0.196791, 0.172537, 0.177275, 0.215904, 0.273741, 0.313397, 0.319098, 0.317919, 0.311525, 0.282913, 0.256631, 0.24768, 0.245004, 0.229996, 0.23084, 0.245588, 0.262999, 0.282463, 0.311503, 0.322702, 0.300145, 0.265134, 0.232638, 0.220251, 0.230005, 0.243774, 0.256831, 0.264636, 0.274468, 0.286534, 0.300907, 0.31769, 0.326372, 0.328471, 0.322579, 0.322082, 0.320259, 0.313383, 0.290878, 0.272933, 0.266785, 0.281051, 0.296806, 0.308638, 0.302637, 0.290709, 0.275975, 0.258679, 0.239734, 0.212653, 0.191088, 0.178716, 0.169708, 0.162366, 0.16186, 0.167345, 0.18334, 0.20754, 0.236158, 0.240135, 0.24219, 0.246036, 0.25718, 0.280183, 0.310931, 0.347288, 0.388303, 0.430822, 0.441583, 0.449416, 0.463431, 0.476658, 0.485229, 0.494181, 0.504428, 0.512426, 0.514751, 0.516676, 0.517735, 0.516038, 0.508589, 0.505437, 0.512032, 0.521301, 0.53806, 0.553195, 0.561542, 0.56732, 0.54918, 0.53104, 0.511231, 0.491378, 0.479496, 0.469316, 0.458715, 0.447884, 0.437294, 0.42701, 0.417129, 0.408794, 0.400458, 0.394092, 0.38784, 0.385586, 0.385457, 0.38604, 0.388051, 0.390062, 0.397381, 0.404792, 0.411246, 0.417067, 0.422695, 0.427513, 0.432331, 0.438782, 0.445779, 0.452242, 0.457322, 0.462402, 0.465238, 0.467418, 0.468115, 0.464063, 0.46001, 0.455474, 0.450699, 0.446212, 0.445601, 0.444991, 0.44399, 0.442483, 0.440975, 0.43704, 0.432368, 0.427649, 0.422265, 0.41688, 0.408014, 0.392078, 0.376142, 0.36012, 0.34403, 0.32794, 0.302144, 0.273182, 0.24422, 0.221109, 0.198549, 0.176005, 0.153895, 0.131786, 0.110729, 0.0971123, 0.0834952, 0.0710232, 0.0639875, 0.0569518, 0.0508463, 0.0487847, 0.0467231, 0.0452009, 0.0464488, 0.0476967, 0.0492557, 0.0535846, 0.0579135, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    BLAU = [0, 0, 0, 0, 0, 0.0528622, 0.302736, 0.131282, 0.211714, 0.382929, 0.533452, 0.584899, 0.586173, 0.586094, 0.526932, 0.419514, 0.337265, 0.287206, 0.264342, 0.255357, 0.247308, 0.239914, 0.242909, 0.24861, 0.250461, 0.26116, 0.262957, 0.269992, 0.277047, 0.291621, 0.305837, 0.32098, 0.327207, 0.37121, 0.426167, 0.489798, 0.583108, 0.6259, 0.520958, 0.523373, 0.527641, 0.533261, 0.538429, 0.545946, 0.557381, 0.565923, 0.578556, 0.588567, 0.603166, 0.598944, 0.619578, 0.625848, 0.658867, 0.664432, 0.70111, 0.69381, 0.742214, 0.702809, 0.65205, 0.612767, 0.591933, 0.576089, 0.570516, 0.565924, 0.560654, 0.554056, 0.546006, 0.538743, 0.523795, 0.500426, 0.471398, 0.458017, 0.445202, 0.425199, 0.407339, 0.399308, 0.387407, 0.378153, 0.367509, 0.363117, 0.358567, 0.347664, 0.340809, 0.334193, 0.32751, 0.317497, 0.314083, 0.304974, 0.29676, 0.28465, 0.272139, 0.270504, 0.26594, 0.256534, 0.257257, 0.25532, 0.253903, 0.25176, 0.249587, 0.245357, 0.229694, 0.209528, 0.196618, 0.191302, 0.189625, 0.190706, 0.194421, 0.19752, 0.20165, 0.20744, 0.216011, 0.223419, 0.23274, 0.244586, 0.25636, 0.27141, 0.285176, 0.299528, 0.311469, 0.320768, 0.329199, 0.321018, 0.294734, 0.266699, 0.24419, 0.227048, 0.20672, 0.191141, 0.181029, 0.175221, 0.177023, 0.178614, 0.178517, 0.180267, 0.180207, 0.178001, 0.171934, 0.168, 0.167237, 0.171527, 0.169067, 0.168471, 0.172791, 0.245159, 0.350786, 0.502102, 0.456786, 0.349417, 0.223947, 0.169241, 0.159047, 0.153526, 0.148372, 0.143832, 0.139727, 0.135683, 0.129856, 0.125633, 0.124224, 0.122468, 0.120525, 0.117793, 0.115021, 0.11242, 0.111479, 0.113238, 0.116423, 0.12064, 0.129962, 0.140933, 0.150851, 0.159602, 0.142161, 0.131819, 0.163326, 0.209944, 0.308013, 0.387108, 0.418368, 0.412497, 0.326626, 0.259189, 0.230214, 0.213796, 0.225854, 0.247408, 0.295571, 0.349337, 0.426527, 0.490748, 0.434244, 0.377739, 0.325137, 0.272639, 0.259747, 0.255315, 0.251625, 0.248341, 0.245464, 0.243101, 0.239989, 0.23401, 0.228031, 0.226376, 0.224972, 0.220989, 0.215636, 0.210769, 0.206876, 0.202982, 0.198557, 0.194123, 0.190009, 0.186108, 0.182268, 0.178686, 0.175104, 0.171737, 0.168442, 0.165125, 0.161752, 0.158379, 0.155208, 0.152095, 0.148894, 0.145409, 0.141924, 0.139026, 0.136416, 0.133768, 0.1306, 0.127431, 0.124567, 0.122099, 0.11963, 0.117242, 0.114878, 0.112415, 0.108556, 0.104697, 0.100854, 0.0970424, 0.0932307, 0.0899381, 0.0870534, 0.0841686, 0.0806292, 0.0768762, 0.0731232, 0.0706122, 0.068218, 0.0658065, 0.0629414, 0.0600764, 0.0573088, 0.0552296, 0.0531503, 0.0509087, 0.0478958, 0.0448829, 0.0417619, 0.0381707, 0.0345795, 0.0313864, 0.030237, 0.0290876, 0.0280608, 0.0281257, 0.0281905, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    BLNG = [0, 0, 0, 0, 0, 0.1331, 0.276342, 0.103404, 0.182252, 0.111067, 0.126585, 0.139286, 0.160494, 0.173467, 0.178195, 0.184382, 0.192175, 0.198969, 0.204049, 0.210216, 0.215079, 0.22165, 0.225952, 0.232426, 0.238929, 0.243994, 0.247987, 0.254154, 0.259516, 0.257759, 0.263639, 0.27069, 0.255647, 0.261931, 0.313735, 0.400186, 0.516504, 0.735806, 0.426523, 0.249023, 0.213961, 0.20021, 0.201768, 0.179043, 0.178785, 0.16837, 0.157765, 0.155317, 0.150196, 0.146669, 0.143967, 0.139195, 0.13649, 0.134072, 0.132068, 0.131089, 0.124852, 0.124258, 0.123145, 0.118935, 0.116382, 0.113772, 0.109905, 0.109775, 0.109829, 0.109353, 0.110893, 0.113196, 0.119525, 0.123925, 0.128575, 0.133349, 0.141904, 0.151149, 0.16289, 0.171816, 0.184376, 0.199891, 0.216212, 0.231917, 0.238464, 0.243671, 0.25646, 0.269058, 0.280912, 0.284217, 0.287009, 0.283656, 0.279746, 0.275811, 0.272609, 0.268153, 0.263226, 0.263856, 0.262017, 0.252336, 0.241003, 0.23759, 0.230606, 0.228808, 0.235636, 0.24352, 0.250476, 0.256856, 0.262384, 0.266392, 0.270038, 0.276071, 0.281413, 0.285076, 0.284712, 0.286724, 0.289491, 0.290699, 0.290236, 0.287082, 0.284124, 0.280683, 0.277823, 0.275454, 0.272522, 0.269543, 0.265103, 0.259243, 0.251941, 0.242852, 0.234617, 0.226253, 0.216859, 0.204243, 0.192793, 0.182285, 0.17236, 0.159612, 0.149448, 0.140078, 0.129235, 0.11866, 0.108076, 0.0973537, 0.0886141, 0.0807563, 0.0738777, 0.0696931, 0.0649887, 0.0582787, 0.0539366, 0.0502889, 0.0466525, 0.0418147, 0.0362252, 0.0313826, 0.0269391, 0.0231607, 0.0200494, 0.0172282, 0.0150578, 0.0127803, 0.0103149, 0.00945199, 0.00945199, 0.00903261, 0.00857562, 0.00812319, 0.00784314, 0.00784314, 0.00758735, 0.00714632, 0.00670945, 0.00627392, 0.00623429, 0.00610592, 0.00281432, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.00220757, 0.00558824, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    BLP = [0, 0, 0, 0, 0, 0.00896356, 0.161349, 0.037752, 0.0717949, 0.132939, 0.224915, 0.323814, 0.435023, 0.501862, 0.523161, 0.538504, 0.548065, 0.560731, 0.576208, 0.587221, 0.600107, 0.607147, 0.6104, 0.613316, 0.613883, 0.616296, 0.617768, 0.622966, 0.623264, 0.626679, 0.630969, 0.63353, 0.634679, 0.642318, 0.645515, 0.650502, 0.714288, 0.705379, 0.68312, 0.699872, 0.71646, 0.729658, 0.745403, 0.756226, 0.761446, 0.75001, 0.727413, 0.711795, 0.690523, 0.671883, 0.657532, 0.649854, 0.642033, 0.631468, 0.622615, 0.616553, 0.608638, 0.61251, 0.613501, 0.613039, 0.609856, 0.604705, 0.599317, 0.591501, 0.587548, 0.583855, 0.585377, 0.580934, 0.58094, 0.590847, 0.596196, 0.597316, 0.600981, 0.605283, 0.606764, 0.607377, 0.607326, 0.607802, 0.608739, 0.608396, 0.607891, 0.607168, 0.608152, 0.608466, 0.609426, 0.605203, 0.600929, 0.596731, 0.592781, 0.589718, 0.586462, 0.583333, 0.580611, 0.579286, 0.577436, 0.566097, 0.559058, 0.548686, 0.53285, 0.512316, 0.490865, 0.46959, 0.451261, 0.43959, 0.433946, 0.43247, 0.428411, 0.422374, 0.416224, 0.409351, 0.399733, 0.395399, 0.392446, 0.389341, 0.387914, 0.378204, 0.373503, 0.37174, 0.371761, 0.371868, 0.370078, 0.365908, 0.356383, 0.348062, 0.342243, 0.333461, 0.325398, 0.317572, 0.309365, 0.299228, 0.290419, 0.282617, 0.275358, 0.264325, 0.257611, 0.252123, 0.24386, 0.23418, 0.224183, 0.214243, 0.204559, 0.19435, 0.183184, 0.173073, 0.162583, 0.150946, 0.14083, 0.131236, 0.121939, 0.112883, 0.103979, 0.0954664, 0.088786, 0.08516, 0.0833122, 0.0825104, 0.0882189, 0.096607, 0.109697, 0.112733, 0.110356, 0.108033, 0.105341, 0.100676, 0.0972454, 0.0958217, 0.0917385, 0.0857297, 0.0807651, 0.0761376, 0.0707553, 0.0653364, 0.0608768, 0.0563455, 0.0513913, 0.0468039, 0.043466, 0.0396242, 0.0345121, 0.0304288, 0.0285621, 0.0265818, 0.0243644, 0.0221328, 0.0198687, 0.0176891, 0.015746, 0.0141502, 0.0140063, 0.0138763, 0.0138763, 0.0138763, 0.0125097, 0.0111066, 0.00971845, 0.00833343, 0.00784314, 0.00784314, 0.00724765, 0.00589734, 0.0045505, 0.0032169, 0.0018833, 0.00180995, 0.00180995, 0.00130051, 0.000520361, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.0020823, 0.00484397, 0.00760564, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Butane = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000804424, 0.000804424, 0.000804424, 0.00351936, 0.0073693, 0.0105892, 0.013783, 0.0208232, 0.0322643, 0.0538168, 0.0820095, 0.109051, 0.150114, 0.2213, 0.308365, 0.436856, 0.499978, 0.509013, 0.465942, 0.376992, 0.268412, 0.256185, 0.285544, 0.297831, 0.279074, 0.240808, 0.189338, 0.144779, 0.11953, 0.109327, 0.107243, 0.107691, 0.107344, 0.110271, 0.113344, 0.116861, 0.120388, 0.123822, 0.125708, 0.128914, 0.135387, 0.140307, 0.144185, 0.147019, 0.159246, 0.168686, 0.18232, 0.211547, 0.257154, 0.309858, 0.3765, 0.433901, 0.482229, 0.515686, 0.533454, 0.53362, 0.532198, 0.534719, 0.534457, 0.519812, 0.474165, 0.410975, 0.332981, 0.268668, 0.203447, 0.165209, 0.160439, 0.165701, 0.164083, 0.160853, 0.164176, 0.162669, 0.161291, 0.152409, 0.14929, 0.140134, 0.134616, 0.12948, 0.123576, 0.117095, 0.116082, 0.121536, 0.1266, 0.138186, 0.152922, 0.168281, 0.185682, 0.202312, 0.220906, 0.24561, 0.272082, 0.301181, 0.33297, 0.35982, 0.390535, 0.420393, 0.454465, 0.48763, 0.506439, 0.511006, 0.506331, 0.496636, 0.481234, 0.448655, 0.433832, 0.407328, 0.335234, 0.235131, 0.164542, 0.167877, 0.170615, 0.172187, 0.173074, 0.175682, 0.177173, 0.178716, 0.180554, 0.182848, 0.187372, 0.191097, 0.193784, 0.200461, 0.207629, 0.215504, 0.224813, 0.231379, 0.236907, 0.24174, 0.249522, 0.258215, 0.267685, 0.277134, 0.285669, 0.292314, 0.297286, 0.301674, 0.30569, 0.310003, 0.314498, 0.318044, 0.320821, 0.322314, 0.322289, 0.321727, 0.321876, 0.318285, 0.308129, 0.296396, 0.283812, 0.271642, 0.259159, 0.244822, 0.228205, 0.207882, 0.177044, 0.138593, 0.114538, 0.0951297, 0.0866427, 0.0794371, 0.0768622, 0.0766219, 0.0901476, 0.10438, 0.121018, 0.137853, 0.155183, 0.172913, 0.191504, 0.208601, 0.222578, 0.23477, 0.242916, 0.250369, 0.255883, 0.261999, 0.270634, 0.278468, 0.278847, 0.279226, 0.278871, 0.278497, 0.277518, 0.27641, 0.275326, 0.274254, 0.272613, 0.27025, 0.267631, 0.26403, 0.260429, 0.25623, 0.251997, 0.245236, 0.237131, 0.229146, 0.221401, 0.213656, 0.205533, 0.197403, 0.188391, 0.178795, 0.169369, 0.16066, 0.151951, 0.142818, 0.133544, 0.125319, 0.119817, 0.114315, 0.108423, 0.102415, 0.0958764, 0.087634, 0.0793917, 0.0744053, 0.0710226, 0.0677021, 0.0652207, 0.0627394, 0.0597799, 0.0561995, 0.0526191, 0.0503286, 0.04843, 0.0464953, 0.0440513, 0.0416074, 0.0395806, 0.0384008, 0.037221, 0.035839, 0.0342981, 0.0327572, 0.0307763, 0.028652, 0.0265276, 0.0249234, 0.0233681, 0.0218652, 0.0217271, 0.021589, 0.0213498, 0.0203953, 0.0194409, 0.0187346, 0.0192059, 0.0196772, 0.0200758, 0.020159, 0.0202421, 0.0205472, 0.0219922, 0.0234371, 0.0247426, 0.0248075, 0.0248723, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    CFL27K = [0, 0, 0, 0, 0, 0.073454, 0.597417, 0.129677, 0.284213, 0.0834154, 0.0523075, 0.0762931, 0.0875119, 0.0961314, 0.111007, 0.133904, 0.160329, 0.135209, 0.112993, 0.12031, 0.131879, 0.0912573, 0.0760668, 0.0694936, 0.0766821, 0.101061, 0.128462, 0.157865, 0.128988, 0.129443, 0.162581, 0.168686, 0.190544, 0.301382, 0.439972, 0.510719, 0.917045, 0.897081, 0.448866, 0.31777, 0.23588, 0.165363, 0.123076, 0.0995245, 0.0871269, 0.0707897, 0.0634059, 0.0606829, 0.058502, 0.0542228, 0.050801, 0.0507944, 0.0488362, 0.0486111, 0.0476893, 0.046746, 0.0414228, 0.0403735, 0.0391834, 0.0359966, 0.032209, 0.0305879, 0.0308233, 0.036101, 0.0484803, 0.0631637, 0.0779307, 0.0845667, 0.0835259, 0.0642556, 0.0445979, 0.0484738, 0.0595352, 0.0671689, 0.0678749, 0.0606911, 0.0567817, 0.0687916, 0.0976934, 0.144237, 0.206792, 0.29767, 0.393542, 0.453883, 0.518705, 0.560183, 0.573634, 0.616401, 0.624291, 0.614554, 0.589153, 0.562672, 0.562623, 0.558166, 0.529032, 0.492235, 0.449898, 0.403524, 0.354934, 0.312091, 0.280261, 0.250142, 0.219171, 0.188407, 0.157446, 0.130499, 0.104654, 0.0874878, 0.0840762, 0.0860649, 0.0819012, 0.0721859, 0.0660133, 0.0638962, 0.0586491, 0.0530161, 0.0487129, 0.0454234, 0.0430071, 0.0415732, 0.0413817, 0.0415406, 0.0397904, 0.0388403, 0.0413544, 0.0525524, 0.059046, 0.0712477, 0.08846, 0.104257, 0.121019, 0.156188, 0.2149, 0.307955, 0.3263, 0.313478, 0.318011, 0.367467, 0.416413, 0.443373, 0.494715, 0.546078, 0.591138, 0.570438, 0.555599, 0.575535, 0.590029, 0.588251, 0.529185, 0.485933, 0.452727, 0.439833, 0.423799, 0.402531, 0.371771, 0.337054, 0.296083, 0.260364, 0.233861, 0.211393, 0.191097, 0.176129, 0.162163, 0.150908, 0.137762, 0.121543, 0.111869, 0.106936, 0.102624, 0.0985139, 0.0924455, 0.0863157, 0.0835018, 0.0801686, 0.0737727, 0.0855806, 0.159378, 0.244788, 0.359476, 0.43325, 0.41887, 0.409158, 0.409183, 0.412822, 0.42466, 0.437504, 0.45317, 0.473488, 0.513258, 0.544151, 0.492406, 0.440661, 0.459041, 0.479292, 0.508572, 0.539781, 0.525789, 0.487028, 0.472863, 0.489876, 0.510113, 0.542697, 0.575282, 0.521665, 0.463031, 0.428788, 0.407507, 0.392829, 0.391374, 0.389919, 0.431885, 0.474602, 0.526278, 0.583877, 0.626045, 0.603274, 0.580504, 0.542137, 0.498573, 0.466572, 0.464604, 0.462637, 0.467286, 0.473869, 0.480412, 0.486834, 0.493256, 0.492668, 0.488628, 0.485407, 0.493233, 0.501058, 0.494389, 0.468893, 0.443397, 0.3892, 0.326284, 0.265747, 0.238863, 0.211979, 0.190996, 0.181994, 0.172991, 0.16608, 0.160812, 0.155544, 0.156304, 0.15903, 0.161757, 0.164674, 0.16761, 0.170376, 0.168719, 0.167062, 0.164028, 0.151263, 0.138498, 0.125134, 0.108925, 0.0927155, 0.0787074, 0.0742683, 0.0698292, 0.0660575, 0.0657127, 0.0653678, 0.0649907, 0.0643259, 0.0636612, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    CFL4K = [0, 0, 0, 0, 0, 0.204934, 0.660031, 0.224523, 0.409402, 0.214674, 0.240844, 0.269762, 0.289501, 0.327425, 0.362444, 0.37126, 0.389774, 0.425601, 0.451295, 0.484043, 0.497485, 0.513853, 0.529567, 0.538931, 0.546245, 0.552682, 0.556879, 0.566937, 0.567657, 0.570921, 0.578895, 0.587732, 0.593816, 0.592737, 0.60646, 0.586863, 0.705368, 0.68675, 0.564266, 0.611795, 0.614837, 0.613986, 0.618893, 0.618973, 0.618818, 0.620881, 0.62438, 0.625811, 0.625487, 0.624709, 0.623076, 0.620487, 0.618172, 0.617508, 0.616035, 0.613679, 0.612886, 0.610652, 0.607305, 0.605694, 0.601324, 0.596548, 0.599103, 0.596753, 0.593705, 0.591124, 0.588271, 0.591206, 0.595441, 0.594619, 0.59367, 0.590235, 0.579513, 0.56118, 0.538775, 0.518396, 0.493533, 0.473286, 0.457391, 0.450952, 0.454766, 0.47294, 0.509885, 0.527097, 0.52106, 0.581906, 0.600597, 0.608761, 0.605346, 0.60904, 0.612526, 0.604302, 0.593162, 0.589715, 0.587794, 0.56908, 0.562224, 0.568917, 0.571597, 0.555123, 0.509535, 0.444581, 0.378937, 0.324467, 0.282151, 0.24986, 0.232405, 0.227698, 0.227608, 0.230846, 0.228946, 0.22668, 0.228461, 0.232687, 0.234111, 0.23222, 0.230626, 0.228393, 0.225859, 0.222966, 0.219332, 0.216432, 0.211683, 0.209159, 0.209275, 0.207473, 0.210804, 0.21642, 0.221936, 0.222009, 0.227327, 0.240348, 0.263293, 0.313497, 0.335739, 0.343652, 0.349858, 0.389544, 0.437465, 0.485426, 0.524381, 0.575186, 0.648424, 0.675313, 0.685894, 0.678536, 0.660787, 0.631277, 0.56772, 0.524347, 0.493776, 0.485819, 0.479565, 0.476152, 0.4546, 0.424708, 0.369258, 0.322644, 0.291532, 0.271898, 0.258445, 0.243974, 0.229423, 0.214945, 0.200931, 0.187671, 0.177785, 0.170343, 0.16791, 0.167093, 0.168045, 0.169245, 0.172192, 0.174669, 0.174381, 0.186511, 0.240927, 0.302203, 0.380775, 0.432745, 0.427396, 0.420592, 0.410751, 0.407084, 0.41742, 0.426744, 0.433229, 0.443795, 0.471428, 0.495259, 0.483702, 0.472145, 0.478405, 0.48514, 0.499621, 0.515756, 0.509537, 0.491068, 0.487423, 0.502569, 0.520028, 0.546344, 0.572661, 0.52585, 0.474784, 0.441979, 0.418878, 0.403106, 0.402015, 0.400924, 0.44877, 0.497463, 0.553226, 0.613662, 0.65715, 0.629314, 0.601479, 0.56778, 0.532127, 0.513563, 0.539384, 0.565205, 0.574232, 0.578356, 0.578931, 0.568143, 0.557356, 0.542309, 0.525163, 0.510432, 0.528279, 0.546126, 0.548955, 0.532278, 0.515601, 0.464844, 0.403734, 0.344652, 0.314277, 0.283901, 0.260627, 0.25177, 0.242912, 0.236507, 0.232027, 0.227548, 0.228542, 0.231321, 0.2341, 0.238955, 0.244005, 0.248625, 0.242032, 0.235439, 0.227228, 0.207595, 0.187962, 0.168781, 0.151747, 0.134713, 0.120159, 0.116385, 0.112611, 0.108791, 0.104735, 0.10068, 0.0963869, 0.0899828, 0.0835786, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    CFL6K = [0, 0, 0, 0, 0, 0.491381, 0.388524, 0.483754, 0.43806, 0.420246, 0.500485, 0.549546, 0.542383, 0.553252, 0.561655, 0.566935, 0.580241, 0.586082, 0.594696, 0.602631, 0.613184, 0.616665, 0.617784, 0.617245, 0.617401, 0.619738, 0.621444, 0.623379, 0.62645, 0.630392, 0.638492, 0.646177, 0.661536, 0.69949, 0.769978, 0.964605, 0.98403, 0.922819, 0.741387, 0.755813, 0.763484, 0.777439, 0.790186, 0.796014, 0.79878, 0.779999, 0.758502, 0.74529, 0.727032, 0.71224, 0.69964, 0.692196, 0.683713, 0.668529, 0.652334, 0.640012, 0.626962, 0.619927, 0.620034, 0.618297, 0.614468, 0.613873, 0.612764, 0.610929, 0.610145, 0.611995, 0.615855, 0.615896, 0.613989, 0.61398, 0.613429, 0.613551, 0.613871, 0.61366, 0.612033, 0.609453, 0.606071, 0.605078, 0.607369, 0.611743, 0.611692, 0.61082, 0.630985, 0.653923, 0.671977, 0.677607, 0.67883, 0.673774, 0.662977, 0.652291, 0.643449, 0.639099, 0.634125, 0.630024, 0.624895, 0.61178, 0.601049, 0.593198, 0.578562, 0.555468, 0.519659, 0.466667, 0.416541, 0.382443, 0.359164, 0.345125, 0.328651, 0.320363, 0.315964, 0.310115, 0.30496, 0.30138, 0.295321, 0.288226, 0.284988, 0.278978, 0.27734, 0.274268, 0.270781, 0.267773, 0.265663, 0.265743, 0.268086, 0.276043, 0.286872, 0.286566, 0.297416, 0.317995, 0.340925, 0.3464, 0.351856, 0.368499, 0.39667, 0.411346, 0.416355, 0.419633, 0.432255, 0.468499, 0.517366, 0.57925, 0.66895, 0.750689, 0.811699, 0.807249, 0.797765, 0.800326, 0.788636, 0.761646, 0.691196, 0.63177, 0.579366, 0.545067, 0.512009, 0.481021, 0.463163, 0.449923, 0.430329, 0.410294, 0.389485, 0.373024, 0.358904, 0.343957, 0.329263, 0.316312, 0.303744, 0.291795, 0.278992, 0.265568, 0.253197, 0.241165, 0.231981, 0.22293, 0.210135, 0.196136, 0.175035, 0.175452, 0.249146, 0.337829, 0.464299, 0.537451, 0.495727, 0.453751, 0.411247, 0.38559, 0.398141, 0.411421, 0.426747, 0.444999, 0.475487, 0.501508, 0.485949, 0.47039, 0.468391, 0.466754, 0.491725, 0.52238, 0.52298, 0.507111, 0.497049, 0.494349, 0.498377, 0.528183, 0.557989, 0.532058, 0.502884, 0.470132, 0.435481, 0.410209, 0.403727, 0.397244, 0.417247, 0.437708, 0.490197, 0.56386, 0.621406, 0.611132, 0.600858, 0.558829, 0.506213, 0.474019, 0.49486, 0.515702, 0.523849, 0.52829, 0.533296, 0.540109, 0.546922, 0.54149, 0.530028, 0.519074, 0.514989, 0.510905, 0.503203, 0.490804, 0.478405, 0.440352, 0.394505, 0.348978, 0.307982, 0.266985, 0.233264, 0.214315, 0.195366, 0.183778, 0.177973, 0.172167, 0.170058, 0.169155, 0.168253, 0.165524, 0.162623, 0.159782, 0.158523, 0.157263, 0.155288, 0.148267, 0.141245, 0.131998, 0.112187, 0.0923759, 0.0726537, 0.0533179, 0.033982, 0.0171315, 0.013043, 0.00895456, 0.00537564, 0.00633221, 0.00728878, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    CL42053 = [0, 0, 0, 0, 0, 0.107304, 0.100705, 0.123749, 0.137707, 0.151288, 0.168305, 0.181914, 0.204454, 0.22403, 0.248452, 0.263473, 0.280753, 0.308719, 0.335408, 0.352896, 0.375209, 0.398542, 0.422718, 0.443503, 0.466162, 0.484834, 0.497954, 0.518312, 0.530088, 0.548521, 0.557225, 0.56148, 0.5668, 0.574339, 0.5801, 0.587918, 0.587031, 0.596665, 0.600129, 0.608555, 0.613091, 0.619846, 0.623796, 0.633947, 0.640399, 0.647606, 0.651883, 0.663351, 0.670545, 0.682549, 0.689249, 0.700243, 0.710389, 0.720057, 0.73066, 0.742761, 0.753161, 0.752586, 0.742561, 0.726209, 0.71017, 0.685583, 0.673866, 0.664575, 0.654989, 0.648684, 0.647462, 0.644681, 0.640511, 0.646593, 0.654222, 0.662018, 0.669034, 0.672848, 0.684143, 0.685771, 0.691303, 0.696725, 0.701076, 0.706296, 0.708294, 0.711539, 0.711829, 0.712047, 0.713046, 0.713223, 0.714279, 0.715049, 0.71743, 0.718171, 0.71944, 0.719944, 0.720682, 0.72175, 0.722329, 0.724731, 0.726043, 0.727668, 0.729414, 0.730866, 0.731747, 0.73421, 0.736446, 0.739168, 0.743401, 0.744689, 0.74824, 0.749752, 0.753792, 0.755585, 0.757461, 0.758234, 0.754101, 0.747004, 0.742546, 0.737838, 0.730421, 0.721101, 0.709459, 0.69625, 0.683182, 0.672499, 0.661113, 0.649731, 0.638579, 0.627342, 0.614771, 0.603365, 0.593095, 0.582811, 0.572467, 0.563951, 0.556855, 0.541929, 0.533717, 0.527888, 0.519206, 0.507645, 0.496296, 0.486697, 0.479476, 0.473697, 0.469743, 0.466958, 0.463039, 0.456361, 0.455447, 0.454724, 0.448178, 0.439071, 0.428374, 0.42171, 0.416141, 0.412393, 0.406825, 0.400505, 0.393102, 0.380811, 0.359944, 0.341049, 0.323218, 0.305573, 0.287372, 0.266136, 0.246439, 0.229243, 0.232684, 0.251069, 0.260268, 0.266502, 0.271175, 0.27539, 0.272178, 0.268698, 0.263639, 0.256515, 0.242361, 0.227944, 0.212864, 0.194911, 0.170769, 0.148419, 0.129809, 0.10937, 0.0847855, 0.0637028, 0.0524331, 0.0425468, 0.038445, 0.0345114, 0.0321432, 0.029775, 0.0271397, 0.0244973, 0.0226437, 0.0209585, 0.0200232, 0.0194988, 0.0192751, 0.0194327, 0.019806, 0.0210063, 0.0222065, 0.0233712, 0.0245338, 0.0248523, 0.0247222, 0.0244645, 0.0239511, 0.0234376, 0.0239478, 0.0244757, 0.0252761, 0.0262566, 0.0273532, 0.0289385, 0.0305238, 0.0327048, 0.0350843, 0.037288, 0.0390349, 0.0407817, 0.0425729, 0.044377, 0.0516554, 0.0764608, 0.101266, 0.125576, 0.149641, 0.174292, 0.206836, 0.23938, 0.271884, 0.304333, 0.336783, 0.368572, 0.40016, 0.431595, 0.460868, 0.49014, 0.517875, 0.542487, 0.567099, 0.584259, 0.595566, 0.606872, 0.609266, 0.608753, 0.608239, 0.604106, 0.599632, 0.595074, 0.588308, 0.581543, 0.574606, 0.566459, 0.558312, 0.549591, 0.538146, 0.5267, 0.51465, 0.49997, 0.485289, 0.47013, 0.452512, 0.434894, 0.418266, 0.410451, 0.402636, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Candle = [0, 0, 0, 0, 0, 0.0246499, 0.000179889, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000366749, 0.0036564, 0.00611629, 0.00820823, 0.0128301, 0.0292785, 0.0674878, 0.106419, 0.145235, 0.236555, 0.350991, 0.339678, 0.203184, 0.138182, 0.165797, 0.207491, 0.230825, 0.237443, 0.223732, 0.225987, 0.230615, 0.241041, 0.25518, 0.27207, 0.290056, 0.308537, 0.321269, 0.336016, 0.350145, 0.363004, 0.38082, 0.396775, 0.409732, 0.420518, 0.429253, 0.434582, 0.439402, 0.442798, 0.451034, 0.456098, 0.461621, 0.472558, 0.481918, 0.48315, 0.485785, 0.484126, 0.485506, 0.493553, 0.506468, 0.505091, 0.500613, 0.501753, 0.502615, 0.510921, 0.517196, 0.517221, 0.524989, 0.525978, 0.530009, 0.530856, 0.531916, 0.538559, 0.535012, 0.535282, 0.540881, 0.546512, 0.550561, 0.553069, 0.554602, 0.55509, 0.559022, 0.56321, 0.569842, 0.578282, 0.586499, 0.593752, 0.598984, 0.603071, 0.602711, 0.603934, 0.60348, 0.604593, 0.608369, 0.613775, 0.618598, 0.622029, 0.625788, 0.629503, 0.635863, 0.641521, 0.644035, 0.647519, 0.648074, 0.648729, 0.653577, 0.659257, 0.658642, 0.6557, 0.65378, 0.651622, 0.649648, 0.647914, 0.646152, 0.646072, 0.639675, 0.635183, 0.634531, 0.632, 0.629265, 0.62617, 0.622948, 0.620321, 0.616855, 0.61461, 0.613452, 0.606739, 0.604051, 0.602784, 0.599786, 0.596179, 0.592017, 0.587081, 0.582608, 0.577669, 0.571821, 0.566657, 0.560762, 0.553112, 0.545806, 0.538865, 0.532951, 0.525738, 0.517721, 0.512477, 0.50696, 0.500988, 0.499651, 0.499878, 0.496697, 0.494223, 0.492991, 0.49026, 0.486722, 0.482677, 0.478, 0.470223, 0.463464, 0.458355, 0.451317, 0.442883, 0.438829, 0.436188, 0.429227, 0.422085, 0.421156, 0.419533, 0.413819, 0.409079, 0.407655, 0.405997, 0.403748, 0.402092, 0.401714, 0.401757, 0.402678, 0.403416, 0.403736, 0.405237, 0.410045, 0.415968, 0.426546, 0.436444, 0.439996, 0.443548, 0.443094, 0.442533, 0.447627, 0.453928, 0.462007, 0.471059, 0.479146, 0.48601, 0.491803, 0.493492, 0.495181, 0.498176, 0.501247, 0.503176, 0.504498, 0.507197, 0.512652, 0.518107, 0.52148, 0.524816, 0.527576, 0.529954, 0.532405, 0.535163, 0.537922, 0.540626, 0.543311, 0.545506, 0.546429, 0.547352, 0.551167, 0.555826, 0.560508, 0.565266, 0.570024, 0.573821, 0.577146, 0.580265, 0.580608, 0.580952, 0.582203, 0.584635, 0.587066, 0.589816, 0.592664, 0.595336, 0.59552, 0.595704, 0.595396, 0.594089, 0.592782, 0.591996, 0.59162, 0.591244, 0.589122, 0.586431, 0.58374, 0.582838, 0.582105, 0.581344, 0.579894, 0.578444, 0.576844, 0.574186, 0.571527, 0.568458, 0.563443, 0.558427, 0.552997, 0.545764, 0.538532, 0.53122, 0.523503, 0.515786, 0.508348, 0.503387, 0.498425, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    CarbonArc = [0, 0, 0, 0, 0, 0.178783, 0.0782483, 0.0822764, 0.0919558, 0.0774508, 0.0860476, 0.0947088, 0.116177, 0.129407, 0.143172, 0.151446, 0.168275, 0.178835, 0.183073, 0.22643, 0.385001, 0.547228, 0.581553, 0.33199, 0.258346, 0.263091, 0.291779, 0.342719, 0.414971, 0.486458, 0.53467, 0.437318, 0.371271, 0.326507, 0.318851, 0.328854, 0.356142, 0.390079, 0.4448, 0.451445, 0.427103, 0.494247, 0.517554, 0.565193, 0.591411, 0.54726, 0.636894, 0.52054, 0.448422, 0.445195, 0.463741, 0.479991, 0.511129, 0.540396, 0.59952, 0.552065, 0.565386, 0.525835, 0.530736, 0.54418, 0.544431, 0.596947, 0.5886, 0.569458, 0.585185, 0.595536, 0.608326, 0.612675, 0.601945, 0.599818, 0.581154, 0.577287, 0.569626, 0.550479, 0.534024, 0.544506, 0.57141, 0.539516, 0.531373, 0.54042, 0.49379, 0.494254, 0.500636, 0.484062, 0.477403, 0.462837, 0.460432, 0.469931, 0.456796, 0.433392, 0.418304, 0.419562, 0.4228, 0.422817, 0.411918, 0.39313, 0.387699, 0.40062, 0.41126, 0.410026, 0.404597, 0.40401, 0.410095, 0.410671, 0.405475, 0.41127, 0.418579, 0.426739, 0.431902, 0.438506, 0.443597, 0.448261, 0.449976, 0.452418, 0.462274, 0.472405, 0.481114, 0.47883, 0.470922, 0.463388, 0.4613, 0.463723, 0.459505, 0.46396, 0.478439, 0.485112, 0.47274, 0.461777, 0.456979, 0.462528, 0.465713, 0.465644, 0.462703, 0.463453, 0.463606, 0.46338, 0.462892, 0.462353, 0.461944, 0.461808, 0.461761, 0.461703, 0.461603, 0.461674, 0.462088, 0.463157, 0.463325, 0.463216, 0.463058, 0.462958, 0.462896, 0.462896, 0.462919, 0.46298, 0.463106, 0.463253, 0.463342, 0.465679, 0.47196, 0.472368, 0.469613, 0.468334, 0.467263, 0.466584, 0.465558, 0.463966, 0.464337, 0.466129, 0.465167, 0.463316, 0.453177, 0.442652, 0.443076, 0.441641, 0.429242, 0.4229, 0.437184, 0.451824, 0.467365, 0.481386, 0.492132, 0.497355, 0.491051, 0.484538, 0.477549, 0.482676, 0.521756, 0.558566, 0.585887, 0.606246, 0.561795, 0.517345, 0.504755, 0.493016, 0.509039, 0.530992, 0.543241, 0.550172, 0.556697, 0.562706, 0.568741, 0.574875, 0.58101, 0.578694, 0.575886, 0.579638, 0.586876, 0.591184, 0.589622, 0.588061, 0.583177, 0.578236, 0.573933, 0.570053, 0.566218, 0.562574, 0.55893, 0.55355, 0.547591, 0.541574, 0.53541, 0.529246, 0.52348, 0.517829, 0.513002, 0.510809, 0.508617, 0.507155, 0.506053, 0.504862, 0.502457, 0.500052, 0.497177, 0.49369, 0.490204, 0.486622, 0.483011, 0.479358, 0.475113, 0.470868, 0.466946, 0.463679, 0.460412, 0.456557, 0.452239, 0.44792, 0.445256, 0.443132, 0.441008, 0.428526, 0.41507, 0.401675, 0.389852, 0.378029, 0.365823, 0.35091, 0.335998, 0.321276, 0.307457, 0.293638, 0.27852, 0.257754, 0.236989, 0.215644, 0.191327, 0.167009, 0.143917, 0.131724, 0.119532, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Cd = [0, 0, 0, 0, 0, 0.00368814, 0.00392157, 0.00270001, 0.00311714, 0.00353189, 0.00343729, 0.0038874, 0.00423018, 0.00367476, 0.00487682, 0.00662343, 0.007471, 0.00770563, 0.00907269, 0.0109836, 0.0127345, 0.0140516, 0.0162574, 0.0210206, 0.0259342, 0.0298216, 0.0350468, 0.0439775, 0.052733, 0.0572617, 0.0681716, 0.0779597, 0.0810652, 0.0882187, 0.0979443, 0.104603, 0.111576, 0.116305, 0.124494, 0.132608, 0.141565, 0.180605, 0.255017, 0.236721, 0.160106, 0.152633, 0.15078, 0.14747, 0.143785, 0.143318, 0.141727, 0.134987, 0.131443, 0.130741, 0.133373, 0.136003, 0.135905, 0.136684, 0.136715, 0.14027, 0.144762, 0.155287, 0.166352, 0.189375, 0.21894, 0.283577, 0.355578, 0.429268, 0.651266, 0.800096, 0.689698, 0.323114, 0.269809, 0.256957, 0.251494, 0.262843, 0.299273, 0.336503, 0.349353, 0.56466, 0.785807, 0.805515, 0.609511, 0.302795, 0.232585, 0.213019, 0.168521, 0.157338, 0.138394, 0.126276, 0.112046, 0.0965152, 0.0874272, 0.0819665, 0.0773613, 0.0806741, 0.0855659, 0.0931808, 0.100636, 0.108287, 0.119984, 0.139484, 0.165433, 0.189201, 0.208659, 0.284168, 0.517442, 0.767542, 0.816427, 0.754685, 0.498098, 0.270419, 0.174346, 0.181463, 0.206875, 0.214652, 0.143926, 0.103238, 0.0867639, 0.0799869, 0.068818, 0.0664749, 0.0636474, 0.0597921, 0.0547614, 0.0487405, 0.0457528, 0.0447991, 0.0449486, 0.0442087, 0.0419641, 0.0403183, 0.0396461, 0.0387177, 0.0372057, 0.0355226, 0.0341977, 0.0344901, 0.0339586, 0.0310993, 0.0280966, 0.0263297, 0.0266952, 0.026325, 0.0258666, 0.0254776, 0.0250427, 0.0245503, 0.0238863, 0.0223062, 0.0201549, 0.0189519, 0.0179144, 0.0171527, 0.016376, 0.0156119, 0.015166, 0.0144983, 0.0134417, 0.0132981, 0.013646, 0.0139111, 0.0139658, 0.0129478, 0.0119348, 0.0109299, 0.0105717, 0.010682, 0.0111616, 0.0117605, 0.0122305, 0.0126179, 0.0112907, 0.0100457, 0.00928547, 0.0086391, 0.00838034, 0.00806441, 0.00760433, 0.00725011, 0.00712398, 0.0071275, 0.00740156, 0.00759176, 0.00759176, 0.00765564, 0.00789852, 0.00814082, 0.00838069, 0.00857202, 0.00831152, 0.00805101, 0.00811257, 0.00818272, 0.00827116, 0.00836349, 0.0083078, 0.008171, 0.0078464, 0.00728377, 0.00683301, 0.00681078, 0.00678855, 0.00755431, 0.00836593, 0.00891643, 0.00932818, 0.00963132, 0.00971689, 0.00980247, 0.0101568, 0.0105157, 0.0104451, 0.0100905, 0.00965766, 0.0088959, 0.00813413, 0.00788267, 0.00780132, 0.00791004, 0.00851239, 0.00911475, 0.00969588, 0.0102708, 0.0113985, 0.0142961, 0.0171936, 0.0190952, 0.0205063, 0.0223903, 0.0306552, 0.0389201, 0.0505575, 0.0665751, 0.0825927, 0.109668, 0.140102, 0.171732, 0.2203, 0.268868, 0.327199, 0.405354, 0.48351, 0.517146, 0.515802, 0.514459, 0.428193, 0.314221, 0.200249, 0.144926, 0.0951212, 0.0467347, 0.0352573, 0.0237798, 0.0137128, 0.0136105, 0.0135083, 0.013005, 0.0105981, 0.00819113, 0.0065141, 0.00801044, 0.00950677, 0.01062, 0.00976621, 0.00891239, 0.00812187, 0.00789489, 0.00766791, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    CobaltGlass = [0, 0, 0, 0, 0, 0.0192846, 0.114501, 0.221858, 0.308899, 0.394907, 0.471506, 0.526302, 0.5417, 0.551031, 0.566369, 0.574136, 0.581942, 0.595429, 0.60149, 0.609802, 0.615719, 0.619563, 0.623738, 0.632195, 0.634753, 0.640468, 0.641512, 0.648088, 0.650792, 0.652333, 0.654258, 0.660326, 0.664352, 0.670071, 0.67781, 0.679635, 0.676768, 0.686643, 0.694768, 0.698399, 0.706015, 0.715174, 0.726614, 0.740462, 0.752708, 0.761518, 0.775049, 0.786208, 0.782597, 0.777669, 0.776294, 0.777395, 0.772185, 0.755294, 0.733295, 0.710207, 0.667879, 0.664911, 0.66447, 0.66099, 0.657898, 0.652169, 0.652358, 0.654711, 0.655555, 0.663287, 0.666408, 0.671056, 0.680644, 0.678783, 0.678723, 0.678405, 0.677672, 0.67717, 0.672838, 0.670657, 0.666941, 0.663475, 0.660704, 0.657869, 0.655781, 0.653569, 0.655018, 0.655526, 0.656855, 0.657028, 0.657087, 0.655112, 0.65119, 0.645314, 0.637912, 0.626398, 0.610822, 0.596138, 0.583229, 0.565824, 0.549028, 0.532426, 0.517536, 0.505005, 0.491988, 0.478948, 0.469567, 0.462971, 0.455159, 0.445024, 0.43213, 0.422321, 0.415228, 0.406216, 0.393904, 0.381717, 0.36844, 0.356245, 0.34911, 0.340493, 0.331385, 0.323265, 0.317076, 0.312458, 0.308164, 0.306973, 0.307909, 0.310528, 0.314755, 0.321236, 0.329068, 0.338172, 0.34859, 0.360651, 0.369793, 0.377647, 0.384803, 0.393659, 0.398756, 0.40183, 0.404375, 0.405901, 0.405789, 0.403032, 0.399081, 0.394126, 0.387779, 0.382573, 0.373802, 0.357238, 0.340655, 0.322013, 0.295357, 0.265556, 0.233812, 0.208828, 0.186985, 0.170379, 0.161929, 0.156295, 0.14577, 0.134846, 0.123223, 0.112804, 0.103033, 0.0907316, 0.0792874, 0.0736037, 0.0707449, 0.0724757, 0.0747694, 0.0774707, 0.0811343, 0.0851085, 0.0852013, 0.0851355, 0.0907365, 0.0957687, 0.0974463, 0.0994656, 0.102648, 0.105159, 0.105977, 0.106848, 0.107832, 0.108424, 0.1082, 0.10827, 0.109009, 0.109515, 0.109369, 0.108871, 0.106904, 0.104754, 0.100894, 0.0970335, 0.0923095, 0.0875625, 0.0804501, 0.0728324, 0.0672635, 0.0628173, 0.059131, 0.0564079, 0.0541288, 0.0535509, 0.052973, 0.0520084, 0.0510212, 0.0511174, 0.0517892, 0.051817, 0.0505547, 0.0492925, 0.0536299, 0.0580642, 0.064727, 0.072863, 0.0822633, 0.096984, 0.111705, 0.126505, 0.141331, 0.156736, 0.173642, 0.190548, 0.208041, 0.225705, 0.244249, 0.265608, 0.286968, 0.301671, 0.313095, 0.32484, 0.340911, 0.356983, 0.373416, 0.390319, 0.407223, 0.423397, 0.439349, 0.454721, 0.461869, 0.469017, 0.475483, 0.480565, 0.485647, 0.490251, 0.49448, 0.498709, 0.496772, 0.492824, 0.488877, 0.472165, 0.454253, 0.43639, 0.419821, 0.403252, 0.385942, 0.363394, 0.340846, 0.318687, 0.298371, 0.278056, 0.258231, 0.240541, 0.222851, 0.205282, 0.188337, 0.171392, 0.155314, 0.146948, 0.138582, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Daylight = [0, 0, 0, 0, 0, 0.127609, 0.167435, 0.204177, 0.237557, 0.287076, 0.321246, 0.344249, 0.372908, 0.39067, 0.411523, 0.427561, 0.45275, 0.472335, 0.49, 0.503205, 0.512628, 0.532405, 0.537468, 0.538938, 0.541474, 0.54013, 0.541555, 0.539182, 0.528948, 0.545301, 0.554368, 0.55386, 0.550647, 0.563067, 0.570476, 0.569166, 0.567207, 0.572072, 0.580013, 0.589493, 0.595669, 0.600004, 0.603994, 0.606436, 0.607744, 0.612049, 0.615207, 0.622618, 0.632711, 0.637406, 0.639112, 0.638965, 0.6421, 0.650025, 0.656615, 0.660426, 0.665716, 0.65692, 0.652392, 0.646369, 0.636216, 0.623218, 0.607492, 0.602598, 0.592334, 0.587446, 0.592963, 0.586987, 0.578502, 0.589177, 0.585851, 0.585753, 0.582275, 0.580041, 0.582924, 0.582433, 0.585008, 0.586103, 0.583987, 0.588501, 0.590643, 0.586575, 0.577998, 0.571047, 0.572321, 0.581934, 0.587758, 0.590155, 0.600135, 0.599313, 0.600465, 0.604804, 0.607975, 0.61055, 0.612919, 0.609518, 0.604728, 0.599686, 0.589924, 0.58499, 0.588527, 0.59307, 0.595606, 0.595854, 0.595112, 0.596521, 0.596638, 0.598514, 0.600668, 0.602093, 0.60314, 0.60344, 0.598811, 0.594233, 0.598772, 0.602051, 0.604423, 0.604419, 0.602639, 0.599721, 0.59621, 0.593549, 0.591093, 0.589844, 0.589711, 0.588983, 0.586183, 0.581831, 0.576136, 0.569255, 0.561235, 0.554812, 0.549592, 0.534381, 0.525626, 0.519265, 0.510479, 0.498537, 0.486191, 0.47455, 0.467349, 0.462188, 0.45933, 0.457573, 0.4559, 0.45402, 0.452852, 0.452319, 0.453458, 0.45382, 0.453696, 0.453758, 0.453716, 0.453503, 0.454906, 0.456845, 0.457439, 0.460993, 0.46974, 0.472782, 0.472752, 0.474349, 0.476042, 0.477456, 0.475555, 0.468269, 0.461676, 0.455584, 0.449015, 0.442291, 0.434738, 0.427156, 0.420891, 0.414737, 0.409232, 0.404918, 0.404659, 0.404757, 0.405754, 0.40809, 0.413312, 0.417778, 0.420668, 0.425046, 0.432799, 0.441316, 0.451979, 0.461871, 0.468539, 0.474941, 0.478873, 0.482804, 0.48056, 0.478152, 0.480068, 0.482907, 0.489642, 0.498511, 0.506784, 0.5143, 0.520661, 0.522595, 0.524529, 0.529444, 0.534533, 0.538818, 0.542676, 0.54765, 0.55486, 0.562069, 0.563458, 0.564746, 0.567972, 0.572478, 0.576589, 0.579039, 0.581489, 0.582894, 0.583952, 0.583672, 0.579917, 0.576163, 0.574071, 0.572466, 0.570934, 0.569642, 0.56835, 0.567846, 0.56773, 0.567601, 0.567296, 0.56699, 0.566433, 0.565547, 0.564661, 0.562913, 0.560902, 0.558829, 0.55587, 0.552912, 0.550289, 0.548347, 0.546405, 0.544477, 0.54256, 0.540643, 0.537888, 0.534861, 0.531833, 0.529033, 0.526255, 0.523401, 0.518586, 0.51377, 0.508654, 0.501411, 0.494168, 0.485737, 0.471665, 0.457594, 0.442485, 0.422867, 0.403248, 0.383142, 0.360532, 0.337923, 0.316606, 0.306797, 0.296988, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    FL37K = [0, 0, 0, 0, 0, 0.00051713, 0.00386715, 0.00563097, 0.00563097, 0.00718954, 0.00718954, 0.00718954, 0.00947285, 0.0136531, 0.0229522, 0.0298175, 0.0375497, 0.0478065, 0.0576816, 0.0835605, 0.103377, 0.123647, 0.147016, 0.168975, 0.196993, 0.229634, 0.253221, 0.281397, 0.322834, 0.376381, 0.421102, 0.475627, 0.527864, 0.546541, 0.530175, 0.778193, 0.741819, 0.541794, 0.556036, 0.546563, 0.544127, 0.548898, 0.553674, 0.55853, 0.562491, 0.561511, 0.570188, 0.570437, 0.571951, 0.58226, 0.579652, 0.584159, 0.58928, 0.59284, 0.596459, 0.601294, 0.605092, 0.61042, 0.618721, 0.620313, 0.62637, 0.631855, 0.62119, 0.612839, 0.602001, 0.596679, 0.598939, 0.583369, 0.564951, 0.568505, 0.568149, 0.569324, 0.567328, 0.562502, 0.564438, 0.560836, 0.558778, 0.559076, 0.555991, 0.56349, 0.556224, 0.545206, 0.547852, 0.552935, 0.554119, 0.547495, 0.547415, 0.543867, 0.544921, 0.543248, 0.545154, 0.543589, 0.539631, 0.53652, 0.535258, 0.531358, 0.521831, 0.514042, 0.498738, 0.482829, 0.478728, 0.483179, 0.490082, 0.494457, 0.496413, 0.501571, 0.507092, 0.512189, 0.516094, 0.519416, 0.522778, 0.527336, 0.534543, 0.541792, 0.545015, 0.548209, 0.55109, 0.554145, 0.557458, 0.560873, 0.564052, 0.565958, 0.567726, 0.569239, 0.570503, 0.571692, 0.572307, 0.57208, 0.571176, 0.570103, 0.569287, 0.568625, 0.568058, 0.567201, 0.563088, 0.559431, 0.562116, 0.554399, 0.547486, 0.546976, 0.533913, 0.524731, 0.525396, 0.590632, 0.649118, 0.671388, 0.623477, 0.564565, 0.542684, 0.540819, 0.551456, 0.546151, 0.541692, 0.538646, 0.534427, 0.5297, 0.523873, 0.519436, 0.517441, 0.513576, 0.508705, 0.506042, 0.502317, 0.491911, 0.482099, 0.47325, 0.466591, 0.46152, 0.460241, 0.460186, 0.460279, 0.460415, 0.461238, 0.462599, 0.467133, 0.472113, 0.478608, 0.483389, 0.483849, 0.482596, 0.477651, 0.471976, 0.464776, 0.458115, 0.452676, 0.448694, 0.448791, 0.448619, 0.447324, 0.445784, 0.441971, 0.438158, 0.431727, 0.425226, 0.428191, 0.433177, 0.441231, 0.450968, 0.459755, 0.467339, 0.474283, 0.478773, 0.483262, 0.493189, 0.503433, 0.508205, 0.510069, 0.513001, 0.518071, 0.523142, 0.525096, 0.526996, 0.531507, 0.537745, 0.543659, 0.548209, 0.552759, 0.55652, 0.560018, 0.562215, 0.56103, 0.559846, 0.560161, 0.560914, 0.560938, 0.558628, 0.556317, 0.551748, 0.546065, 0.540238, 0.53247, 0.524701, 0.516763, 0.508603, 0.500443, 0.492403, 0.484399, 0.476209, 0.465385, 0.454562, 0.443093, 0.430315, 0.417537, 0.404319, 0.390756, 0.377193, 0.364059, 0.351064, 0.33807, 0.323185, 0.308121, 0.29298, 0.275824, 0.258669, 0.241668, 0.225767, 0.209866, 0.194453, 0.181358, 0.168263, 0.15503, 0.141198, 0.127365, 0.113715, 0.101007, 0.088298, 0.0763242, 0.0708929, 0.0654615, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    FLAV17K = [0, 0, 0, 0, 0, 0.016031, 0.42932, 0.0244678, 0.101911, 0.051942, 0.0668863, 0.0879829, 0.122364, 0.157928, 0.207159, 0.237947, 0.290102, 0.321151, 0.379081, 0.416358, 0.46567, 0.499801, 0.518919, 0.530856, 0.531794, 0.539827, 0.543102, 0.551348, 0.557205, 0.566476, 0.57192, 0.580039, 0.586705, 0.594427, 0.591979, 0.595347, 0.644587, 0.776709, 0.587809, 0.629318, 0.63058, 0.642208, 0.643198, 0.649315, 0.647241, 0.654325, 0.65704, 0.661468, 0.666148, 0.66721, 0.671879, 0.676442, 0.672014, 0.680315, 0.67995, 0.684435, 0.691363, 0.694394, 0.694597, 0.688477, 0.68656, 0.684945, 0.660127, 0.651453, 0.637716, 0.620461, 0.613041, 0.608101, 0.601076, 0.599179, 0.596271, 0.588259, 0.58346, 0.580822, 0.578567, 0.574436, 0.573006, 0.567058, 0.564815, 0.566547, 0.560163, 0.554372, 0.554529, 0.5595, 0.566784, 0.578396, 0.590949, 0.596057, 0.599305, 0.594254, 0.591301, 0.585562, 0.578631, 0.568637, 0.555325, 0.540951, 0.518325, 0.488972, 0.448745, 0.398596, 0.350842, 0.321588, 0.309494, 0.300922, 0.291236, 0.283611, 0.279292, 0.276233, 0.272058, 0.27246, 0.273199, 0.270907, 0.270551, 0.270063, 0.26275, 0.258336, 0.25504, 0.250003, 0.244222, 0.23891, 0.235101, 0.231527, 0.225602, 0.221306, 0.21991, 0.21991, 0.21859, 0.218164, 0.218873, 0.220464, 0.235828, 0.259927, 0.288517, 0.287625, 0.296833, 0.319269, 0.36714, 0.411381, 0.452032, 0.487536, 0.551727, 0.604007, 0.62863, 0.637474, 0.636518, 0.620634, 0.548734, 0.473986, 0.451946, 0.445684, 0.449338, 0.452639, 0.435847, 0.385571, 0.331542, 0.277523, 0.248594, 0.225478, 0.212564, 0.192119, 0.167619, 0.153215, 0.140014, 0.12828, 0.119325, 0.114886, 0.116715, 0.123082, 0.122681, 0.120094, 0.129366, 0.139555, 0.143085, 0.160061, 0.256315, 0.343976, 0.402378, 0.439772, 0.424206, 0.410359, 0.400218, 0.398449, 0.414145, 0.426356, 0.430662, 0.440039, 0.463623, 0.480086, 0.466773, 0.457489, 0.485718, 0.513947, 0.506413, 0.497924, 0.474004, 0.446788, 0.456774, 0.487145, 0.497523, 0.482557, 0.46272, 0.424224, 0.385727, 0.383776, 0.383951, 0.39246, 0.405398, 0.437288, 0.50714, 0.576993, 0.592046, 0.606151, 0.592437, 0.560331, 0.53348, 0.528744, 0.524009, 0.537331, 0.556673, 0.568779, 0.562093, 0.555407, 0.533012, 0.50603, 0.482162, 0.468261, 0.454361, 0.450927, 0.452647, 0.451523, 0.412011, 0.3725, 0.324969, 0.267023, 0.209077, 0.193249, 0.190215, 0.187375, 0.187283, 0.187191, 0.187351, 0.188022, 0.188694, 0.190855, 0.194188, 0.197521, 0.199115, 0.200142, 0.201169, 0.180956, 0.158745, 0.136707, 0.119154, 0.101601, 0.0862475, 0.086435, 0.0866225, 0.0868944, 0.0875677, 0.0882409, 0.0876877, 0.0818022, 0.0759167, 0.0694435, 0.0599531, 0.0504626, 0.0415589, 0.0378786, 0.0341982, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    FLAV8K = [0, 0, 0, 0, 0, 0.0160957, 0.513267, 0.0229663, 0.0870287, 0.04243, 0.0542218, 0.0755832, 0.0921673, 0.12121, 0.151131, 0.179411, 0.217256, 0.253077, 0.283515, 0.314482, 0.362617, 0.400369, 0.425394, 0.457194, 0.491556, 0.511724, 0.522471, 0.532257, 0.533636, 0.538913, 0.544649, 0.548663, 0.553054, 0.563529, 0.563405, 0.549653, 0.663309, 0.750223, 0.560797, 0.590346, 0.595109, 0.599004, 0.606761, 0.606904, 0.614045, 0.618005, 0.618812, 0.621693, 0.62734, 0.629158, 0.630092, 0.632056, 0.636433, 0.640535, 0.642577, 0.646894, 0.650648, 0.654727, 0.659823, 0.659812, 0.661272, 0.657017, 0.655108, 0.644747, 0.631516, 0.624439, 0.613847, 0.598547, 0.591604, 0.585035, 0.573, 0.565769, 0.562275, 0.558719, 0.555953, 0.554328, 0.553311, 0.550122, 0.543197, 0.542497, 0.53934, 0.531745, 0.543709, 0.545788, 0.542518, 0.544572, 0.623725, 0.591629, 0.549434, 0.541568, 0.572166, 0.565386, 0.552162, 0.553119, 0.502171, 0.448763, 0.458203, 0.447912, 0.391046, 0.337001, 0.315172, 0.310437, 0.289623, 0.259943, 0.24579, 0.237976, 0.230171, 0.224413, 0.223156, 0.222827, 0.217339, 0.212114, 0.208979, 0.206084, 0.200982, 0.195349, 0.191993, 0.187929, 0.182846, 0.17712, 0.171559, 0.168303, 0.164839, 0.161903, 0.16084, 0.165288, 0.167512, 0.167703, 0.168877, 0.179568, 0.213296, 0.248842, 0.279032, 0.278996, 0.321534, 0.386045, 0.453651, 0.470123, 0.485487, 0.522658, 0.565713, 0.57561, 0.52776, 0.545277, 0.575782, 0.610791, 0.584102, 0.53779, 0.485205, 0.450863, 0.428017, 0.410435, 0.395893, 0.386417, 0.342016, 0.285347, 0.245834, 0.209115, 0.177299, 0.159813, 0.150042, 0.136325, 0.123217, 0.115243, 0.108669, 0.10437, 0.101253, 0.0989929, 0.0974536, 0.0961471, 0.0928511, 0.0895565, 0.0912023, 0.105783, 0.196638, 0.288108, 0.381674, 0.445844, 0.435901, 0.426703, 0.41911, 0.415067, 0.41843, 0.429876, 0.459653, 0.482551, 0.48617, 0.487687, 0.480419, 0.475871, 0.49664, 0.517409, 0.510046, 0.501931, 0.481368, 0.458146, 0.467335, 0.494286, 0.501788, 0.48464, 0.463495, 0.427044, 0.390592, 0.389458, 0.390379, 0.397095, 0.406891, 0.436421, 0.505482, 0.574542, 0.593567, 0.611726, 0.58914, 0.539614, 0.500693, 0.506396, 0.512098, 0.511648, 0.509146, 0.506402, 0.503029, 0.499656, 0.496792, 0.494076, 0.490939, 0.486456, 0.481972, 0.482682, 0.485949, 0.484308, 0.416451, 0.348595, 0.292902, 0.253009, 0.213116, 0.200495, 0.196158, 0.192045, 0.191108, 0.19017, 0.186643, 0.177859, 0.169074, 0.163212, 0.159647, 0.156081, 0.154323, 0.153154, 0.151986, 0.144394, 0.136198, 0.127934, 0.117889, 0.107844, 0.0984256, 0.093432, 0.0884384, 0.0839154, 0.0816263, 0.0793372, 0.0762543, 0.0697203, 0.0631864, 0.05658, 0.0496017, 0.0426234, 0.0361075, 0.033708, 0.0313085, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    FLBLB = [0, 0, 0, 0, 0, 0.162307, 0.569248, 0.387568, 0.442232, 0.576363, 0.451323, 0.48139, 0.517003, 0.527299, 0.536952, 0.545847, 0.553259, 0.551506, 0.550696, 0.555579, 0.555268, 0.554752, 0.55351, 0.551867, 0.552135, 0.5444, 0.546691, 0.536844, 0.525804, 0.514473, 0.505357, 0.506208, 0.521613, 0.50915, 0.524807, 0.565829, 0.920335, 0.742374, 0.431911, 0.450916, 0.403641, 0.370006, 0.341996, 0.301633, 0.290935, 0.272448, 0.250851, 0.235728, 0.218725, 0.203565, 0.192739, 0.182472, 0.170477, 0.159256, 0.150277, 0.14361, 0.12968, 0.124973, 0.119837, 0.113026, 0.105852, 0.100044, 0.0971306, 0.0904407, 0.0852093, 0.0809307, 0.0770879, 0.0746855, 0.0743302, 0.0733073, 0.0714519, 0.068268, 0.063903, 0.0611549, 0.0598379, 0.0570897, 0.0531859, 0.0490186, 0.0475674, 0.0472184, 0.0449077, 0.0403447, 0.0393272, 0.0374183, 0.0357942, 0.0340053, 0.0321252, 0.0308125, 0.0294952, 0.0291932, 0.0279623, 0.0294343, 0.0349491, 0.0387647, 0.0383693, 0.0287348, 0.0210544, 0.0157211, 0.0113956, 0.00930297, 0.00939066, 0.0119319, 0.0151838, 0.0153198, 0.0130577, 0.0128729, 0.0126899, 0.0124984, 0.0121392, 0.0120335, 0.0118749, 0.0117578, 0.0118651, 0.0120102, 0.0117046, 0.0106117, 0.00953154, 0.00900771, 0.0085553, 0.00785455, 0.00683554, 0.00675611, 0.00590251, 0.00532931, 0.00538515, 0.00569194, 0.00573152, 0.00573152, 0.00579131, 0.00608727, 0.00638051, 0.00653595, 0.00690081, 0.0115785, 0.0140441, 0.0158518, 0.0189897, 0.018169, 0.0198272, 0.0280648, 0.0533737, 0.102735, 0.188434, 0.314707, 0.398691, 0.380895, 0.249919, 0.105829, 0.0395214, 0.015308, 0.0175377, 0.0157795, 0.0153663, 0.0171945, 0.0142508, 0.00968301, 0.0083748, 0.00690224, 0.00514124, 0.00452489, 0.00452489, 0.00473458, 0.0049271, 0.0049271, 0.0049271, 0.0049271, 0.005055, 0.00527551, 0.00532931, 0.00532931, 0.00532931, 0.00539453, 0.00706688, 0.00918849, 0.0139593, 0.018816, 0.0239652, 0.0270932, 0.025125, 0.0217896, 0.0155082, 0.0102045, 0.00694074, 0.00438956, 0.00345442, 0.00304627, 0.00411495, 0.00490794, 0.00454813, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00303454, 0.00121418, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000726895, 0.00378108, 0.00683526, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    FLBL = [0, 0, 0, 0, 0, 0.191665, 0.586411, 0.166073, 0.391302, 0.164436, 0.174575, 0.187492, 0.192505, 0.19148, 0.196006, 0.198251, 0.198848, 0.194165, 0.194523, 0.191827, 0.195158, 0.187196, 0.18567, 0.180048, 0.179159, 0.184124, 0.19402, 0.203427, 0.202043, 0.206119, 0.224349, 0.255324, 0.294588, 0.396852, 0.508598, 0.594489, 0.908645, 0.967136, 0.902945, 0.602564, 0.396027, 0.297697, 0.215951, 0.180379, 0.151301, 0.121215, 0.110469, 0.101067, 0.0876541, 0.0770866, 0.0699731, 0.0642429, 0.0606375, 0.0570399, 0.0507383, 0.0489015, 0.0475837, 0.0436581, 0.039016, 0.0342709, 0.0320163, 0.0290846, 0.0280103, 0.0257701, 0.0243206, 0.0258763, 0.0275216, 0.0266396, 0.0260069, 0.0233868, 0.0220432, 0.0217389, 0.0201174, 0.0185707, 0.0147457, 0.0145672, 0.01466, 0.0143608, 0.0134818, 0.0139179, 0.0133362, 0.0123177, 0.0119203, 0.0110318, 0.00992675, 0.0093217, 0.00987551, 0.00999925, 0.00859599, 0.0090167, 0.00978983, 0.0160249, 0.0254968, 0.0280024, 0.0227457, 0.0111518, 0.00556834, 0.00511974, 0.00487254, 0.00474654, 0.00455837, 0.00447566, 0.00484603, 0.00507072, 0.00458467, 0.00418088, 0.00460015, 0.00502765, 0.00502765, 0.00461186, 0.00420716, 0.00450158, 0.00508489, 0.00533147, 0.00504703, 0.00483685, 0.00462913, 0.00469675, 0.00467149, 0.00455838, 0.00467572, 0.00467572, 0.00473533, 0.00466501, 0.00446065, 0.00438395, 0.00463806, 0.00473551, 0.00468319, 0.00472018, 0.00497277, 0.00533163, 0.00601561, 0.00965778, 0.0102687, 0.00964553, 0.00981986, 0.0100479, 0.0117518, 0.016245, 0.0375011, 0.0668756, 0.105654, 0.140932, 0.215238, 0.371806, 0.506631, 0.592837, 0.514103, 0.340701, 0.108692, 0.0573673, 0.022741, 0.015946, 0.0129431, 0.0114935, 0.0120584, 0.0114488, 0.00877794, 0.00739082, 0.00669495, 0.00600743, 0.00530397, 0.00451222, 0.00396894, 0.00382936, 0.00409048, 0.00464176, 0.00518785, 0.00573226, 0.00619727, 0.00688393, 0.0132282, 0.0198575, 0.028167, 0.043025, 0.0801823, 0.126357, 0.195267, 0.24542, 0.255157, 0.233455, 0.146156, 0.0747872, 0.0395468, 0.0129615, 0.0106298, 0.00838702, 0.00651604, 0.00479439, 0.00446284, 0.00413129, 0.0038038, 0.00347642, 0.00319055, 0.00291355, 0.00244725, 0.00187722, 0.00169752, 0.00201259, 0.00230385, 0.00250389, 0.00270393, 0.00281857, 0.00292825, 0.00288141, 0.00275138, 0.00265754, 0.00263614, 0.00261474, 0.00259362, 0.0025725, 0.00255154, 0.00253068, 0.00250988, 0.00248929, 0.0024687, 0.00243304, 0.00239237, 0.00235742, 0.00233734, 0.00231726, 0.00231272, 0.00231272, 0.00243853, 0.00296714, 0.00349575, 0.00363134, 0.00357335, 0.00350487, 0.00329491, 0.00308494, 0.00293352, 0.00285815, 0.00278277, 0.0027081, 0.00263364, 0.00256653, 0.00260328, 0.00264003, 0.00273653, 0.00295434, 0.00317214, 0.00331814, 0.00340773, 0.00349732, 0.00345262, 0.0033641, 0.00327558, 0.00326797, 0.00326797, 0.00326286, 0.00312479, 0.00298671, 0.00286576, 0.00286576, 0.00286576, 0.00286576, 0.00286576, 0.00286576, 0.00286576, 0.00286576, 0.00286576, 0.00288717, 0.00301853, 0.00314988, 0.00326797, 0.00326797, 0.00326797, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    FLD2 = [0, 0, 0, 0, 0, 0.179563, 0.596227, 0.247865, 0.397034, 0.350651, 0.346267, 0.39399, 0.430772, 0.477063, 0.505844, 0.519096, 0.531043, 0.531942, 0.53468, 0.541622, 0.545477, 0.556875, 0.561595, 0.567696, 0.573119, 0.57969, 0.584203, 0.595076, 0.592424, 0.602629, 0.610445, 0.616928, 0.619382, 0.630795, 0.627359, 0.630548, 0.876097, 0.980115, 0.886662, 0.661904, 0.645447, 0.663417, 0.66405, 0.670238, 0.672319, 0.675914, 0.674943, 0.678262, 0.679483, 0.682542, 0.687314, 0.692048, 0.701306, 0.708336, 0.711071, 0.706988, 0.690857, 0.681413, 0.65623, 0.635609, 0.622781, 0.617371, 0.611864, 0.609535, 0.598998, 0.594007, 0.593302, 0.592229, 0.583212, 0.589659, 0.590803, 0.593042, 0.596903, 0.602626, 0.603633, 0.606916, 0.613295, 0.616712, 0.618986, 0.620495, 0.622706, 0.624042, 0.626126, 0.62746, 0.627322, 0.626312, 0.626788, 0.62622, 0.622993, 0.623025, 0.623065, 0.623647, 0.624467, 0.624413, 0.623975, 0.622535, 0.623218, 0.625402, 0.626939, 0.626865, 0.624931, 0.624039, 0.625325, 0.626426, 0.626685, 0.627698, 0.628855, 0.628164, 0.626547, 0.627236, 0.628848, 0.630034, 0.626076, 0.620548, 0.62138, 0.621128, 0.624867, 0.62653, 0.627556, 0.628071, 0.626874, 0.62596, 0.624251, 0.622355, 0.620068, 0.615697, 0.612262, 0.60923, 0.606114, 0.601786, 0.597065, 0.592011, 0.586511, 0.579226, 0.572851, 0.565531, 0.553921, 0.545574, 0.538925, 0.533989, 0.523048, 0.506759, 0.482967, 0.454291, 0.462802, 0.550227, 0.610981, 0.63681, 0.556747, 0.490732, 0.433894, 0.44543, 0.450937, 0.446397, 0.444691, 0.44416, 0.445409, 0.446311, 0.446604, 0.447254, 0.448094, 0.447588, 0.447351, 0.449189, 0.450912, 0.452447, 0.453987, 0.455531, 0.458583, 0.462122, 0.464375, 0.465627, 0.4454, 0.426691, 0.41694, 0.412832, 0.427943, 0.443518, 0.46026, 0.464882, 0.443388, 0.426244, 0.418171, 0.414723, 0.421761, 0.426156, 0.423144, 0.423404, 0.43734, 0.450201, 0.453042, 0.455884, 0.461948, 0.468099, 0.470493, 0.472086, 0.477938, 0.486123, 0.495622, 0.506784, 0.517637, 0.527306, 0.536974, 0.542605, 0.548002, 0.551034, 0.552812, 0.555151, 0.558617, 0.562082, 0.568078, 0.574117, 0.578078, 0.580665, 0.582482, 0.581062, 0.579641, 0.577806, 0.575833, 0.57351, 0.570278, 0.567046, 0.566008, 0.565611, 0.564587, 0.561552, 0.558517, 0.557866, 0.558388, 0.558516, 0.553324, 0.548132, 0.543575, 0.539844, 0.536113, 0.535315, 0.535408, 0.535286, 0.532126, 0.528965, 0.525829, 0.522744, 0.519658, 0.516575, 0.513493, 0.510411, 0.506289, 0.501828, 0.497367, 0.497351, 0.497753, 0.497945, 0.492663, 0.487382, 0.482789, 0.483062, 0.483335, 0.481144, 0.467258, 0.453371, 0.438239, 0.41769, 0.39714, 0.376091, 0.35248, 0.328869, 0.305821, 0.287792, 0.269764, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    FeCo = [0, 0, 0, 0, 0, 0.193565, 0.142078, 0.145705, 0.30005, 0.512716, 0.49301, 0.538063, 0.390916, 0.339014, 0.508081, 0.549086, 0.547686, 0.542048, 0.521387, 0.57299, 0.576415, 0.531921, 0.623141, 0.589661, 0.654505, 0.550646, 0.588905, 0.586221, 0.674233, 0.55655, 0.651456, 0.562613, 0.542491, 0.701373, 0.63693, 0.578773, 0.747888, 0.587398, 0.682759, 0.673014, 0.657142, 0.652959, 0.655128, 0.632747, 0.640608, 0.608448, 0.596306, 0.591181, 0.555453, 0.500823, 0.518901, 0.666827, 0.56967, 0.571818, 0.576035, 0.532726, 0.552306, 0.549644, 0.577374, 0.5653, 0.525727, 0.5799, 0.563627, 0.569177, 0.563822, 0.560346, 0.550402, 0.509949, 0.481515, 0.488956, 0.390898, 0.490272, 0.501339, 0.460003, 0.402105, 0.442852, 0.462601, 0.492945, 0.37548, 0.425304, 0.396081, 0.437561, 0.48247, 0.41805, 0.560282, 0.605578, 0.536234, 0.586694, 0.407047, 0.540325, 0.59484, 0.439794, 0.435187, 0.604449, 0.462919, 0.343736, 0.375487, 0.413607, 0.536988, 0.44333, 0.310543, 0.383474, 0.449877, 0.390095, 0.360743, 0.406007, 0.37262, 0.359956, 0.501537, 0.396323, 0.455977, 0.520043, 0.484075, 0.468637, 0.61389, 0.523005, 0.507142, 0.55302, 0.572579, 0.568522, 0.613969, 0.553725, 0.453815, 0.482815, 0.630815, 0.619463, 0.484217, 0.400156, 0.395483, 0.474172, 0.570305, 0.666524, 0.752404, 0.758402, 0.694903, 0.606073, 0.544675, 0.534267, 0.520962, 0.478277, 0.453922, 0.446758, 0.463972, 0.538649, 0.57549, 0.513998, 0.445596, 0.389071, 0.386763, 0.37225, 0.350333, 0.381639, 0.384912, 0.341462, 0.345109, 0.366224, 0.380377, 0.381902, 0.361269, 0.365242, 0.382464, 0.349313, 0.313303, 0.286609, 0.270223, 0.270586, 0.264552, 0.253885, 0.252311, 0.253672, 0.225984, 0.196107, 0.18395, 0.181427, 0.235713, 0.291199, 0.350765, 0.399562, 0.421212, 0.409329, 0.325198, 0.272192, 0.284126, 0.291542, 0.288712, 0.299996, 0.350831, 0.408109, 0.492327, 0.569485, 0.580924, 0.592362, 0.496702, 0.398184, 0.35918, 0.332888, 0.321856, 0.319188, 0.314571, 0.307482, 0.300047, 0.29129, 0.282533, 0.267935, 0.252997, 0.246695, 0.244983, 0.242046, 0.236655, 0.231264, 0.23688, 0.242687, 0.237312, 0.224544, 0.213062, 0.206989, 0.200915, 0.18338, 0.162025, 0.144982, 0.139139, 0.133296, 0.12504, 0.116079, 0.10824, 0.103991, 0.0997429, 0.0936397, 0.086623, 0.0795018, 0.0709697, 0.0624375, 0.0551987, 0.0496396, 0.0440806, 0.0407723, 0.0381477, 0.0355399, 0.0331694, 0.0307989, 0.0283841, 0.0258794, 0.0233746, 0.0214598, 0.0200084, 0.0185571, 0.0153703, 0.0116173, 0.00786424, 0.00749356, 0.00744114, 0.00737979, 0.00708639, 0.00679298, 0.00655708, 0.00672751, 0.00689794, 0.00708264, 0.00733512, 0.0075876, 0.00779286, 0.00779286, 0.00779286, 0.00778751, 0.00775467, 0.00772183, 0.00767593, 0.0075138, 0.00735167, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    GRUN = [0, 0, 0, 0, 0, 0.00302736, 0.00311714, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0.00207525, 0.00644835, 0.0041255, 0.00687482, 0.00790581, 0.0092716, 0.00863815, 0.0113748, 0.0119471, 0.0128613, 0.0155409, 0.0185645, 0.0190951, 0.0197742, 0.0225046, 0.023811, 0.0314503, 0.0385367, 0.0478509, 0.0481578, 0.0431818, 0.0339903, 0.040871, 0.0624777, 0.208886, 0.405456, 0.272542, 0.0954356, 0.0704119, 0.0722084, 0.0759824, 0.0820818, 0.0898869, 0.093567, 0.0919014, 0.0798176, 0.0634345, 0.0525094, 0.047115, 0.0442987, 0.0482043, 0.0523078, 0.0573635, 0.0605777, 0.0697643, 0.0765988, 0.0915865, 0.10135, 0.109256, 0.106116, 0.0880441, 0.0679751, 0.0519124, 0.0443429, 0.0446381, 0.048338, 0.0481261, 0.046368, 0.0453058, 0.0443517, 0.0437814, 0.0451806, 0.044145, 0.0427835, 0.0448419, 0.0471434, 0.047859, 0.0469189, 0.0491263, 0.0530726, 0.051175, 0.0497843, 0.0491171, 0.049815, 0.0499656, 0.0523201, 0.0542124, 0.0554567, 0.0567896, 0.0579878, 0.056983, 0.05489, 0.052598, 0.051945, 0.0524869, 0.0545561, 0.0553577, 0.0555306, 0.057377, 0.0611108, 0.0650088, 0.0684284, 0.0722909, 0.0763288, 0.0797479, 0.0822221, 0.0896289, 0.0999084, 0.11414, 0.131495, 0.144126, 0.147895, 0.147601, 0.159162, 0.172639, 0.189695, 0.207385, 0.225564, 0.246331, 0.262812, 0.276543, 0.277936, 0.263217, 0.232384, 0.207121, 0.195468, 0.197419, 0.210774, 0.231595, 0.249813, 0.266228, 0.314755, 0.463052, 0.638205, 0.744684, 0.739512, 0.699332, 0.64463, 0.596359, 0.53402, 0.446161, 0.351632, 0.293516, 0.313322, 0.410473, 0.486308, 0.390845, 0.298761, 0.209245, 0.208042, 0.214706, 0.234482, 0.227072, 0.20848, 0.174645, 0.150897, 0.144851, 0.137967, 0.130631, 0.121785, 0.113203, 0.106756, 0.101074, 0.0966355, 0.0934284, 0.091113, 0.0890664, 0.0871065, 0.0867815, 0.086788, 0.090929, 0.0942225, 0.0925187, 0.101475, 0.146731, 0.201362, 0.279627, 0.332858, 0.332152, 0.309233, 0.239972, 0.189955, 0.183581, 0.181918, 0.193455, 0.210107, 0.248151, 0.285463, 0.315965, 0.346467, 0.300614, 0.252723, 0.22961, 0.211789, 0.204611, 0.203266, 0.203427, 0.205497, 0.206794, 0.205127, 0.203461, 0.199555, 0.195519, 0.192929, 0.191108, 0.189588, 0.188668, 0.187749, 0.185657, 0.183545, 0.181487, 0.179463, 0.177362, 0.174932, 0.172502, 0.170309, 0.168194, 0.166187, 0.16446, 0.162733, 0.16153, 0.160479, 0.158928, 0.155776, 0.152624, 0.150457, 0.148776, 0.147049, 0.144721, 0.142392, 0.140232, 0.13829, 0.136349, 0.134484, 0.132641, 0.130819, 0.129294, 0.127769, 0.126675, 0.126457, 0.12624, 0.126495, 0.127122, 0.12775, 0.137688, 0.150664, 0.16364, 0.18362, 0.204258, 0.225194, 0.253879, 0.282564, 0.306378, 0.295777, 0.285176, 0.266998, 0.212851, 0.158703, 0.110562, 0.0885322, 0.0665029, 0.0475639, 0.0444935, 0.041423, 0.0386938, 0.0390018, 0.0393099, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    GaPb = [0, 0, 0, 0, 0, 0.49155, 0.601143, 0.444537, 0.370639, 0.160346, 0.154909, 0.164386, 0.196292, 0.265634, 0.420262, 0.519967, 0.634885, 0.855862, 0.629564, 0.607154, 0.61779, 0.580985, 0.536048, 0.474512, 0.408987, 0.35894, 0.324355, 0.306435, 0.288049, 0.280665, 0.281426, 0.2742, 0.282156, 0.35139, 0.463623, 0.52728, 0.659847, 0.776581, 0.535159, 0.456374, 0.425282, 0.436483, 0.457915, 0.4796, 0.488504, 0.47844, 0.434868, 0.354797, 0.287993, 0.249364, 0.219932, 0.213137, 0.207478, 0.203765, 0.198565, 0.195059, 0.192042, 0.194741, 0.199952, 0.210233, 0.224254, 0.23626, 0.246093, 0.256767, 0.263739, 0.262549, 0.249898, 0.236632, 0.224029, 0.222674, 0.222879, 0.230212, 0.238226, 0.245844, 0.238002, 0.231048, 0.2284, 0.227488, 0.228345, 0.228684, 0.227104, 0.228197, 0.229923, 0.226832, 0.223905, 0.223625, 0.227867, 0.225849, 0.21713, 0.218421, 0.229556, 0.253973, 0.286633, 0.274031, 0.248795, 0.238087, 0.221183, 0.206043, 0.197657, 0.193509, 0.19152, 0.185691, 0.180652, 0.176967, 0.166654, 0.153666, 0.14436, 0.142896, 0.145724, 0.146817, 0.149903, 0.154507, 0.16038, 0.164723, 0.164666, 0.165758, 0.169681, 0.173931, 0.178889, 0.184145, 0.188532, 0.19028, 0.192636, 0.19456, 0.19603, 0.198522, 0.201616, 0.204962, 0.20846, 0.212011, 0.21772, 0.224796, 0.232579, 0.235792, 0.2764, 0.328354, 0.358514, 0.307867, 0.256089, 0.239954, 0.248531, 0.25324, 0.244966, 0.27829, 0.362477, 0.538007, 0.621648, 0.644349, 0.533962, 0.404307, 0.263168, 0.247252, 0.239305, 0.244638, 0.243377, 0.239601, 0.235557, 0.231778, 0.228461, 0.225472, 0.222659, 0.221663, 0.220839, 0.220048, 0.218037, 0.214045, 0.210178, 0.206401, 0.204328, 0.202804, 0.20242, 0.201652, 0.188565, 0.17803, 0.182538, 0.211968, 0.326261, 0.431062, 0.511934, 0.572759, 0.590393, 0.569258, 0.467235, 0.374894, 0.304512, 0.257341, 0.275217, 0.293124, 0.311163, 0.328234, 0.33631, 0.344385, 0.340199, 0.335686, 0.333598, 0.332029, 0.333638, 0.33699, 0.339777, 0.341847, 0.342808, 0.339518, 0.336229, 0.332897, 0.329563, 0.326383, 0.323284, 0.319707, 0.315171, 0.310635, 0.304767, 0.298876, 0.293781, 0.289212, 0.284567, 0.279606, 0.274644, 0.269591, 0.264506, 0.259518, 0.254779, 0.25004, 0.247005, 0.244468, 0.24122, 0.235699, 0.230178, 0.225688, 0.221706, 0.217618, 0.212102, 0.206586, 0.204969, 0.208418, 0.211866, 0.222393, 0.235069, 0.248334, 0.269944, 0.291554, 0.31488, 0.341688, 0.368496, 0.366837, 0.342809, 0.318782, 0.272306, 0.218506, 0.164707, 0.14505, 0.128606, 0.112485, 0.10477, 0.0970549, 0.0899734, 0.0873658, 0.0847582, 0.0817902, 0.077111, 0.0724317, 0.0680679, 0.0650752, 0.0620826, 0.0588363, 0.0542881, 0.0497399, 0.045281, 0.0416169, 0.0379527, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    GreenLaser = [0, 0, 0, 0, 0, 0.00174531, 0.00390312, 0.00331825, 0.00331825, 0.00311714, 0.00351936, 0.00311714, 0.00291604, 0.00322227, 0.00351936, 0.00372046, 0.00372046, 0.00372046, 0.003709, 0.00323042, 0.00321936, 0.0035778, 0.0036812, 0.00333708, 0.00345096, 0.00353121, 0.00363883, 0.00377074, 0.0039046, 0.00405476, 0.00417295, 0.00415501, 0.00436849, 0.00461191, 0.00433674, 0.00454981, 0.0042074, 0.00393199, 0.00389444, 0.00425942, 0.00467539, 0.0042735, 0.00431052, 0.00460815, 0.00396364, 0.00407169, 0.00395936, 0.00380151, 0.00393681, 0.0042614, 0.00455544, 0.0040874, 0.00480309, 0.00804811, 0.0127464, 0.0161651, 0.0209982, 0.0218879, 0.0230417, 0.0199303, 0.0164974, 0.0134761, 0.0104122, 0.00913942, 0.00683761, 0.00599159, 0.00496989, 0.00464326, 0.00452489, 0.00435947, 0.00432378, 0.00432378, 0.00432378, 0.00432378, 0.00553042, 0.00553042, 0.00553042, 0.00553042, 0.00553042, 0.00553042, 0.00633191, 0.00786871, 0.00799275, 0.00804424, 0.00846408, 0.00861555, 0.00900711, 0.00955893, 0.0111278, 0.0118357, 0.0128679, 0.0137652, 0.0152153, 0.0163105, 0.0167546, 0.0181062, 0.0189181, 0.0197508, 0.0218244, 0.0235093, 0.025714, 0.0281513, 0.0296421, 0.0326856, 0.038065, 0.0431977, 0.049737, 0.0544149, 0.0599812, 0.0682735, 0.0764305, 0.0838778, 0.0938896, 0.105423, 0.115269, 0.131243, 0.147701, 0.163962, 0.181937, 0.203731, 0.231007, 0.255629, 0.287051, 0.326438, 0.37363, 0.427358, 0.482205, 0.540367, 0.597984, 0.643007, 0.682496, 0.793523, 0.969875, 0.947201, 0.799706, 0.630783, 0.585283, 0.539849, 0.491156, 0.436216, 0.388815, 0.344022, 0.301687, 0.269254, 0.239628, 0.212431, 0.1959, 0.182007, 0.166259, 0.152219, 0.13927, 0.13014, 0.1216, 0.114044, 0.106316, 0.0986311, 0.0928334, 0.0869882, 0.0810595, 0.0769491, 0.0738176, 0.0695967, 0.0653199, 0.0612762, 0.0577203, 0.0549566, 0.0525329, 0.0503554, 0.0478485, 0.0452353, 0.0429935, 0.0407951, 0.0387512, 0.036882, 0.0360431, 0.0352009, 0.034347, 0.0333291, 0.0318977, 0.0302724, 0.028229, 0.0264441, 0.0251984, 0.0242435, 0.0239482, 0.0235772, 0.0229943, 0.0223665, 0.0215509, 0.0208007, 0.0206586, 0.0205165, 0.0200801, 0.0196358, 0.0193864, 0.0191786, 0.0185601, 0.0177165, 0.0171853, 0.0170503, 0.0167178, 0.0156286, 0.0145395, 0.0144174, 0.0143516, 0.0141448, 0.0138631, 0.0136681, 0.0136467, 0.0136253, 0.0135834, 0.0135412, 0.0132732, 0.012856, 0.0124873, 0.0123225, 0.0121578, 0.0120708, 0.0120098, 0.0119658, 0.0119658, 0.0119658, 0.0119504, 0.0119306, 0.0118549, 0.0116004, 0.0113459, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0.0112619, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    GroLux = [0, 0, 0, 0, 0, 0.00852187, 0.0154003, 0.00740184, 0.00789341, 0.00884565, 0.008513, 0.00677983, 0.00659505, 0.00958339, 0.00791185, 0.0104349, 0.0120062, 0.0124635, 0.0136358, 0.0150709, 0.0158218, 0.0168232, 0.0188371, 0.0219328, 0.0240039, 0.0269142, 0.0295856, 0.0301727, 0.0362324, 0.0392652, 0.0445856, 0.0477178, 0.0509532, 0.0498434, 0.0762464, 0.145844, 0.385103, 0.543037, 0.545301, 0.295664, 0.123458, 0.10097, 0.098425, 0.102959, 0.107784, 0.113032, 0.12202, 0.127607, 0.135063, 0.140961, 0.143305, 0.14797, 0.15526, 0.160532, 0.165277, 0.17341, 0.180942, 0.186942, 0.188611, 0.190866, 0.193577, 0.193177, 0.200916, 0.206822, 0.211892, 0.216955, 0.223077, 0.226692, 0.237113, 0.242705, 0.240396, 0.238771, 0.238103, 0.236685, 0.23177, 0.235592, 0.237723, 0.23854, 0.236969, 0.236732, 0.236467, 0.233487, 0.230306, 0.228588, 0.226447, 0.216807, 0.208686, 0.206527, 0.199012, 0.194988, 0.186891, 0.178869, 0.168114, 0.158808, 0.15326, 0.145193, 0.141271, 0.136889, 0.127552, 0.117838, 0.112624, 0.110565, 0.109061, 0.11037, 0.113768, 0.114178, 0.114675, 0.117563, 0.118729, 0.120134, 0.122248, 0.123656, 0.125554, 0.127732, 0.128599, 0.129566, 0.12985, 0.130127, 0.129826, 0.128977, 0.128151, 0.127992, 0.12703, 0.126117, 0.125613, 0.12546, 0.124912, 0.124045, 0.122789, 0.120865, 0.119545, 0.118938, 0.119136, 0.120814, 0.118224, 0.114476, 0.113639, 0.119008, 0.12963, 0.147365, 0.170091, 0.207526, 0.268602, 0.357668, 0.428532, 0.451968, 0.360922, 0.243533, 0.153794, 0.103385, 0.077819, 0.0759991, 0.0732734, 0.069038, 0.068266, 0.0686418, 0.0661146, 0.0635459, 0.0609044, 0.058491, 0.0562005, 0.0533607, 0.0503906, 0.0469974, 0.0441312, 0.0421212, 0.0409573, 0.040406, 0.0409712, 0.0418967, 0.0473087, 0.0531835, 0.059395, 0.0706049, 0.111287, 0.154283, 0.205155, 0.237688, 0.223987, 0.197781, 0.144629, 0.103427, 0.0871579, 0.0766354, 0.0791455, 0.0818642, 0.0851674, 0.0879118, 0.0883196, 0.0887429, 0.0893113, 0.0898797, 0.0925137, 0.0952029, 0.0976544, 0.100055, 0.102805, 0.105747, 0.109048, 0.112807, 0.117107, 0.123486, 0.129865, 0.13687, 0.143912, 0.152355, 0.161543, 0.170358, 0.178424, 0.18649, 0.196237, 0.206013, 0.223392, 0.245797, 0.267384, 0.285522, 0.30366, 0.323937, 0.344927, 0.363196, 0.374399, 0.385603, 0.395378, 0.404735, 0.412499, 0.415162, 0.417824, 0.419493, 0.420672, 0.421707, 0.42079, 0.419874, 0.416167, 0.408837, 0.401507, 0.391504, 0.380689, 0.370485, 0.368923, 0.367361, 0.367363, 0.370539, 0.373715, 0.378133, 0.383526, 0.388919, 0.395999, 0.403629, 0.411259, 0.418224, 0.425127, 0.431789, 0.432169, 0.432548, 0.43297, 0.433685, 0.434401, 0.433446, 0.424559, 0.415672, 0.402555, 0.371049, 0.339543, 0.306885, 0.268316, 0.229747, 0.192234, 0.16412, 0.136007, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPM2 = [0, 0, 0, 0, 0, 0.0311966, 0.17196, 0.0398127, 0.135847, 0.0208399, 0.0224108, 0.0227003, 0.0220094, 0.0200288, 0.0182874, 0.0195893, 0.0202334, 0.0202763, 0.022566, 0.0266067, 0.0269358, 0.0272618, 0.0291698, 0.0306935, 0.0330797, 0.0354731, 0.0396632, 0.0439244, 0.0456048, 0.0523224, 0.0662384, 0.0778769, 0.0960046, 0.237216, 0.320537, 0.47693, 0.822206, 0.456361, 0.291594, 0.178003, 0.129593, 0.109421, 0.0936325, 0.0863836, 0.0809228, 0.0783859, 0.0792951, 0.0793294, 0.0757864, 0.0731143, 0.0728261, 0.0712015, 0.069925, 0.0693074, 0.0668909, 0.0685924, 0.067499, 0.0694181, 0.0724921, 0.0786426, 0.0864171, 0.0894519, 0.07926, 0.0789901, 0.080284, 0.0807296, 0.0785041, 0.0810267, 0.0847385, 0.0876214, 0.0891734, 0.0910659, 0.0982307, 0.105734, 0.108824, 0.110474, 0.109549, 0.11246, 0.115066, 0.113717, 0.114512, 0.116702, 0.121435, 0.126551, 0.127021, 0.131772, 0.137095, 0.137532, 0.141677, 0.15389, 0.2357, 0.391422, 0.332328, 0.168158, 0.144269, 0.205418, 0.203699, 0.154791, 0.134754, 0.140232, 0.145813, 0.154735, 0.165087, 0.171796, 0.177133, 0.177685, 0.179602, 0.189289, 0.202487, 0.215459, 0.228237, 0.238616, 0.243554, 0.244801, 0.247672, 0.253893, 0.261621, 0.270094, 0.278269, 0.286401, 0.295662, 0.30285, 0.313934, 0.321938, 0.325774, 0.332025, 0.338804, 0.347311, 0.359688, 0.381885, 0.407887, 0.42914, 0.444302, 0.460513, 0.483781, 0.50715, 0.52012, 0.526106, 0.534401, 0.550366, 0.552139, 0.556496, 0.568924, 0.691434, 0.812521, 0.892815, 0.892743, 0.86008, 0.791812, 0.733458, 0.681376, 0.636775, 0.602397, 0.58506, 0.570672, 0.557536, 0.546713, 0.539393, 0.538219, 0.529836, 0.517571, 0.512243, 0.506857, 0.497808, 0.492175, 0.492091, 0.492344, 0.49284, 0.488208, 0.48192, 0.479588, 0.479186, 0.516561, 0.565807, 0.68505, 0.791057, 0.851995, 0.903364, 0.930611, 0.9426, 0.921712, 0.881616, 0.801442, 0.711629, 0.599953, 0.512198, 0.49148, 0.473622, 0.467721, 0.461215, 0.449066, 0.436917, 0.423459, 0.409967, 0.399869, 0.390497, 0.382937, 0.376371, 0.370695, 0.366149, 0.361279, 0.355166, 0.349054, 0.342789, 0.336516, 0.333419, 0.332011, 0.329817, 0.326052, 0.322286, 0.317905, 0.313513, 0.308726, 0.303677, 0.298009, 0.289733, 0.281456, 0.274201, 0.267286, 0.261355, 0.257982, 0.254608, 0.253524, 0.253107, 0.251276, 0.244913, 0.238551, 0.228253, 0.216017, 0.203815, 0.192076, 0.180337, 0.171959, 0.167946, 0.163932, 0.160099, 0.15632, 0.152367, 0.145954, 0.139541, 0.133184, 0.12694, 0.120696, 0.116805, 0.114762, 0.11272, 0.108386, 0.103306, 0.0982248, 0.0934434, 0.0886901, 0.0839428, 0.0793518, 0.0747608, 0.070401, 0.0676741, 0.0649472, 0.0620153, 0.0581104, 0.0542054, 0.050555, 0.0480113, 0.0454675, 0.0428272, 0.0396911, 0.036555, 0.0334982, 0.0311473, 0.0287964, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMFL1 = [0, 0, 0, 0, 0, 0.235941, 0.485595, 0.479385, 0.476421, 0.50806, 0.430596, 0.487586, 0.497746, 0.512468, 0.527971, 0.529387, 0.528768, 0.531813, 0.535221, 0.54213, 0.545792, 0.550298, 0.551622, 0.55712, 0.559951, 0.562383, 0.564838, 0.571496, 0.573171, 0.576092, 0.579664, 0.592448, 0.608215, 0.610326, 0.613816, 0.677652, 0.793556, 0.94775, 0.821629, 0.691438, 0.650575, 0.628918, 0.633531, 0.621185, 0.626303, 0.628499, 0.62623, 0.630245, 0.63181, 0.628683, 0.627985, 0.629392, 0.630434, 0.628543, 0.62763, 0.627198, 0.626412, 0.626524, 0.629038, 0.625236, 0.624893, 0.623197, 0.628273, 0.634, 0.640688, 0.641106, 0.641904, 0.636743, 0.629052, 0.621623, 0.610859, 0.595267, 0.582259, 0.572344, 0.577073, 0.573899, 0.574553, 0.569626, 0.564842, 0.558957, 0.554565, 0.550985, 0.547389, 0.543605, 0.543531, 0.542431, 0.546012, 0.539741, 0.521808, 0.491429, 0.521914, 0.600266, 0.539195, 0.436597, 0.429308, 0.472934, 0.440462, 0.382274, 0.351613, 0.332566, 0.30893, 0.294106, 0.294423, 0.296922, 0.296919, 0.297144, 0.299253, 0.304856, 0.307146, 0.307747, 0.307278, 0.310244, 0.313466, 0.315303, 0.317042, 0.315318, 0.317879, 0.320122, 0.322457, 0.324691, 0.325929, 0.325372, 0.325746, 0.327002, 0.328892, 0.330733, 0.333908, 0.338094, 0.343207, 0.349273, 0.354761, 0.359923, 0.365257, 0.37554, 0.382953, 0.38807, 0.390476, 0.392915, 0.381136, 0.342229, 0.413715, 0.54902, 0.763817, 0.835795, 0.840413, 0.754221, 0.681253, 0.605331, 0.502818, 0.447861, 0.422866, 0.41096, 0.398743, 0.386006, 0.379755, 0.375955, 0.372001, 0.366478, 0.358201, 0.354984, 0.354491, 0.347084, 0.340524, 0.341797, 0.342596, 0.342623, 0.33178, 0.313064, 0.319342, 0.333688, 0.401052, 0.476757, 0.627188, 0.757631, 0.770213, 0.769331, 0.7226, 0.676793, 0.633315, 0.585091, 0.526641, 0.47448, 0.43544, 0.410816, 0.418887, 0.426427, 0.432475, 0.435712, 0.427197, 0.419705, 0.421741, 0.423778, 0.423649, 0.423462, 0.424171, 0.425071, 0.42838, 0.433009, 0.437502, 0.441822, 0.445898, 0.449032, 0.452166, 0.456546, 0.460999, 0.462912, 0.463475, 0.465739, 0.471409, 0.477079, 0.484813, 0.492583, 0.499544, 0.505969, 0.513639, 0.526548, 0.539457, 0.550997, 0.562082, 0.571938, 0.578604, 0.58527, 0.587498, 0.58843, 0.588422, 0.585407, 0.582392, 0.585684, 0.592082, 0.597644, 0.591918, 0.586191, 0.57948, 0.571491, 0.563501, 0.561567, 0.561474, 0.561254, 0.559232, 0.557211, 0.556474, 0.558344, 0.560213, 0.566605, 0.576549, 0.586493, 0.591248, 0.594311, 0.597374, 0.605384, 0.613859, 0.622221, 0.627623, 0.633026, 0.636913, 0.630095, 0.623278, 0.612812, 0.585022, 0.557233, 0.527461, 0.489072, 0.450683, 0.407873, 0.34236, 0.276846, 0.216477, 0.201901, 0.187326, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMFL2Glow = [0, 0, 0, 0, 0, 0.00489478, 0.00475136, 0.00476134, 0.00437406, 0.00481719, 0.0044613, 0.00438739, 0.0054681, 0.00495262, 0.00477627, 0.00500905, 0.00549828, 0.00466978, 0.00398147, 0.00443728, 0.00419165, 0.00509741, 0.00527944, 0.00438667, 0.00514632, 0.0042498, 0.00519129, 0.00533211, 0.00537959, 0.00553042, 0.00574871, 0.00761272, 0.00838319, 0.0113318, 0.0238042, 0.0529459, 0.274131, 0.501254, 0.470186, 0.116095, 0.0263988, 0.0230099, 0.0185055, 0.0205172, 0.0218976, 0.02064, 0.0198805, 0.0234735, 0.0235036, 0.0274585, 0.0291338, 0.0259225, 0.0263312, 0.030024, 0.0321479, 0.0307932, 0.0330332, 0.0379532, 0.0381539, 0.0360305, 0.0364994, 0.0363941, 0.0344003, 0.0385319, 0.0394078, 0.0397222, 0.0419039, 0.0450161, 0.0491205, 0.0461492, 0.0430855, 0.0392739, 0.0347575, 0.0327697, 0.0391151, 0.0393386, 0.0411981, 0.0450316, 0.0464986, 0.0434849, 0.0400653, 0.0392084, 0.0400226, 0.0391567, 0.0405504, 0.0441132, 0.0416109, 0.0372519, 0.0397111, 0.0438525, 0.0445418, 0.0454617, 0.0483701, 0.0482233, 0.0439352, 0.0377007, 0.0347146, 0.0352493, 0.0372047, 0.038496, 0.0377575, 0.0356701, 0.0341871, 0.0337086, 0.0342724, 0.0359157, 0.0359467, 0.0384734, 0.0378001, 0.0370925, 0.038083, 0.0371602, 0.0365076, 0.0380377, 0.0410367, 0.0441894, 0.0434359, 0.0415462, 0.0405564, 0.0414328, 0.0441183, 0.0451111, 0.0472867, 0.0492293, 0.0505487, 0.0520444, 0.0525343, 0.0537904, 0.055203, 0.0542041, 0.0558056, 0.0576251, 0.0592113, 0.0616037, 0.0723451, 0.0934428, 0.133782, 0.157779, 0.168935, 0.16325, 0.159085, 0.169174, 0.203035, 0.30315, 0.409809, 0.507282, 0.509259, 0.456404, 0.298397, 0.181652, 0.0912287, 0.0765467, 0.0707299, 0.0796883, 0.0823918, 0.0825957, 0.080574, 0.0782313, 0.0753257, 0.074516, 0.0748349, 0.072293, 0.0691658, 0.0643305, 0.0606461, 0.0588315, 0.0557673, 0.0517981, 0.0508707, 0.0509251, 0.0549626, 0.0599494, 0.0785045, 0.102374, 0.157578, 0.209209, 0.248669, 0.276596, 0.275446, 0.262114, 0.222533, 0.200402, 0.214678, 0.234344, 0.266238, 0.294062, 0.310481, 0.328856, 0.355409, 0.385871, 0.452725, 0.519579, 0.557122, 0.593882, 0.574084, 0.542205, 0.481385, 0.404704, 0.35529, 0.340437, 0.33215, 0.34902, 0.36589, 0.391237, 0.417077, 0.443378, 0.469925, 0.49269, 0.50788, 0.52307, 0.523722, 0.524123, 0.528817, 0.536348, 0.546951, 0.570484, 0.594016, 0.593065, 0.583954, 0.565313, 0.521923, 0.478534, 0.449854, 0.425469, 0.40269, 0.38505, 0.36741, 0.346825, 0.324789, 0.302101, 0.270626, 0.239151, 0.215982, 0.203602, 0.191221, 0.183096, 0.176265, 0.169884, 0.169884, 0.169884, 0.1734, 0.184055, 0.194709, 0.197029, 0.1928, 0.188571, 0.177307, 0.163746, 0.150186, 0.13867, 0.127345, 0.115991, 0.103858, 0.0917247, 0.0802698, 0.073606, 0.0669422, 0.0605739, 0.0556086, 0.0506432, 0.0459069, 0.042166, 0.0384252, 0.0348552, 0.0321624, 0.0294696, 0.026962, 0.0261027, 0.0252434, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMFL2 = [0, 0, 0, 0, 0, 0.0807585, 0.585722, 0.240959, 0.396632, 0.183994, 0.132348, 0.152007, 0.17169, 0.183678, 0.203358, 0.228594, 0.245499, 0.259186, 0.270391, 0.297797, 0.307388, 0.324531, 0.339122, 0.351744, 0.364768, 0.378216, 0.387022, 0.402165, 0.427881, 0.455335, 0.479776, 0.513946, 0.53223, 0.531016, 0.54607, 0.624115, 0.727326, 0.91005, 0.687226, 0.594375, 0.563791, 0.55017, 0.541183, 0.53888, 0.53663, 0.539317, 0.540947, 0.541354, 0.538341, 0.536762, 0.536631, 0.536013, 0.535782, 0.535025, 0.534913, 0.53468, 0.531911, 0.53351, 0.529547, 0.52672, 0.527811, 0.524353, 0.527555, 0.522851, 0.518838, 0.519564, 0.5241, 0.522702, 0.514211, 0.513964, 0.505896, 0.489518, 0.471673, 0.45585, 0.448844, 0.437933, 0.422341, 0.412136, 0.401751, 0.396507, 0.389238, 0.375957, 0.361123, 0.352175, 0.34562, 0.335615, 0.32745, 0.319798, 0.31432, 0.303592, 0.295222, 0.405419, 0.420952, 0.27079, 0.217506, 0.252247, 0.247818, 0.200545, 0.162022, 0.145445, 0.140841, 0.142177, 0.146496, 0.149318, 0.149945, 0.150592, 0.15105, 0.154537, 0.158711, 0.163298, 0.166074, 0.168642, 0.168887, 0.167126, 0.166192, 0.165015, 0.163891, 0.163113, 0.164073, 0.166722, 0.169792, 0.172015, 0.171655, 0.17297, 0.176891, 0.180304, 0.182229, 0.185881, 0.19183, 0.200413, 0.209009, 0.216016, 0.221867, 0.235365, 0.255704, 0.275869, 0.285108, 0.28809, 0.286803, 0.280302, 0.275503, 0.298575, 0.368458, 0.527799, 0.65325, 0.677562, 0.634675, 0.562727, 0.453953, 0.373172, 0.310216, 0.292141, 0.278114, 0.270832, 0.262023, 0.25276, 0.245684, 0.241603, 0.242777, 0.241096, 0.237877, 0.226939, 0.216285, 0.210884, 0.208562, 0.211242, 0.212176, 0.211846, 0.209604, 0.206746, 0.20827, 0.213328, 0.294662, 0.379452, 0.484618, 0.566423, 0.568674, 0.572072, 0.578359, 0.565525, 0.51149, 0.44893, 0.368582, 0.321156, 0.348399, 0.370559, 0.378477, 0.386339, 0.393966, 0.406767, 0.467724, 0.528681, 0.558327, 0.587136, 0.552548, 0.504419, 0.450587, 0.393629, 0.35921, 0.353358, 0.351221, 0.363312, 0.375404, 0.385148, 0.394755, 0.413528, 0.437171, 0.457187, 0.469938, 0.482689, 0.4959, 0.509118, 0.518875, 0.526343, 0.535837, 0.553852, 0.571866, 0.586971, 0.601106, 0.598926, 0.554372, 0.509818, 0.463551, 0.416783, 0.378164, 0.365634, 0.353104, 0.337559, 0.32053, 0.302853, 0.276436, 0.250019, 0.225543, 0.20359, 0.181636, 0.167898, 0.156655, 0.146002, 0.143705, 0.141408, 0.140169, 0.141076, 0.141984, 0.142865, 0.143725, 0.144584, 0.147239, 0.150479, 0.153718, 0.140101, 0.124897, 0.109751, 0.0960989, 0.0824469, 0.0697713, 0.0639938, 0.0582162, 0.0528202, 0.049235, 0.0456498, 0.0419236, 0.0375843, 0.0332449, 0.030282, 0.0343869, 0.0384917, 0.0429549, 0.0506074, 0.05826, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMFLCL42053 = [0, 0, 0, 0, 0, 0.665942, 0.5014, 0.561605, 0.444193, 0.485823, 0.468655, 0.456392, 0.425889, 0.42991, 0.442354, 0.466794, 0.491763, 0.51616, 0.523966, 0.534496, 0.541358, 0.542375, 0.54901, 0.555844, 0.560287, 0.5661, 0.576156, 0.597202, 0.609673, 0.612068, 0.608717, 0.655319, 0.764735, 0.964711, 0.95131, 0.801622, 0.679736, 0.627618, 0.634033, 0.618285, 0.60456, 0.602417, 0.609703, 0.615348, 0.617467, 0.620082, 0.621107, 0.620642, 0.621196, 0.621675, 0.622942, 0.628357, 0.634616, 0.642989, 0.649693, 0.652703, 0.651525, 0.656302, 0.658156, 0.653726, 0.640035, 0.622001, 0.61274, 0.603346, 0.594428, 0.588668, 0.585493, 0.576921, 0.576634, 0.583461, 0.579972, 0.565654, 0.559929, 0.562422, 0.567534, 0.571916, 0.580281, 0.58726, 0.591077, 0.59486, 0.602535, 0.603509, 0.600762, 0.5913, 0.581967, 0.634816, 0.638168, 0.585839, 0.552303, 0.591991, 0.606406, 0.578365, 0.563045, 0.562038, 0.562045, 0.560621, 0.551954, 0.541537, 0.534155, 0.530814, 0.531289, 0.535281, 0.541834, 0.54809, 0.551565, 0.551986, 0.549842, 0.548399, 0.546334, 0.544666, 0.541308, 0.542337, 0.542628, 0.539732, 0.536786, 0.533255, 0.528146, 0.525916, 0.525884, 0.527539, 0.530686, 0.531361, 0.529437, 0.525278, 0.523523, 0.539515, 0.547287, 0.553394, 0.549756, 0.509098, 0.493523, 0.540893, 0.658775, 0.830243, 0.896685, 0.889479, 0.814726, 0.729633, 0.638693, 0.541441, 0.482149, 0.448344, 0.447879, 0.43999, 0.429527, 0.416269, 0.411711, 0.407447, 0.39442, 0.378207, 0.35999, 0.341791, 0.326726, 0.316884, 0.30783, 0.29895, 0.28789, 0.278671, 0.272684, 0.316197, 0.386364, 0.459122, 0.527009, 0.567869, 0.575485, 0.529089, 0.431091, 0.295724, 0.221805, 0.167717, 0.162355, 0.16191, 0.162414, 0.163728, 0.169809, 0.177506, 0.190702, 0.195578, 0.179475, 0.158489, 0.126981, 0.101241, 0.0875388, 0.0788124, 0.0813717, 0.0824211, 0.0792394, 0.0762736, 0.0742107, 0.0722491, 0.0712308, 0.0702125, 0.0688878, 0.0675549, 0.0662741, 0.0650045, 0.0642458, 0.063767, 0.0631519, 0.0623642, 0.0614129, 0.0598349, 0.0582568, 0.0574859, 0.056762, 0.0549259, 0.0524988, 0.0511221, 0.0518495, 0.0525769, 0.0523402, 0.0520868, 0.0515715, 0.050883, 0.0500857, 0.0488298, 0.047574, 0.0467261, 0.0460143, 0.0457626, 0.0467063, 0.04765, 0.0482316, 0.0487073, 0.0523968, 0.0663756, 0.0803544, 0.100003, 0.122445, 0.145267, 0.173231, 0.201195, 0.228724, 0.25569, 0.282656, 0.303901, 0.323409, 0.341916, 0.346272, 0.350627, 0.351359, 0.344733, 0.338108, 0.329343, 0.318898, 0.308452, 0.29192, 0.273403, 0.254885, 0.243678, 0.233158, 0.222812, 0.216995, 0.211178, 0.206058, 0.205853, 0.205649, 0.207694, 0.220419, 0.233144, 0.250739, 0.289511, 0.328282, 0.363386, 0.379658, 0.39593, 0.406395, 0.365182, 0.323968, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMFLCobaltGlass = [0, 0, 0, 0, 0, 0.977926, 0.644943, 0.625802, 0.587028, 0.597675, 0.603276, 0.599978, 0.606474, 0.607908, 0.613072, 0.612002, 0.616045, 0.617519, 0.616425, 0.624311, 0.620939, 0.625582, 0.627694, 0.63035, 0.625619, 0.627867, 0.638061, 0.668863, 0.68303, 0.720004, 0.874825, 0.979054, 0.989827, 0.98493, 0.980522, 0.899772, 0.773593, 0.748063, 0.729211, 0.731766, 0.727701, 0.720152, 0.705749, 0.686977, 0.675204, 0.662859, 0.65467, 0.652599, 0.64457, 0.630974, 0.622207, 0.618678, 0.61714, 0.617135, 0.61232, 0.607921, 0.603563, 0.599478, 0.591699, 0.585816, 0.582473, 0.578786, 0.580069, 0.585632, 0.588313, 0.591204, 0.598007, 0.602911, 0.602267, 0.603355, 0.602114, 0.598901, 0.594733, 0.591112, 0.591336, 0.5927, 0.593171, 0.593892, 0.594217, 0.596454, 0.596097, 0.586711, 0.576416, 0.574317, 0.616304, 0.6412, 0.569062, 0.515835, 0.550902, 0.579586, 0.534977, 0.518098, 0.511488, 0.487423, 0.463, 0.447222, 0.420392, 0.383784, 0.341408, 0.319537, 0.317552, 0.316044, 0.311729, 0.305454, 0.29719, 0.288379, 0.277345, 0.269679, 0.26344, 0.254273, 0.243189, 0.233515, 0.224381, 0.215947, 0.209089, 0.198411, 0.188492, 0.180209, 0.175528, 0.175336, 0.179417, 0.184461, 0.187817, 0.191998, 0.202522, 0.23489, 0.232828, 0.228809, 0.226327, 0.21952, 0.239211, 0.326722, 0.481644, 0.591803, 0.605911, 0.557798, 0.46373, 0.381196, 0.321626, 0.300453, 0.290965, 0.283251, 0.275508, 0.274099, 0.273877, 0.273942, 0.266645, 0.257145, 0.247437, 0.238395, 0.229775, 0.222064, 0.215657, 0.211421, 0.208031, 0.205353, 0.209515, 0.224771, 0.259492, 0.384402, 0.557876, 0.621909, 0.662199, 0.629991, 0.547952, 0.384951, 0.255005, 0.148994, 0.127552, 0.133404, 0.132691, 0.131469, 0.133938, 0.138564, 0.155917, 0.169125, 0.16822, 0.161286, 0.13915, 0.119578, 0.105527, 0.0946963, 0.0905855, 0.0871302, 0.0851614, 0.0850454, 0.0901217, 0.097144, 0.112304, 0.128419, 0.153427, 0.178435, 0.224342, 0.270806, 0.30297, 0.332078, 0.357937, 0.382015, 0.387247, 0.368591, 0.340371, 0.275513, 0.210656, 0.167413, 0.125429, 0.104789, 0.0954922, 0.088657, 0.086753, 0.0848489, 0.0799594, 0.0750183, 0.0706531, 0.0666685, 0.0633186, 0.0626392, 0.0619598, 0.0617746, 0.0617543, 0.0626606, 0.0659735, 0.0692865, 0.0705262, 0.0711607, 0.0715602, 0.0712078, 0.0708554, 0.0710111, 0.071417, 0.071999, 0.0749576, 0.0779162, 0.0798993, 0.0806154, 0.0813315, 0.0794281, 0.0767291, 0.0740966, 0.072406, 0.0707154, 0.0703254, 0.0725761, 0.0748267, 0.0772719, 0.0798699, 0.082468, 0.0847222, 0.0868643, 0.0890064, 0.096538, 0.104577, 0.112964, 0.130413, 0.147862, 0.166871, 0.1969, 0.22693, 0.259735, 0.30572, 0.351705, 0.402872, 0.476575, 0.550277, 0.609051, 0.591171, 0.57329, 0.553963, 0.521764, 0.489564, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMFLRedGlass = [0, 0, 0, 0, 0, 0.0620987, 0.0617396, 0.0593607, 0.0561589, 0.0531647, 0.0462101, 0.0474033, 0.0464002, 0.044545, 0.0459875, 0.0478632, 0.0537771, 0.0581627, 0.0614135, 0.0572903, 0.0571142, 0.0569747, 0.05491, 0.0517348, 0.051081, 0.0505839, 0.0498791, 0.0471091, 0.0456361, 0.044978, 0.0438914, 0.0404224, 0.0404224, 0.0404224, 0.0404224, 0.0399492, 0.0376069, 0.0376069, 0.0376069, 0.0376069, 0.0353017, 0.0329814, 0.0329814, 0.0329814, 0.0329814, 0.0342824, 0.0355958, 0.0355958, 0.0355958, 0.0355958, 0.0355958, 0.0355958, 0.0351159, 0.0347914, 0.0343309, 0.0339869, 0.0338864, 0.0338864, 0.0338864, 0.0338864, 0.0338864, 0.0336064, 0.0314731, 0.0314731, 0.0314731, 0.0314731, 0.0314731, 0.0302828, 0.0259427, 0.0259427, 0.0259427, 0.0259427, 0.0259427, 0.0259427, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.022725, 0.0220792, 0.0201106, 0.0201106, 0.0201106, 0.0201106, 0.0201106, 0.0201106, 0.0201106, 0.0199184, 0.0198411, 0.0223123, 0.0261503, 0.0298816, 0.0335739, 0.0391951, 0.0429362, 0.0430152, 0.0431373, 0.0444391, 0.048823, 0.0502765, 0.0502765, 0.0516902, 0.0557987, 0.0574158, 0.0587291, 0.0607638, 0.0616674, 0.0628866, 0.0643281, 0.0665297, 0.0681416, 0.0690183, 0.0700342, 0.0699944, 0.06921, 0.0691042, 0.0701412, 0.0718286, 0.0744223, 0.0778265, 0.081399, 0.0833968, 0.0845741, 0.0841181, 0.0829958, 0.0938152, 0.0995133, 0.103338, 0.10916, 0.1136, 0.117918, 0.122649, 0.128173, 0.134277, 0.141155, 0.147619, 0.154085, 0.160698, 0.167694, 0.175275, 0.184699, 0.196413, 0.209577, 0.224536, 0.239245, 0.253536, 0.264097, 0.273312, 0.283718, 0.298316, 0.32027, 0.333175, 0.341206, 0.35724, 0.374521, 0.394513, 0.407048, 0.407466, 0.404588, 0.399324, 0.408946, 0.423373, 0.427961, 0.430529, 0.407593, 0.39218, 0.421119, 0.456429, 0.513433, 0.554212, 0.554084, 0.546712, 0.52373, 0.499001, 0.470624, 0.448844, 0.442028, 0.434059, 0.422862, 0.415382, 0.423441, 0.433652, 0.463894, 0.494136, 0.602814, 0.713586, 0.766616, 0.807312, 0.839321, 0.866569, 0.889344, 0.906448, 0.907713, 0.848301, 0.788889, 0.757554, 0.727853, 0.683669, 0.631788, 0.598096, 0.600835, 0.603573, 0.608706, 0.613879, 0.616327, 0.616974, 0.61803, 0.620809, 0.623588, 0.622941, 0.621151, 0.619262, 0.617113, 0.614965, 0.613006, 0.611103, 0.61113, 0.617337, 0.623543, 0.632222, 0.642119, 0.650901, 0.64464, 0.638379, 0.62989, 0.618508, 0.607126, 0.599506, 0.593028, 0.586442, 0.57832, 0.570198, 0.560467, 0.547472, 0.534476, 0.522818, 0.512211, 0.501604, 0.484699, 0.465739, 0.446779, 0.431811, 0.417219, 0.402637, 0.388312, 0.373987, 0.360523, 0.353143, 0.345764, 0.338485, 0.331685, 0.324885, 0.319667, 0.32133, 0.322992, 0.326774, 0.341437, 0.356099, 0.369667, 0.373494, 0.37732, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMSBFL = [0, 0, 0, 0, 0, 0.048068, 0.215733, 0.085038, 0.0485169, 0.163196, 0.0354679, 0.0473972, 0.0546814, 0.0700908, 0.0910821, 0.115389, 0.136714, 0.158132, 0.172013, 0.207267, 0.230639, 0.256645, 0.278137, 0.29782, 0.320752, 0.343089, 0.363738, 0.387566, 0.411542, 0.43487, 0.453568, 0.484693, 0.510766, 0.521064, 0.528492, 0.576181, 0.647353, 0.799662, 0.578188, 0.577165, 0.544166, 0.54386, 0.54214, 0.54248, 0.537692, 0.539805, 0.542103, 0.544371, 0.546725, 0.54488, 0.544601, 0.54649, 0.543995, 0.544132, 0.545817, 0.546445, 0.548893, 0.549567, 0.550918, 0.55349, 0.553978, 0.553145, 0.557108, 0.558612, 0.561507, 0.56674, 0.572719, 0.576888, 0.583674, 0.587057, 0.582507, 0.577516, 0.568315, 0.558481, 0.547961, 0.536467, 0.52367, 0.514867, 0.503318, 0.502073, 0.492136, 0.48141, 0.479766, 0.46952, 0.457445, 0.443409, 0.436323, 0.421372, 0.412192, 0.401509, 0.398807, 0.43797, 0.434255, 0.370806, 0.338668, 0.333971, 0.321292, 0.308987, 0.293931, 0.280869, 0.268262, 0.256487, 0.248257, 0.245513, 0.24933, 0.253547, 0.258245, 0.26521, 0.269655, 0.274924, 0.278545, 0.282871, 0.28786, 0.292348, 0.295748, 0.299657, 0.306127, 0.309758, 0.312834, 0.316177, 0.319057, 0.323029, 0.324072, 0.324986, 0.32699, 0.329981, 0.331819, 0.33531, 0.33954, 0.340651, 0.342459, 0.345218, 0.348933, 0.352968, 0.354583, 0.359045, 0.375955, 0.375634, 0.372193, 0.370866, 0.360811, 0.358601, 0.371959, 0.499272, 0.608305, 0.640202, 0.60758, 0.545813, 0.443837, 0.387553, 0.360139, 0.361805, 0.360869, 0.355598, 0.353995, 0.353745, 0.352793, 0.351441, 0.349387, 0.347952, 0.34685, 0.346154, 0.345466, 0.344618, 0.343657, 0.342512, 0.341551, 0.340725, 0.331839, 0.320351, 0.30848, 0.297666, 0.313858, 0.341299, 0.435062, 0.51093, 0.525861, 0.539643, 0.550531, 0.548212, 0.517436, 0.481456, 0.434617, 0.411396, 0.44174, 0.465438, 0.470514, 0.473801, 0.469603, 0.466967, 0.478879, 0.490791, 0.510074, 0.529553, 0.5264, 0.518413, 0.506189, 0.491642, 0.489653, 0.503583, 0.51716, 0.529385, 0.54161, 0.539815, 0.537205, 0.53661, 0.537087, 0.535852, 0.531188, 0.526524, 0.515755, 0.504881, 0.513225, 0.534274, 0.554326, 0.570179, 0.586032, 0.596768, 0.605798, 0.609879, 0.601104, 0.59233, 0.569524, 0.542621, 0.523151, 0.527478, 0.531805, 0.531588, 0.529133, 0.526469, 0.520991, 0.515513, 0.510574, 0.506334, 0.502094, 0.498879, 0.495975, 0.493133, 0.491167, 0.489201, 0.487369, 0.485808, 0.484247, 0.48345, 0.483253, 0.483055, 0.479964, 0.475927, 0.471891, 0.470889, 0.470172, 0.469294, 0.464202, 0.459111, 0.453491, 0.444134, 0.434778, 0.425318, 0.41537, 0.405423, 0.394699, 0.3806, 0.366501, 0.351273, 0.330239, 0.309206, 0.289501, 0.281621, 0.273742, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPMSB = [0, 0, 0, 0, 0, 0.0355671, 0.375443, 0.0503767, 0.0957265, 0.0640301, 0.0536391, 0.0836635, 0.0940995, 0.119347, 0.146123, 0.17114, 0.198017, 0.221455, 0.238054, 0.265351, 0.288214, 0.317964, 0.339102, 0.3588, 0.382248, 0.406158, 0.423482, 0.442367, 0.449517, 0.473469, 0.501764, 0.533183, 0.53559, 0.528545, 0.537829, 0.599735, 0.627884, 0.846823, 0.573646, 0.579058, 0.550853, 0.551372, 0.545522, 0.545286, 0.546409, 0.544946, 0.54638, 0.546064, 0.546609, 0.547318, 0.547012, 0.54469, 0.546009, 0.550194, 0.547224, 0.549069, 0.552576, 0.554374, 0.553227, 0.55394, 0.560508, 0.562827, 0.567733, 0.573883, 0.577772, 0.575473, 0.578571, 0.573498, 0.561721, 0.562299, 0.552592, 0.54704, 0.535605, 0.520108, 0.504379, 0.492727, 0.483652, 0.475975, 0.466297, 0.467509, 0.459495, 0.448563, 0.438097, 0.435337, 0.43271, 0.42594, 0.421842, 0.415229, 0.405317, 0.390344, 0.371696, 0.414483, 0.417706, 0.348562, 0.321415, 0.325328, 0.320679, 0.305725, 0.290108, 0.285073, 0.290353, 0.299432, 0.30513, 0.309386, 0.316726, 0.322036, 0.3286, 0.335177, 0.341058, 0.346917, 0.352584, 0.35822, 0.363576, 0.368528, 0.372994, 0.376021, 0.380196, 0.382817, 0.38532, 0.387799, 0.38912, 0.390272, 0.391711, 0.393121, 0.394496, 0.396298, 0.397818, 0.399327, 0.400613, 0.400909, 0.400955, 0.400819, 0.400625, 0.401554, 0.4003, 0.400584, 0.408916, 0.402727, 0.397958, 0.402689, 0.397199, 0.388988, 0.37882, 0.417333, 0.485957, 0.600384, 0.607332, 0.566274, 0.460345, 0.410344, 0.395572, 0.394986, 0.393398, 0.390137, 0.392949, 0.397626, 0.394623, 0.39223, 0.390909, 0.391427, 0.392935, 0.394661, 0.396084, 0.395801, 0.395211, 0.394122, 0.393537, 0.393317, 0.389682, 0.384946, 0.375546, 0.366127, 0.367773, 0.373514, 0.403397, 0.43526, 0.473866, 0.504673, 0.515817, 0.516991, 0.496684, 0.477919, 0.462373, 0.453067, 0.457915, 0.466528, 0.485691, 0.500744, 0.498609, 0.496886, 0.498994, 0.501101, 0.50168, 0.502218, 0.505736, 0.509891, 0.513454, 0.516692, 0.520368, 0.524598, 0.529108, 0.534687, 0.540266, 0.545507, 0.550727, 0.551718, 0.550461, 0.54973, 0.550051, 0.550372, 0.548634, 0.54686, 0.544597, 0.542009, 0.539338, 0.536312, 0.533286, 0.527129, 0.519929, 0.513721, 0.510087, 0.506452, 0.504649, 0.50338, 0.50218, 0.501201, 0.500222, 0.498345, 0.496025, 0.493468, 0.487704, 0.48194, 0.477544, 0.474924, 0.472305, 0.469824, 0.467386, 0.464789, 0.459956, 0.455124, 0.451245, 0.449303, 0.447361, 0.444389, 0.440608, 0.436827, 0.432306, 0.427545, 0.422783, 0.418971, 0.415249, 0.411394, 0.404093, 0.396792, 0.388939, 0.377179, 0.365419, 0.353126, 0.338297, 0.323469, 0.308313, 0.291737, 0.275161, 0.258247, 0.239594, 0.220942, 0.20358, 0.197711, 0.191842, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPS = [0, 0, 0, 0, 0, 0.00560225, 0, 0, 0, 0.00160885, 0.00160885, 0.00160885, 0.000804424, 0.000804424, 0.000804424, 0.00180995, 0.00180995, 0.00180995, 0.0024976, 0.00784314, 0.00784314, 0.00784314, 0.00816363, 0.00990289, 0.0152618, 0.0195354, 0.0241208, 0.037402, 0.0412693, 0.0458065, 0.0544957, 0.0664592, 0.0868188, 0.105304, 0.120087, 0.139089, 0.19943, 0.22039, 0.206404, 0.21619, 0.226373, 0.236773, 0.246176, 0.249925, 0.253602, 0.26246, 0.287904, 0.321621, 0.366004, 0.40788, 0.448919, 0.490024, 0.512495, 0.499441, 0.483948, 0.481129, 0.458969, 0.421937, 0.378422, 0.34151, 0.325769, 0.326385, 0.355259, 0.403971, 0.465278, 0.502993, 0.540095, 0.561098, 0.589072, 0.59475, 0.554883, 0.542953, 0.503298, 0.453695, 0.390166, 0.364373, 0.412944, 0.301736, 0.18543, 0.160581, 0.144609, 0.141725, 0.143366, 0.146151, 0.151551, 0.157767, 0.163578, 0.162894, 0.1697, 0.173823, 0.194106, 0.217504, 0.210898, 0.201842, 0.218787, 0.260167, 0.329016, 0.502777, 0.639621, 0.595694, 0.415606, 0.269192, 0.210183, 0.18389, 0.170363, 0.163031, 0.155611, 0.154648, 0.157252, 0.162988, 0.170296, 0.17808, 0.192722, 0.261573, 0.418759, 0.532007, 0.298531, 0.19841, 0.18124, 0.187343, 0.181444, 0.183231, 0.189502, 0.193792, 0.194135, 0.193407, 0.196217, 0.20059, 0.205621, 0.209802, 0.213419, 0.215979, 0.217724, 0.22258, 0.224514, 0.22534, 0.227188, 0.231011, 0.235873, 0.241796, 0.249664, 0.259128, 0.270792, 0.282409, 0.299865, 0.32946, 0.337934, 0.342846, 0.357929, 0.378236, 0.401742, 0.408374, 0.408508, 0.397813, 0.392843, 0.390355, 0.393298, 0.396185, 0.398974, 0.403116, 0.407987, 0.410834, 0.413773, 0.418185, 0.425478, 0.437454, 0.466416, 0.507679, 0.516842, 0.515644, 0.476921, 0.435965, 0.432541, 0.430624, 0.437597, 0.442582, 0.440796, 0.439546, 0.439649, 0.438799, 0.435898, 0.441073, 0.463096, 0.495219, 0.550245, 0.572019, 0.500612, 0.427682, 0.348381, 0.281637, 0.331796, 0.381954, 0.410977, 0.439435, 0.457474, 0.473286, 0.4647, 0.442742, 0.428066, 0.42262, 0.422336, 0.441828, 0.461321, 0.469483, 0.476985, 0.481201, 0.483671, 0.485811, 0.487287, 0.488763, 0.491881, 0.495028, 0.505749, 0.521479, 0.535919, 0.544937, 0.553955, 0.55566, 0.554928, 0.555052, 0.557401, 0.55975, 0.565391, 0.571992, 0.576907, 0.576417, 0.575928, 0.573746, 0.570731, 0.567562, 0.562332, 0.557103, 0.552845, 0.549848, 0.546852, 0.544084, 0.541385, 0.538674, 0.535788, 0.532903, 0.529113, 0.523486, 0.51786, 0.513538, 0.510241, 0.506945, 0.500087, 0.492068, 0.484049, 0.479206, 0.474663, 0.470077, 0.464399, 0.45872, 0.452953, 0.446562, 0.440171, 0.432654, 0.419795, 0.406936, 0.393879, 0.379963, 0.366047, 0.351265, 0.332038, 0.31281, 0.294796, 0.287582, 0.280367, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    HPX = [0, 0, 0, 0, 0, 0.115701, 0.195172, 0.282326, 0.364907, 0.429698, 0.466305, 0.514776, 0.527527, 0.531181, 0.531352, 0.534788, 0.543369, 0.549467, 0.558653, 0.563018, 0.570577, 0.576856, 0.581252, 0.589495, 0.599042, 0.606523, 0.609724, 0.617056, 0.623728, 0.629923, 0.64045, 0.648683, 0.653231, 0.658323, 0.663096, 0.665676, 0.671539, 0.675361, 0.678924, 0.683428, 0.68858, 0.69373, 0.704959, 0.719434, 0.730557, 0.720266, 0.70092, 0.676789, 0.64626, 0.642377, 0.643647, 0.631211, 0.62761, 0.620619, 0.612735, 0.613819, 0.603043, 0.607169, 0.603554, 0.602109, 0.600209, 0.610126, 0.619946, 0.629986, 0.633874, 0.642814, 0.658331, 0.673275, 0.678297, 0.672871, 0.66913, 0.670287, 0.671494, 0.669636, 0.661316, 0.661396, 0.660527, 0.660911, 0.664871, 0.668641, 0.669282, 0.666599, 0.66311, 0.656942, 0.650669, 0.644751, 0.641459, 0.640036, 0.639835, 0.641044, 0.642677, 0.642897, 0.640133, 0.636619, 0.63517, 0.635446, 0.635421, 0.633064, 0.631186, 0.632128, 0.633255, 0.634409, 0.635184, 0.631654, 0.624996, 0.621458, 0.620462, 0.621322, 0.621412, 0.620545, 0.620573, 0.620291, 0.619967, 0.61967, 0.618671, 0.616065, 0.614042, 0.611274, 0.607687, 0.603788, 0.600431, 0.597691, 0.592503, 0.587352, 0.582786, 0.576881, 0.571994, 0.566553, 0.559871, 0.550622, 0.53933, 0.527538, 0.515391, 0.500644, 0.486203, 0.473408, 0.465214, 0.459117, 0.454495, 0.451704, 0.45075, 0.448663, 0.444177, 0.442949, 0.442526, 0.442656, 0.441198, 0.439559, 0.439022, 0.4382, 0.4372, 0.436182, 0.435192, 0.434247, 0.434358, 0.434953, 0.437004, 0.437959, 0.436991, 0.437839, 0.439666, 0.43767, 0.436173, 0.43917, 0.436835, 0.425837, 0.410586, 0.392256, 0.377041, 0.362832, 0.361612, 0.362104, 0.372722, 0.385331, 0.409683, 0.432155, 0.448224, 0.463605, 0.477254, 0.487512, 0.490464, 0.493274, 0.49579, 0.498492, 0.501618, 0.504305, 0.505762, 0.508179, 0.514607, 0.520433, 0.520646, 0.520859, 0.520591, 0.52031, 0.522525, 0.525272, 0.526362, 0.526544, 0.525554, 0.523079, 0.520578, 0.517977, 0.515377, 0.508828, 0.50205, 0.496344, 0.491209, 0.486707, 0.483477, 0.480246, 0.473923, 0.467546, 0.462157, 0.457421, 0.452346, 0.44584, 0.439334, 0.431774, 0.423862, 0.416888, 0.412351, 0.407813, 0.404194, 0.400843, 0.396547, 0.389225, 0.381903, 0.373141, 0.36367, 0.354344, 0.346976, 0.339608, 0.331223, 0.321519, 0.311814, 0.303442, 0.295475, 0.287001, 0.271345, 0.255689, 0.24094, 0.228035, 0.21513, 0.204285, 0.195057, 0.18583, 0.173442, 0.160023, 0.146604, 0.136202, 0.126084, 0.115828, 0.102004, 0.0881789, 0.0751364, 0.0676205, 0.0601046, 0.0537296, 0.0527701, 0.0518107, 0.0511084, 0.0515241, 0.0519397, 0.0521217, 0.0511036, 0.0500856, 0.0489477, 0.0467428, 0.0445378, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Incandescent1 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000735544, 0.000820494, 0.000765233, 0.000833077, 0.000879733, 0.000854701, 0.00086602, 0.000453691, 0, 0, 0, 0.000113546, 0.000655931, 0.000778963, 0.000789423, 0.000759454, 0.0024019, 0.00261129, 0.00245587, 0.00263736, 0.00298578, 0.00427146, 0.00433639, 0.00414149, 0.00393565, 0.00507596, 0.00573704, 0.00783715, 0.00849793, 0.00861259, 0.011598, 0.0166031, 0.0209163, 0.0265296, 0.0318991, 0.0352153, 0.0457732, 0.0600826, 0.0695967, 0.078911, 0.0937157, 0.108094, 0.124519, 0.141904, 0.163911, 0.186824, 0.207933, 0.23481, 0.25454, 0.272319, 0.295326, 0.313143, 0.332068, 0.355648, 0.374465, 0.40165, 0.428999, 0.454531, 0.472138, 0.495097, 0.515262, 0.538777, 0.560749, 0.583772, 0.605356, 0.627913, 0.650291, 0.662326, 0.67571, 0.686764, 0.701218, 0.71572, 0.727082, 0.738729, 0.753188, 0.766323, 0.773143, 0.779624, 0.791666, 0.805063, 0.817604, 0.826707, 0.835874, 0.843328, 0.848721, 0.853868, 0.858903, 0.8638, 0.86711, 0.868292, 0.869795, 0.872392, 0.876233, 0.879105, 0.882197, 0.884324, 0.886026, 0.886311, 0.886183, 0.887837, 0.889224, 0.889766, 0.887676, 0.885596, 0.883578, 0.879568, 0.878814, 0.876934, 0.87586, 0.875775, 0.874432, 0.873203, 0.871386, 0.869413, 0.868821, 0.865736, 0.864359, 0.865028, 0.860778, 0.858052, 0.855561, 0.851482, 0.846278, 0.84108, 0.836417, 0.83399, 0.831187, 0.827167, 0.824373, 0.82216, 0.820734, 0.819966, 0.818868, 0.815738, 0.812304, 0.808688, 0.80659, 0.805485, 0.806033, 0.807122, 0.808454, 0.810445, 0.812694, 0.815395, 0.818074, 0.820741, 0.827701, 0.835226, 0.843652, 0.841987, 0.823925, 0.811063, 0.801967, 0.790529, 0.778335, 0.779326, 0.781791, 0.788029, 0.793226, 0.792282, 0.791606, 0.791839, 0.791302, 0.788822, 0.783954, 0.773939, 0.764416, 0.755921, 0.747179, 0.737877, 0.729271, 0.722616, 0.713616, 0.69481, 0.676968, 0.668086, 0.659205, 0.648041, 0.636817, 0.625749, 0.614715, 0.605448, 0.597148, 0.589005, 0.581061, 0.573477, 0.567276, 0.561075, 0.557604, 0.554291, 0.54843, 0.541213, 0.535823, 0.53409, 0.532357, 0.530896, 0.529439, 0.527666, 0.525684, 0.523703, 0.521726, 0.51975, 0.518143, 0.516658, 0.514793, 0.511942, 0.50909, 0.507572, 0.506442, 0.505255, 0.503884, 0.502513, 0.500947, 0.499285, 0.497407, 0.492616, 0.487825, 0.484536, 0.483198, 0.481861, 0.481449, 0.481319, 0.480956, 0.477299, 0.473642, 0.47018, 0.467112, 0.464045, 0.459635, 0.45417, 0.448705, 0.441301, 0.433264, 0.425226, 0.416102, 0.406875, 0.397652, 0.388557, 0.379461, 0.369536, 0.353754, 0.337973, 0.321373, 0.300889, 0.280405, 0.259246, 0.235155, 0.211064, 0.186701, 0.160939, 0.135176, 0.111266, 0.103841, 0.096415, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Incandescent2 = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000677732, 0.000838631, 0.000858396, 0.000721062, 0.000691143, 0.00107533, 0.00131035, 0.0082173, 0.0203234, 0.0247054, 0.0306971, 0.0375875, 0.052151, 0.0655941, 0.0837261, 0.103923, 0.129892, 0.157773, 0.198104, 0.236552, 0.268113, 0.29143, 0.30157, 0.308043, 0.319451, 0.330832, 0.339751, 0.353537, 0.365914, 0.377681, 0.389534, 0.404145, 0.417513, 0.429507, 0.441178, 0.450779, 0.456124, 0.464274, 0.474818, 0.481777, 0.491826, 0.509211, 0.522325, 0.538208, 0.558054, 0.576999, 0.593544, 0.608676, 0.616464, 0.628983, 0.64264, 0.653134, 0.667929, 0.687181, 0.697622, 0.710991, 0.72772, 0.747493, 0.760715, 0.77661, 0.787988, 0.800833, 0.811181, 0.821881, 0.827745, 0.837637, 0.844055, 0.846452, 0.849117, 0.851905, 0.853315, 0.854912, 0.855936, 0.85872, 0.860641, 0.861269, 0.859632, 0.855243, 0.851249, 0.848494, 0.847799, 0.84806, 0.847668, 0.849675, 0.853339, 0.857388, 0.86225, 0.86698, 0.870299, 0.872327, 0.874045, 0.87637, 0.879071, 0.881449, 0.884801, 0.886071, 0.886611, 0.886914, 0.887493, 0.888769, 0.889315, 0.888868, 0.886855, 0.885433, 0.884064, 0.880185, 0.879907, 0.878111, 0.87685, 0.876402, 0.874638, 0.873816, 0.87218, 0.869983, 0.868725, 0.865596, 0.864733, 0.86629, 0.86147, 0.858886, 0.85646, 0.851126, 0.846395, 0.841878, 0.837487, 0.834281, 0.831047, 0.827458, 0.825119, 0.822816, 0.820158, 0.819409, 0.81854, 0.81503, 0.81191, 0.80904, 0.806973, 0.805852, 0.806309, 0.808158, 0.810479, 0.811817, 0.813575, 0.81607, 0.818017, 0.81967, 0.827201, 0.835156, 0.842507, 0.84024, 0.822346, 0.810019, 0.801722, 0.790685, 0.778762, 0.780561, 0.783789, 0.788381, 0.792258, 0.791917, 0.791642, 0.79159, 0.790943, 0.788796, 0.784107, 0.773941, 0.764526, 0.756678, 0.748333, 0.738859, 0.730164, 0.723655, 0.714823, 0.696281, 0.678615, 0.669094, 0.659574, 0.648757, 0.637907, 0.62681, 0.615661, 0.606264, 0.597828, 0.589678, 0.581891, 0.574432, 0.568231, 0.56203, 0.558497, 0.555118, 0.549333, 0.542268, 0.536879, 0.534847, 0.532815, 0.531223, 0.529639, 0.527791, 0.525768, 0.523829, 0.522243, 0.520657, 0.518827, 0.516915, 0.514664, 0.511532, 0.5084, 0.506679, 0.505371, 0.50415, 0.503211, 0.502271, 0.501171, 0.499992, 0.498552, 0.493589, 0.488626, 0.485289, 0.484064, 0.482839, 0.48224, 0.48183, 0.481228, 0.477902, 0.474576, 0.471288, 0.468075, 0.464863, 0.460258, 0.45456, 0.448863, 0.441334, 0.433209, 0.425083, 0.416031, 0.406891, 0.397752, 0.388622, 0.379491, 0.369519, 0.353601, 0.337683, 0.321003, 0.300704, 0.280405, 0.259465, 0.23574, 0.212015, 0.187894, 0.161737, 0.135581, 0.11136, 0.104373, 0.0973849, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    LCDS = [0, 0, 0, 0, 0, 0.0149106, 0.00437268, 0, 0, 0, 0, 0, 0, 0, 0, 0.00201106, 0.00201106, 0.00238371, 0.00343438, 0.00834548, 0.0102697, 0.0129813, 0.0158577, 0.021114, 0.0265338, 0.0304008, 0.0340515, 0.0385504, 0.0527493, 0.0476676, 0.0605837, 0.0798784, 0.0736373, 0.0892648, 0.154478, 0.290616, 0.577132, 0.449538, 0.195532, 0.162836, 0.169705, 0.188498, 0.205804, 0.217667, 0.22893, 0.247209, 0.26121, 0.268852, 0.275944, 0.287237, 0.296753, 0.305717, 0.316763, 0.327209, 0.332454, 0.337538, 0.339015, 0.34019, 0.340972, 0.341461, 0.338842, 0.337593, 0.342454, 0.344783, 0.346835, 0.349554, 0.350821, 0.353766, 0.359984, 0.361674, 0.361273, 0.36273, 0.359903, 0.356226, 0.35439, 0.350292, 0.348883, 0.350558, 0.348691, 0.352585, 0.345324, 0.340607, 0.349702, 0.369999, 0.403521, 0.427518, 0.44786, 0.452075, 0.441209, 0.416978, 0.391516, 0.367557, 0.345447, 0.325335, 0.299563, 0.279359, 0.258211, 0.239931, 0.210548, 0.18103, 0.16038, 0.139848, 0.123025, 0.112031, 0.103257, 0.0980091, 0.0902152, 0.086161, 0.0832881, 0.0804876, 0.0794101, 0.0786419, 0.075001, 0.070225, 0.0687393, 0.0667635, 0.0639819, 0.0602083, 0.0565648, 0.0532548, 0.0497397, 0.0484291, 0.0450149, 0.0445177, 0.0474289, 0.0480808, 0.0435449, 0.0414931, 0.0438621, 0.052926, 0.0667801, 0.0818486, 0.097822, 0.120175, 0.134762, 0.16249, 0.242507, 0.289926, 0.330283, 0.372424, 0.427417, 0.463852, 0.465481, 0.459577, 0.464633, 0.495039, 0.441036, 0.374948, 0.357873, 0.340058, 0.321651, 0.277852, 0.231921, 0.182437, 0.132662, 0.0846802, 0.0700522, 0.0582411, 0.0513732, 0.0465005, 0.0427022, 0.036669, 0.0311036, 0.0290959, 0.0267258, 0.0237667, 0.0226838, 0.0229594, 0.0252492, 0.028189, 0.0302895, 0.0326704, 0.0440317, 0.056239, 0.0734347, 0.104196, 0.18115, 0.243697, 0.269922, 0.291584, 0.303415, 0.323884, 0.362377, 0.399994, 0.435628, 0.46559, 0.479652, 0.491982, 0.497067, 0.497972, 0.459963, 0.421953, 0.428322, 0.435876, 0.397261, 0.348785, 0.316246, 0.292442, 0.286251, 0.302387, 0.308627, 0.276954, 0.245282, 0.241695, 0.239742, 0.255537, 0.280762, 0.302724, 0.318149, 0.333574, 0.447603, 0.563338, 0.60218, 0.590184, 0.564672, 0.482278, 0.399884, 0.373886, 0.366686, 0.357224, 0.341884, 0.326544, 0.310387, 0.293991, 0.274033, 0.242669, 0.211305, 0.194816, 0.185654, 0.176496, 0.167391, 0.158286, 0.144076, 0.123234, 0.102393, 0.0816034, 0.0608301, 0.040944, 0.033612, 0.02628, 0.02108, 0.0202088, 0.0193376, 0.0192352, 0.0197369, 0.0202386, 0.0200283, 0.0195857, 0.0191432, 0.0188336, 0.0185365, 0.0181878, 0.0164964, 0.014805, 0.0131162, 0.011446, 0.00977577, 0.00819995, 0.00707222, 0.00594449, 0.00499656, 0.0048303, 0.00466405, 0.00448742, 0.00425755, 0.00402768, 0.00382102, 0.00382102, 0.00382102, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    LEDB = [0, 0, 0, 0, 0, 0.0380773, 0.09969, 0.18701, 0.268628, 0.354513, 0.445302, 0.503557, 0.545114, 0.566318, 0.583863, 0.593377, 0.60351, 0.613596, 0.625635, 0.632039, 0.647306, 0.656021, 0.660666, 0.665346, 0.668324, 0.670293, 0.677987, 0.681676, 0.696375, 0.710843, 0.726752, 0.742695, 0.766776, 0.794942, 0.821735, 0.84592, 0.863477, 0.885478, 0.895637, 0.898055, 0.89669, 0.902572, 0.913018, 0.921914, 0.930315, 0.937993, 0.94328, 0.950713, 0.955584, 0.961621, 0.964417, 0.96815, 0.971623, 0.973035, 0.973858, 0.97443, 0.974779, 0.974427, 0.97439, 0.974288, 0.972165, 0.968236, 0.962341, 0.955124, 0.945064, 0.936584, 0.929873, 0.922086, 0.906306, 0.89389, 0.879882, 0.864955, 0.850585, 0.83571, 0.822205, 0.80532, 0.787119, 0.76777, 0.748922, 0.738809, 0.721929, 0.703705, 0.695596, 0.6866, 0.67492, 0.66327, 0.653299, 0.646018, 0.637713, 0.632604, 0.626547, 0.621033, 0.615241, 0.609306, 0.604448, 0.590909, 0.571478, 0.548998, 0.526254, 0.510156, 0.496429, 0.480713, 0.467242, 0.452704, 0.435593, 0.423166, 0.407219, 0.396109, 0.388702, 0.379379, 0.367641, 0.358642, 0.352074, 0.344848, 0.334471, 0.322028, 0.312258, 0.305316, 0.297908, 0.288121, 0.275658, 0.26565, 0.257287, 0.249058, 0.240131, 0.229969, 0.220012, 0.211756, 0.204536, 0.195879, 0.185667, 0.176124, 0.167515, 0.157124, 0.148187, 0.139862, 0.131215, 0.123148, 0.11563, 0.10889, 0.103128, 0.0971322, 0.0904862, 0.086813, 0.0834858, 0.0798552, 0.078068, 0.0765579, 0.0740282, 0.0707112, 0.0668962, 0.0625163, 0.0586247, 0.0555472, 0.0538065, 0.052548, 0.0508533, 0.049859, 0.0500938, 0.0498179, 0.0492671, 0.0484869, 0.0475387, 0.0458138, 0.0445015, 0.0438595, 0.0427265, 0.0412381, 0.0411424, 0.0414963, 0.0416507, 0.041785, 0.0419177, 0.0420274, 0.0420012, 0.0418693, 0.0413777, 0.0404595, 0.0384658, 0.0371041, 0.0371041, 0.0364745, 0.0345312, 0.0325951, 0.0306757, 0.029261, 0.029261, 0.0286777, 0.0256553, 0.0229261, 0.0229261, 0.0229261, 0.0212862, 0.0196025, 0.0179367, 0.0162747, 0.0156863, 0.0156863, 0.0149717, 0.0133514, 0.0117351, 0.0101348, 0.00853448, 0.00844646, 0.00844646, 0.0104842, 0.0136048, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0.0156863, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    LPM2 = [0, 0, 0, 0, 0, 0.111898, 0.425656, 0.110874, 0.0405732, 0.0104012, 0.00587718, 0.00507321, 0.00455966, 0.00376998, 0.00462028, 0.00745953, 0.00698637, 0.00694555, 0.00708142, 0.00906144, 0.00921349, 0.00951725, 0.0114729, 0.0129645, 0.0170495, 0.0241265, 0.0333262, 0.0448834, 0.0498659, 0.0688198, 0.0953678, 0.136548, 0.244598, 0.442308, 0.541624, 0.760346, 0.973394, 0.964108, 0.777088, 0.427143, 0.258545, 0.182868, 0.127644, 0.105752, 0.0844517, 0.0684904, 0.060764, 0.0545691, 0.047421, 0.0391642, 0.0339682, 0.0295978, 0.0274128, 0.0251106, 0.0236154, 0.0242269, 0.0218143, 0.0182194, 0.0145726, 0.014209, 0.0138689, 0.0131986, 0.0115673, 0.010656, 0.0108616, 0.0115256, 0.0111646, 0.01167, 0.014025, 0.0137353, 0.0112244, 0.00995094, 0.00888812, 0.00794802, 0.00815947, 0.00788782, 0.00782245, 0.00836302, 0.00944287, 0.0093252, 0.00907864, 0.00831161, 0.00762729, 0.00738087, 0.00762026, 0.007882, 0.00761918, 0.00730492, 0.00692061, 0.00845481, 0.0119315, 0.0303337, 0.0699298, 0.0610984, 0.020654, 0.00609062, 0.00502545, 0.00460354, 0.00441257, 0.00467132, 0.0049327, 0.00500304, 0.00505059, 0.00507793, 0.00501343, 0.00473218, 0.00425845, 0.00416272, 0.00398316, 0.00413816, 0.00431417, 0.0044885, 0.00470433, 0.00486277, 0.00480183, 0.00463368, 0.00454648, 0.00434251, 0.00411845, 0.0040165, 0.00417915, 0.00441742, 0.00530915, 0.00556711, 0.00507651, 0.00534496, 0.00570959, 0.00612691, 0.00661271, 0.00724163, 0.00761799, 0.00806409, 0.00870034, 0.0100215, 0.0128687, 0.0157993, 0.0166709, 0.0179218, 0.0207238, 0.0263063, 0.0442982, 0.0700777, 0.105833, 0.225295, 0.367475, 0.528061, 0.593552, 0.578, 0.35457, 0.182067, 0.0422163, 0.0289532, 0.0206523, 0.0206218, 0.0176685, 0.013773, 0.0127919, 0.0111761, 0.00844654, 0.00707658, 0.0064387, 0.00593953, 0.00540903, 0.00464555, 0.00411977, 0.00398019, 0.00393756, 0.00396512, 0.00409532, 0.00425864, 0.00456677, 0.00511907, 0.0113306, 0.0186104, 0.0321887, 0.0600595, 0.1366, 0.210189, 0.276338, 0.302278, 0.241583, 0.173721, 0.090907, 0.0299398, 0.0185211, 0.00990119, 0.00912396, 0.00820507, 0.0066939, 0.00530174, 0.00501756, 0.00473338, 0.00456656, 0.00440287, 0.00403168, 0.00361617, 0.0033807, 0.0032439, 0.00304832, 0.00277826, 0.0025549, 0.00251045, 0.00246599, 0.00248428, 0.00250622, 0.00259874, 0.00272876, 0.00278699, 0.00270141, 0.00261583, 0.00267665, 0.00274, 0.00272753, 0.00266495, 0.00260252, 0.00254076, 0.00247899, 0.00235677, 0.0022144, 0.00205579, 0.00185501, 0.00165423, 0.00165488, 0.00171436, 0.00190413, 0.00251105, 0.00311797, 0.00326645, 0.00318913, 0.00311319, 0.00305593, 0.00299866, 0.00294992, 0.00291223, 0.00287454, 0.00273727, 0.00256974, 0.00241084, 0.00237409, 0.00233734, 0.00233069, 0.00238514, 0.00243959, 0.00252375, 0.00263126, 0.00273876, 0.0024582, 0.00205104, 0.00164387, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00172014, 0.00235975, 0.00299936, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0.00351936, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    LPS = [0, 0, 0, 0, 0, 0.0106443, 0.00784314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000186662, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00841505, 0.0292801, 0.016676, 0.00614009, 0.00159341, 0.00303825, 0.0055981, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00213449, 0.00201803, 0.00347294, 0.00466457, 0.00482655, 0.00394907, 0.00229141, 0.00314877, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.0104388, 0.0274014, 0.0605658, 0.187075, 0.157079, 0.0496938, 0.0139241, 0.00864127, 0.00590173, 0.00251383, 0.00270669, 0.00335588, 0.00376153, 0.00712827, 0.00775616, 0.00770192, 0.00764203, 0.00826636, 0.012642, 0.0233147, 0.0338239, 0.0294826, 0.0176075, 0.00720936, 0.00231272, 0.00245211, 0.00781335, 0.00418221, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.00113865, 0.00542358, 0.00669578, 0.00605759, 0.0041051, 0.00424621, 0.00561249, 0.00833566, 0.0136221, 0.0192287, 0.0247116, 0.0295704, 0.0341077, 0.0381921, 0.0338605, 0.027147, 0.0207281, 0.0155836, 0.0112452, 0.00791407, 0.00633484, 0.00767555, 0.0119052, 0.0170106, 0.0182594, 0.0203972, 0.0240954, 0.0246358, 0.023476, 0.0294072, 0.0399373, 0.0713531, 0.0978511, 0.116359, 0.183381, 0.285533, 0.387999, 0.490565, 0.340922, 0.170239, 0.103265, 0.0518374, 0.0920746, 0.129868, 0.15934, 0.184776, 0.200036, 0.212953, 0.220824, 0.230737, 0.244913, 0.257168, 0.265068, 0.307581, 0.447093, 0.566881, 0.604205, 0.635599, 0.611799, 0.587999, 0.589089, 0.590843, 0.494848, 0.377974, 0.335644, 0.334162, 0.329612, 0.321173, 0.30728, 0.272495, 0.23771, 0.224645, 0.212843, 0.203441, 0.195315, 0.190435, 0.192061, 0.193687, 0.208349, 0.223236, 0.23441, 0.24313, 0.251117, 0.256017, 0.260917, 0.247437, 0.227831, 0.203717, 0.167897, 0.132077, 0.106244, 0.0833257, 0.0640171, 0.0562642, 0.0485113, 0.0444505, 0.0422082, 0.0400865, 0.0395902, 0.0390939, 0.0380593, 0.0363256, 0.034592, 0.0325461, 0.0304055, 0.0282473, 0.0258401, 0.0234328, 0.0215924, 0.0209027, 0.020213, 0.0197088, 0.0193505, 0.0189922, 0.0181965, 0.0172583, 0.01632, 0.0151851, 0.0140318, 0.0129141, 0.0127242, 0.0125343, 0.0122285, 0.0111037, 0.00997887, 0.00922257, 0.0102156, 0.0112087, 0.0119259, 0.0114438, 0.0109617, 0.0105287, 0.010348, 0.0101674, 0.0100099, 0.0100586, 0.0101072, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    MHD = [0, 0, 0, 0, 0, 0.135948, 0.308779, 0.227368, 0.216189, 0.325642, 0.46354, 0.466322, 0.404913, 0.440133, 0.364574, 0.364155, 0.462402, 0.497137, 0.523825, 0.543778, 0.535471, 0.553987, 0.557893, 0.517134, 0.477859, 0.484039, 0.474507, 0.425234, 0.391407, 0.368808, 0.401423, 0.430345, 0.393187, 0.372252, 0.412266, 0.484239, 0.58143, 0.619171, 0.522354, 0.500603, 0.470296, 0.454357, 0.447568, 0.416415, 0.427982, 0.459191, 0.479481, 0.453495, 0.429402, 0.440362, 0.463316, 0.471413, 0.46215, 0.478426, 0.487435, 0.491562, 0.506467, 0.556085, 0.550347, 0.547807, 0.57511, 0.564365, 0.569345, 0.559579, 0.518967, 0.532444, 0.512052, 0.499066, 0.539472, 0.544944, 0.504643, 0.483857, 0.470868, 0.527167, 0.503589, 0.433469, 0.412075, 0.397616, 0.404475, 0.432195, 0.381764, 0.373684, 0.402735, 0.423404, 0.39177, 0.345196, 0.341639, 0.3638, 0.378068, 0.34933, 0.314217, 0.303037, 0.307288, 0.334692, 0.335327, 0.293384, 0.26786, 0.273615, 0.285196, 0.280428, 0.273532, 0.285351, 0.314411, 0.345703, 0.363343, 0.376378, 0.407186, 0.364923, 0.305219, 0.316136, 0.355815, 0.373231, 0.361916, 0.35177, 0.370656, 0.378644, 0.383457, 0.390623, 0.392445, 0.390201, 0.392879, 0.407096, 0.402699, 0.384893, 0.366182, 0.380372, 0.370157, 0.376507, 0.406432, 0.462664, 0.433891, 0.419445, 0.450853, 0.620679, 0.693364, 0.699218, 0.646571, 0.604959, 0.560994, 0.507382, 0.449144, 0.399393, 0.365233, 0.399636, 0.449576, 0.508215, 0.461412, 0.393778, 0.365004, 0.35148, 0.347543, 0.34378, 0.344011, 0.350897, 0.350741, 0.348004, 0.346874, 0.341935, 0.330313, 0.325208, 0.323613, 0.348459, 0.370867, 0.367558, 0.364159, 0.360614, 0.358645, 0.357819, 0.334857, 0.304751, 0.28813, 0.27379, 0.282418, 0.291539, 0.30357, 0.322939, 0.36729, 0.41238, 0.459334, 0.487708, 0.476054, 0.456382, 0.419982, 0.394789, 0.39501, 0.406256, 0.448396, 0.484639, 0.496225, 0.506609, 0.505803, 0.504998, 0.496368, 0.487529, 0.478155, 0.468668, 0.483294, 0.511134, 0.534795, 0.553159, 0.562261, 0.535878, 0.509495, 0.488766, 0.468366, 0.465391, 0.471675, 0.482884, 0.503958, 0.525031, 0.528316, 0.531294, 0.524768, 0.511959, 0.502324, 0.506051, 0.509777, 0.516261, 0.523664, 0.526788, 0.518797, 0.510806, 0.498658, 0.485295, 0.476986, 0.484856, 0.492727, 0.491025, 0.484607, 0.477845, 0.466431, 0.455016, 0.446559, 0.441942, 0.437325, 0.435164, 0.433749, 0.432053, 0.426375, 0.420697, 0.41627, 0.414382, 0.412495, 0.411233, 0.410462, 0.409692, 0.405925, 0.40118, 0.396436, 0.387515, 0.378201, 0.369333, 0.372095, 0.374856, 0.378628, 0.389535, 0.400442, 0.40872, 0.404512, 0.400304, 0.392294, 0.367754, 0.343215, 0.317386, 0.284941, 0.252496, 0.222437, 0.213617, 0.204798, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    MHN = [0, 0, 0, 0, 0, 0.0133592, 0.182496, 0.0222281, 0.0410257, 0.106376, 0.452651, 0.516696, 0.476951, 0.318174, 0.116847, 0.0717574, 0.0473325, 0.0430737, 0.047619, 0.039717, 0.0421525, 0.0463904, 0.0538702, 0.0628369, 0.0680498, 0.0702346, 0.0742739, 0.0799369, 0.0913094, 0.0987504, 0.110247, 0.12595, 0.112552, 0.128576, 0.244926, 0.40324, 0.496769, 0.637957, 0.461052, 0.169159, 0.0626095, 0.0499198, 0.0609615, 0.0653808, 0.0831921, 0.0857162, 0.080761, 0.0781636, 0.0928417, 0.100529, 0.135638, 0.280796, 0.43113, 0.644811, 0.636648, 0.567668, 0.557073, 0.379158, 0.167839, 0.118446, 0.0982157, 0.0772995, 0.0543886, 0.0515207, 0.0474573, 0.0429434, 0.0497396, 0.0533984, 0.0626483, 0.0632999, 0.0512251, 0.0439727, 0.0426264, 0.0394583, 0.0345968, 0.0295439, 0.0295454, 0.0290462, 0.0250234, 0.0256105, 0.025501, 0.0226259, 0.0276429, 0.0321523, 0.0330172, 0.0309363, 0.0267594, 0.0257592, 0.027819, 0.027644, 0.0277739, 0.0320818, 0.0376632, 0.0362347, 0.029784, 0.0335628, 0.0345144, 0.0495662, 0.107521, 0.126023, 0.0737973, 0.0365891, 0.0350022, 0.0353121, 0.0348663, 0.0342094, 0.036824, 0.0396325, 0.0416525, 0.0438171, 0.0483738, 0.0537308, 0.0600559, 0.0676818, 0.0762415, 0.0849432, 0.0872253, 0.0893131, 0.0956066, 0.106996, 0.12139, 0.131913, 0.129462, 0.123428, 0.115297, 0.0952016, 0.0934013, 0.0967711, 0.10473, 0.122673, 0.154332, 0.175262, 0.190503, 0.316266, 0.469319, 0.591477, 0.577007, 0.543443, 0.509873, 0.485229, 0.396374, 0.296071, 0.193059, 0.186057, 0.243846, 0.403202, 0.464894, 0.455282, 0.278713, 0.18295, 0.138138, 0.123734, 0.113051, 0.108572, 0.0985711, 0.0870201, 0.0849983, 0.0829433, 0.0808301, 0.079789, 0.0793251, 0.0824576, 0.0863676, 0.0926452, 0.10287, 0.119508, 0.147743, 0.184375, 0.261532, 0.351768, 0.277473, 0.187614, 0.120137, 0.0643819, 0.0777506, 0.10765, 0.193842, 0.274386, 0.340688, 0.377776, 0.351919, 0.309892, 0.234129, 0.185721, 0.199354, 0.227818, 0.297841, 0.363233, 0.409264, 0.454657, 0.494111, 0.533564, 0.528258, 0.521757, 0.504464, 0.484867, 0.480698, 0.484985, 0.489912, 0.49565, 0.500689, 0.503045, 0.5054, 0.495145, 0.484155, 0.469262, 0.452293, 0.438866, 0.432533, 0.426201, 0.41914, 0.412066, 0.404717, 0.397186, 0.389623, 0.381923, 0.374223, 0.363786, 0.352438, 0.340538, 0.327205, 0.313873, 0.301822, 0.290145, 0.279723, 0.273321, 0.266919, 0.260507, 0.254089, 0.247778, 0.242891, 0.238005, 0.231596, 0.223211, 0.214825, 0.207974, 0.201589, 0.195153, 0.187986, 0.18082, 0.174862, 0.171359, 0.167856, 0.163967, 0.159774, 0.155581, 0.15156, 0.147595, 0.143629, 0.139407, 0.13516, 0.131022, 0.129711, 0.128399, 0.126834, 0.123476, 0.120118, 0.116712, 0.113077, 0.109442, 0.105535, 0.100447, 0.0953594, 0.0911091, 0.0911584, 0.0912076, 0.0916318, 0.0953932, 0.0991546, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    MHSc = [0, 0, 0, 0, 0, 0.382751, 0.41754, 0.318353, 0.351634, 0.459713, 0.242161, 0.177523, 0.223489, 0.417719, 0.495141, 0.516593, 0.516429, 0.378298, 0.262672, 0.255565, 0.297312, 0.400571, 0.458797, 0.507903, 0.552059, 0.53193, 0.366705, 0.281577, 0.316929, 0.342594, 0.398289, 0.501341, 0.567438, 0.57381, 0.510667, 0.518718, 0.607934, 0.650549, 0.562197, 0.557413, 0.51995, 0.530401, 0.542574, 0.533974, 0.408299, 0.336299, 0.326269, 0.33054, 0.337277, 0.37339, 0.436297, 0.468567, 0.447028, 0.443629, 0.478956, 0.541625, 0.561064, 0.555453, 0.55323, 0.556963, 0.545887, 0.562751, 0.550803, 0.454894, 0.369173, 0.392375, 0.458208, 0.53377, 0.620836, 0.615834, 0.536093, 0.547299, 0.589508, 0.570885, 0.636287, 0.691174, 0.627601, 0.538392, 0.550852, 0.605871, 0.58968, 0.487516, 0.451177, 0.527869, 0.579655, 0.613232, 0.573742, 0.464935, 0.508685, 0.524046, 0.453849, 0.454783, 0.488148, 0.443302, 0.426468, 0.481255, 0.46897, 0.420195, 0.521268, 0.596254, 0.460127, 0.342354, 0.412374, 0.478694, 0.389149, 0.304738, 0.408169, 0.621984, 0.662789, 0.656628, 0.649224, 0.605657, 0.472586, 0.308918, 0.244808, 0.293108, 0.305227, 0.261509, 0.227043, 0.251878, 0.363429, 0.528952, 0.492198, 0.392939, 0.32009, 0.359207, 0.369434, 0.367358, 0.366004, 0.394084, 0.356972, 0.328836, 0.332892, 0.434873, 0.526891, 0.574541, 0.500592, 0.459155, 0.4482, 0.480164, 0.420866, 0.372739, 0.36729, 0.407318, 0.459349, 0.520679, 0.550155, 0.555732, 0.504349, 0.451957, 0.399355, 0.43131, 0.453213, 0.458363, 0.422805, 0.374085, 0.365284, 0.358783, 0.356318, 0.353815, 0.351293, 0.328093, 0.306138, 0.300794, 0.315567, 0.363024, 0.410358, 0.457602, 0.481292, 0.49738, 0.50598, 0.513083, 0.501775, 0.476824, 0.371421, 0.296546, 0.325631, 0.365359, 0.431917, 0.471858, 0.454452, 0.409952, 0.308926, 0.239356, 0.241127, 0.257329, 0.313969, 0.370659, 0.427556, 0.483028, 0.525229, 0.56743, 0.568071, 0.567603, 0.538799, 0.503943, 0.496774, 0.504777, 0.514144, 0.525239, 0.53406, 0.534171, 0.534282, 0.531179, 0.527889, 0.512073, 0.4896, 0.470928, 0.459867, 0.448806, 0.442785, 0.436852, 0.434603, 0.43479, 0.435515, 0.438501, 0.441487, 0.444002, 0.446362, 0.451336, 0.463102, 0.474868, 0.48945, 0.504853, 0.516763, 0.517488, 0.518213, 0.50769, 0.491627, 0.476165, 0.468816, 0.461467, 0.444855, 0.416212, 0.387569, 0.359722, 0.332118, 0.305884, 0.299048, 0.292212, 0.283325, 0.270275, 0.257225, 0.241218, 0.222889, 0.204559, 0.18833, 0.172787, 0.157244, 0.147937, 0.139217, 0.130618, 0.125164, 0.11971, 0.114691, 0.112748, 0.110806, 0.109535, 0.111453, 0.113372, 0.115324, 0.117419, 0.119514, 0.121567, 0.123406, 0.125245, 0.126906, 0.126987, 0.127068, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    MHWWD = [0, 0, 0, 0, 0, 0.0505351, 0.117909, 0.0535547, 0.0727501, 0.122307, 0.212169, 0.177516, 0.142398, 0.138638, 0.137826, 0.142178, 0.156474, 0.172135, 0.17998, 0.201762, 0.220642, 0.239359, 0.249727, 0.256337, 0.275711, 0.293799, 0.305687, 0.321161, 0.331235, 0.347602, 0.369103, 0.385953, 0.407106, 0.445201, 0.495666, 0.535465, 0.61341, 0.564307, 0.536103, 0.532484, 0.53662, 0.539278, 0.539625, 0.543714, 0.548237, 0.546717, 0.542738, 0.529962, 0.52875, 0.534736, 0.538692, 0.589612, 0.662167, 0.647344, 0.602138, 0.548888, 0.520938, 0.482328, 0.455812, 0.45762, 0.46821, 0.4805, 0.493978, 0.492101, 0.498308, 0.514993, 0.526917, 0.537627, 0.546454, 0.548072, 0.539346, 0.534866, 0.527469, 0.517308, 0.515406, 0.503208, 0.494405, 0.490231, 0.480833, 0.472547, 0.46422, 0.46166, 0.463722, 0.465421, 0.468719, 0.464071, 0.456589, 0.446983, 0.43997, 0.428826, 0.418581, 0.410749, 0.404074, 0.39862, 0.389978, 0.385484, 0.383235, 0.389055, 0.394341, 0.388385, 0.371022, 0.353931, 0.348503, 0.350932, 0.350828, 0.344562, 0.334109, 0.323801, 0.316214, 0.31266, 0.312016, 0.313647, 0.316152, 0.32035, 0.327687, 0.33374, 0.338301, 0.341473, 0.345886, 0.351298, 0.355118, 0.35762, 0.357892, 0.357167, 0.356247, 0.355902, 0.356122, 0.356892, 0.357975, 0.358752, 0.359367, 0.359746, 0.365829, 0.4421, 0.543552, 0.62454, 0.604249, 0.574406, 0.543797, 0.516191, 0.453049, 0.397958, 0.365759, 0.363973, 0.395093, 0.484106, 0.489972, 0.462788, 0.40138, 0.368334, 0.353188, 0.352139, 0.350043, 0.346205, 0.344429, 0.343526, 0.34421, 0.34422, 0.343046, 0.341485, 0.339717, 0.365307, 0.389546, 0.393363, 0.386356, 0.361762, 0.36475, 0.387711, 0.412843, 0.438675, 0.391097, 0.337725, 0.3227, 0.31256, 0.331224, 0.351672, 0.378194, 0.402527, 0.421339, 0.432245, 0.426115, 0.416425, 0.399309, 0.38042, 0.357509, 0.351815, 0.394368, 0.433555, 0.45867, 0.48186, 0.487141, 0.492422, 0.485339, 0.477927, 0.475595, 0.474348, 0.474953, 0.476571, 0.481625, 0.491032, 0.499739, 0.505762, 0.511785, 0.517983, 0.524191, 0.528255, 0.531181, 0.53668, 0.547334, 0.557989, 0.56284, 0.567591, 0.569407, 0.569281, 0.568231, 0.56329, 0.558349, 0.553026, 0.547575, 0.542457, 0.5382, 0.533943, 0.531508, 0.529605, 0.527223, 0.523308, 0.519392, 0.51652, 0.514162, 0.511853, 0.510211, 0.50857, 0.506576, 0.504127, 0.501677, 0.497894, 0.493706, 0.489669, 0.487777, 0.485884, 0.4847, 0.484954, 0.485207, 0.484175, 0.482133, 0.48009, 0.473261, 0.46487, 0.456479, 0.454607, 0.453349, 0.452134, 0.452048, 0.451961, 0.451129, 0.445028, 0.438926, 0.431716, 0.419243, 0.406771, 0.395328, 0.388362, 0.381396, 0.378275, 0.394891, 0.411508, 0.41646, 0.317593, 0.218726, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    MPS = [0, 0, 0, 0, 0, 0.00784314, 0.00784314, 0.0120279, 0.0127702, 0.0102375, 0.0109839, 0.0124297, 0.0138972, 0.0146567, 0.0159281, 0.0166808, 0.0149539, 0.0146453, 0.0141253, 0.0163399, 0.0164404, 0.0174559, 0.0189122, 0.0186842, 0.0179025, 0.0186056, 0.0200121, 0.0236323, 0.0231781, 0.0224286, 0.0220093, 0.0215667, 0.0289539, 0.0281024, 0.0255894, 0.0296867, 0.05953, 0.0461784, 0.0279508, 0.0395874, 0.0499965, 0.0416223, 0.0321565, 0.0347334, 0.0327764, 0.0324302, 0.0332987, 0.0372271, 0.0426257, 0.0794511, 0.138304, 0.144605, 0.0719628, 0.0423691, 0.0562376, 0.0866571, 0.065145, 0.0518847, 0.0447332, 0.0492488, 0.0491758, 0.0447478, 0.0534893, 0.0747304, 0.0981819, 0.183703, 0.366224, 0.685727, 0.612726, 0.227886, 0.122616, 0.110895, 0.103752, 0.109891, 0.234143, 0.457512, 0.471369, 0.136733, 0.0834546, 0.0934663, 0.0946942, 0.0991081, 0.100909, 0.10455, 0.114193, 0.123669, 0.133403, 0.137439, 0.145083, 0.1578, 0.174557, 0.193996, 0.202611, 0.191479, 0.183693, 0.206555, 0.472636, 0.715175, 0.798183, 0.720551, 0.420534, 0.215959, 0.194929, 0.194686, 0.199592, 0.187268, 0.179053, 0.163739, 0.153818, 0.159513, 0.141524, 0.125208, 0.169303, 0.358246, 0.687411, 0.790571, 0.472977, 0.213728, 0.132413, 0.183022, 0.210652, 0.214266, 0.218948, 0.221513, 0.222723, 0.229894, 0.232469, 0.234739, 0.23799, 0.243872, 0.25368, 0.262751, 0.270087, 0.27655, 0.283505, 0.290067, 0.294669, 0.298426, 0.301843, 0.305009, 0.303012, 0.283381, 0.235198, 0.249629, 0.307926, 0.435805, 0.4509, 0.422537, 0.353098, 0.342603, 0.369109, 0.38487, 0.39439, 0.393506, 0.385279, 0.375047, 0.378466, 0.3814, 0.383484, 0.385513, 0.387514, 0.387892, 0.387805, 0.386052, 0.405399, 0.459026, 0.525258, 0.600617, 0.642444, 0.673449, 0.611799, 0.541023, 0.473917, 0.416233, 0.41411, 0.413743, 0.419358, 0.423923, 0.42584, 0.429748, 0.437947, 0.446403, 0.455397, 0.484208, 0.557961, 0.632617, 0.709805, 0.789795, 0.881497, 0.964433, 0.965759, 0.967085, 0.876583, 0.78363, 0.697444, 0.612703, 0.545999, 0.489179, 0.452821, 0.442401, 0.433434, 0.430034, 0.426633, 0.429866, 0.433485, 0.443954, 0.458062, 0.467465, 0.467443, 0.467421, 0.463955, 0.460428, 0.457091, 0.453878, 0.455085, 0.474891, 0.494697, 0.508907, 0.521253, 0.526331, 0.512537, 0.498743, 0.495043, 0.49429, 0.494443, 0.497497, 0.500551, 0.4988, 0.494683, 0.490301, 0.482341, 0.474382, 0.467614, 0.462394, 0.457174, 0.455144, 0.454083, 0.452925, 0.450389, 0.447853, 0.443417, 0.435122, 0.426828, 0.41793, 0.408559, 0.399188, 0.393719, 0.389524, 0.385328, 0.377875, 0.370116, 0.362367, 0.354894, 0.347421, 0.339732, 0.330511, 0.321291, 0.312281, 0.304269, 0.296258, 0.287956, 0.278396, 0.268837, 0.258908, 0.247086, 0.235264, 0.224137, 0.219191, 0.214246, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    NeKrFL = [0, 0, 0, 0, 0, 0.00392157, 0.00392157, 0.00385205, 0.00311714, 0.00372046, 0.00331825, 0.00372046, 0.00392157, 0.00392157, 0.00392157, 0.00231272, 0.00231272, 0.00271493, 0.00280662, 0.00334328, 0.00353639, 0.00365071, 0.00353077, 0.003412, 0.00428958, 0.00872174, 0.0266707, 0.149496, 0.293005, 0.187139, 0.0976873, 0.106618, 0.290255, 0.50501, 0.279918, 0.0565301, 0.11967, 0.242102, 0.288742, 0.290347, 0.157843, 0.0443595, 0.0214128, 0.0195487, 0.0287184, 0.0388194, 0.0841239, 0.186446, 0.252201, 0.169892, 0.0602796, 0.069542, 0.126223, 0.0924466, 0.0161931, 0.00626148, 0.00550329, 0.00679006, 0.00847209, 0.0188488, 0.0252189, 0.0167999, 0.0162008, 0.037345, 0.0531693, 0.035222, 0.0158468, 0.0177855, 0.0265994, 0.0252536, 0.0281909, 0.023623, 0.0168224, 0.013456, 0.0209702, 0.062991, 0.123706, 0.147411, 0.208853, 0.171729, 0.102245, 0.0997166, 0.123937, 0.150435, 0.179135, 0.204873, 0.229313, 0.242432, 0.246207, 0.260676, 0.278107, 0.292672, 0.309551, 0.32674, 0.344443, 0.360044, 0.378773, 0.39374, 0.405943, 0.423574, 0.44191, 0.463072, 0.488497, 0.513088, 0.532733, 0.547355, 0.564157, 0.573175, 0.580627, 0.591408, 0.599248, 0.607295, 0.615007, 0.622727, 0.632505, 0.644317, 0.655794, 0.664701, 0.671449, 0.677184, 0.683258, 0.685164, 0.689645, 0.692353, 0.692111, 0.691306, 0.687605, 0.682665, 0.676513, 0.668263, 0.658455, 0.649888, 0.642462, 0.628, 0.618877, 0.612054, 0.604209, 0.593893, 0.583085, 0.572499, 0.562029, 0.551091, 0.539327, 0.526458, 0.513275, 0.499823, 0.490735, 0.481457, 0.466469, 0.455753, 0.447747, 0.444508, 0.440324, 0.434565, 0.4308, 0.428164, 0.432059, 0.438429, 0.449142, 0.454342, 0.456575, 0.44557, 0.43421, 0.427395, 0.423485, 0.424295, 0.423532, 0.42163, 0.417503, 0.412658, 0.406669, 0.400531, 0.393523, 0.385083, 0.368202, 0.351511, 0.335469, 0.319191, 0.302321, 0.293734, 0.302992, 0.304335, 0.289162, 0.287126, 0.314885, 0.352987, 0.420071, 0.479291, 0.505629, 0.531303, 0.550792, 0.570282, 0.526307, 0.480638, 0.452589, 0.428305, 0.438739, 0.468198, 0.483485, 0.480807, 0.473935, 0.450997, 0.428059, 0.424787, 0.422659, 0.41977, 0.416475, 0.419329, 0.434498, 0.449667, 0.476286, 0.503103, 0.517468, 0.523601, 0.52696, 0.518642, 0.510324, 0.509831, 0.511947, 0.507183, 0.484555, 0.461927, 0.426722, 0.387845, 0.356524, 0.349398, 0.342272, 0.349219, 0.363097, 0.376148, 0.378038, 0.379927, 0.377183, 0.368421, 0.359659, 0.355661, 0.353111, 0.351687, 0.366204, 0.380721, 0.397533, 0.419005, 0.440477, 0.447075, 0.441987, 0.436898, 0.403664, 0.361248, 0.318832, 0.292679, 0.268056, 0.244162, 0.239243, 0.234324, 0.228963, 0.220475, 0.211988, 0.202409, 0.187647, 0.172886, 0.15901, 0.148985, 0.138959, 0.130576, 0.130625, 0.130675, 0.129633, 0.118884, 0.108135, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    NeXeFL1 = [0, 0, 0, 0, 0, 0.0122818, 0.0115848, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9.1687e-05, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.0014857, 0.00623429, 0.00623429, 0.00623429, 0.00623429, 0.00563097, 0.00563097, 0.00563097, 0.00563097, 0.00573238, 0.00623429, 0.00623429, 0.00623429, 0.00623429, 0.00703609, 0.00784314, 0.00784314, 0.00784314, 0.00784314, 0.00639199, 0.00495208, 0.00557548, 0.0057925, 0.00640719, 0.00722602, 0.0103721, 0.0119298, 0.0126534, 0.0126763, 0.012206, 0.0171034, 0.0267409, 0.0377671, 0.0534228, 0.0914643, 0.118796, 0.175902, 0.141339, 0.0997856, 0.176914, 0.413658, 0.543488, 0.356544, 0.245169, 0.213103, 0.129653, 0.130952, 0.150938, 0.149863, 0.15148, 0.170516, 0.202081, 0.237373, 0.290227, 0.325809, 0.337207, 0.360123, 0.402279, 0.419356, 0.409668, 0.428723, 0.454741, 0.468437, 0.488511, 0.532272, 0.559254, 0.5551, 0.552927, 0.569106, 0.582324, 0.589876, 0.603336, 0.614771, 0.620921, 0.624401, 0.628414, 0.632043, 0.636183, 0.643039, 0.650629, 0.662641, 0.6737, 0.687706, 0.698899, 0.707446, 0.716164, 0.731177, 0.750588, 0.766979, 0.783121, 0.799428, 0.81516, 0.827767, 0.837136, 0.845073, 0.847972, 0.845628, 0.842057, 0.837612, 0.827143, 0.813846, 0.797524, 0.778309, 0.756297, 0.73532, 0.713774, 0.691051, 0.664627, 0.647492, 0.635079, 0.62312, 0.611245, 0.60012, 0.590385, 0.578367, 0.564893, 0.549541, 0.537794, 0.525632, 0.511368, 0.503584, 0.496365, 0.48397, 0.472548, 0.461761, 0.455994, 0.45152, 0.449204, 0.446626, 0.444013, 0.442526, 0.441195, 0.440139, 0.438789, 0.437281, 0.436184, 0.435168, 0.434376, 0.432812, 0.429993, 0.42462, 0.417398, 0.402569, 0.385284, 0.36719, 0.349061, 0.332099, 0.318654, 0.325941, 0.335597, 0.353322, 0.372285, 0.394369, 0.415122, 0.433007, 0.449998, 0.465121, 0.47411, 0.469188, 0.464737, 0.461604, 0.459237, 0.460077, 0.460233, 0.454028, 0.447823, 0.434748, 0.421489, 0.412764, 0.405008, 0.398904, 0.393705, 0.388457, 0.383146, 0.379008, 0.379364, 0.379719, 0.38233, 0.385072, 0.391726, 0.40046, 0.406135, 0.405686, 0.405237, 0.394207, 0.382995, 0.368862, 0.352798, 0.337807, 0.327327, 0.316848, 0.305244, 0.293265, 0.281914, 0.272196, 0.262477, 0.255356, 0.248992, 0.243612, 0.24138, 0.239148, 0.232454, 0.223562, 0.214644, 0.205368, 0.196091, 0.186973, 0.178059, 0.169146, 0.164856, 0.161971, 0.15903, 0.1553, 0.151569, 0.148573, 0.147066, 0.14556, 0.141957, 0.136707, 0.131457, 0.122451, 0.112218, 0.101986, 0.0951323, 0.0885966, 0.0822095, 0.0796896, 0.0771697, 0.0747996, 0.0734873, 0.072175, 0.071337, 0.0727509, 0.0741648, 0.074593, 0.0707358, 0.0668786, 0.0620362, 0.0521353, 0.0422343, 0.0328944, 0.0285494, 0.0242043, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    NeXeFL2 = [0, 0, 0, 0, 0, 0.00560225, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.00641621, 0.00922367, 0.0136291, 0.0206386, 0.028488, 0.0512793, 0.0727544, 0.102578, 0.133003, 0.164339, 0.201682, 0.238847, 0.275028, 0.302153, 0.34183, 0.388397, 0.410951, 0.443288, 0.472036, 0.497632, 0.513897, 0.52507, 0.538481, 0.535656, 0.540845, 0.545601, 0.550909, 0.560724, 0.564805, 0.573842, 0.576917, 0.593594, 0.606107, 0.574071, 0.53966, 0.555879, 0.596171, 0.586804, 0.534742, 0.524198, 0.496952, 0.478643, 0.497501, 0.481976, 0.431721, 0.397502, 0.38174, 0.366544, 0.37115, 0.38249, 0.399542, 0.415654, 0.460851, 0.515162, 0.533377, 0.535085, 0.533275, 0.520997, 0.486028, 0.456388, 0.433358, 0.394547, 0.343983, 0.303101, 0.271203, 0.249222, 0.226665, 0.197894, 0.16861, 0.144112, 0.125055, 0.113642, 0.10357, 0.0899696, 0.0809778, 0.0732443, 0.0694975, 0.0697668, 0.0715717, 0.0718045, 0.0710579, 0.0685573, 0.0654768, 0.0640141, 0.0617021, 0.0599306, 0.0586261, 0.0568749, 0.05421, 0.0506918, 0.0492622, 0.0482932, 0.0474183, 0.0466427, 0.046566, 0.0475461, 0.0483905, 0.0494442, 0.0522929, 0.0564108, 0.0609437, 0.0672254, 0.0917924, 0.120725, 0.154615, 0.197151, 0.242859, 0.287604, 0.32903, 0.341154, 0.34218, 0.332012, 0.311489, 0.285208, 0.250524, 0.22003, 0.191713, 0.167113, 0.140465, 0.112564, 0.0913737, 0.072565, 0.0577259, 0.0433491, 0.0297812, 0.0273135, 0.0248573, 0.0224212, 0.0214178, 0.0211859, 0.0200393, 0.0188876, 0.0181524, 0.0176335, 0.017466, 0.0175556, 0.0178312, 0.018948, 0.0203363, 0.0211713, 0.022344, 0.033201, 0.046315, 0.0727377, 0.0997352, 0.12869, 0.162423, 0.208201, 0.252294, 0.292758, 0.320983, 0.323674, 0.323463, 0.31667, 0.307793, 0.293075, 0.275535, 0.246199, 0.218481, 0.205836, 0.19319, 0.181313, 0.169458, 0.159705, 0.150402, 0.147315, 0.147635, 0.151773, 0.160752, 0.174342, 0.205593, 0.236843, 0.270319, 0.303925, 0.33377, 0.361617, 0.379956, 0.37925, 0.378544, 0.367261, 0.355795, 0.339037, 0.318781, 0.297057, 0.26916, 0.241263, 0.21995, 0.200832, 0.185455, 0.179793, 0.174131, 0.169951, 0.166203, 0.161223, 0.152296, 0.143368, 0.138, 0.134386, 0.130834, 0.128123, 0.125413, 0.121791, 0.116986, 0.112181, 0.108248, 0.104581, 0.100803, 0.0954558, 0.0901086, 0.0855137, 0.0824463, 0.0793789, 0.0748886, 0.0692804, 0.0636722, 0.0598766, 0.0566724, 0.0534682, 0.0489919, 0.0443959, 0.0399009, 0.0380369, 0.0361729, 0.0338785, 0.0285441, 0.0232096, 0.0183231, 0.0155627, 0.0128023, 0.0102596, 0.00866354, 0.00706745, 0.00572081, 0.00565514, 0.00558946, 0.00552714, 0.00549472, 0.00546229, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Ne = [0, 0, 0, 0, 0, 0.00161603, 0.00251383, 0.00344983, 0.00351936, 0.00392157, 0.0037737, 0.00351936, 0.00372046, 0.00372046, 0.00372046, 0.00372046, 0.00372046, 0.00331825, 0.00329533, 0.00311714, 0.00311714, 0.00311714, 0.00287678, 0.00251383, 0.0027068, 0.00311714, 0.00314237, 0.00331825, 0.00331825, 0.00372046, 0.00372046, 0.00331825, 0.00331825, 0.00331825, 0.00331825, 0.00328445, 0.00311714, 0.00351936, 0.00392157, 0.00357568, 0.00371981, 0.00392157, 0.00392157, 0.00392157, 0.00392157, 0.00362133, 0.00331825, 0.00331825, 0.00331825, 0.00331825, 0.00323939, 0.00291604, 0.00331825, 0.00331825, 0.00326004, 0.00291604, 0.00291604, 0.00301386, 0.00311714, 0.00311714, 0.00297137, 0.00292187, 0.00294149, 0.00291604, 0.00287904, 0.0025359, 0.00251383, 0.00263985, 0.00291604, 0.00324687, 0.00331825, 0.00331825, 0.00305737, 0.00291604, 0.00342636, 0.00309293, 0.00284794, 0.00284519, 0.00296535, 0.0032024, 0.00300263, 0.00244059, 0.00249787, 0.00282492, 0.00319593, 0.00316742, 0.00317504, 0.00306868, 0.00258101, 0.0024934, 0.0025109, 0.00261686, 0.00277889, 0.00295638, 0.00307932, 0.00161103, 0.000818538, 0.00130072, 0.00149653, 0.00148775, 0.00229053, 0.00383994, 0.00585, 0.00799949, 0.00741257, 0.00376043, 0.00492375, 0.00711022, 0.00571864, 0.00563097, 0.00789039, 0.0113093, 0.0102876, 0.00647756, 0.0064132, 0.00523615, 0.00470469, 0.00585179, 0.00846799, 0.0110608, 0.0113705, 0.00974221, 0.0115272, 0.0120759, 0.0100736, 0.0079644, 0.0104313, 0.0115392, 0.0120173, 0.0167527, 0.0282925, 0.0692845, 0.140916, 0.197512, 0.175696, 0.117653, 0.0669936, 0.116839, 0.206438, 0.324827, 0.385299, 0.33865, 0.125448, 0.0533306, 0.0216133, 0.0253086, 0.0228473, 0.0200827, 0.0231499, 0.0268856, 0.0310271, 0.0323225, 0.0342292, 0.0371544, 0.0412963, 0.0459706, 0.0518872, 0.0562101, 0.0577363, 0.0618513, 0.0673603, 0.0712043, 0.0751495, 0.0804373, 0.0880498, 0.0994394, 0.111321, 0.12356, 0.134078, 0.14404, 0.155725, 0.167317, 0.172387, 0.178463, 0.190469, 0.206833, 0.238039, 0.270581, 0.306493, 0.324879, 0.305505, 0.286717, 0.269153, 0.296746, 0.426756, 0.526809, 0.542912, 0.556676, 0.560657, 0.562962, 0.549653, 0.536344, 0.462408, 0.386853, 0.393908, 0.418607, 0.46522, 0.523842, 0.564998, 0.584015, 0.588633, 0.538089, 0.487546, 0.47179, 0.458058, 0.466524, 0.486787, 0.495735, 0.482022, 0.468308, 0.493626, 0.519619, 0.529776, 0.529463, 0.527356, 0.517701, 0.508045, 0.540608, 0.587244, 0.616851, 0.602234, 0.587617, 0.555834, 0.519039, 0.492814, 0.500429, 0.508045, 0.522809, 0.541095, 0.55856, 0.564955, 0.571349, 0.572626, 0.567255, 0.561884, 0.561447, 0.562508, 0.563219, 0.558974, 0.554729, 0.558156, 0.57716, 0.596163, 0.61781, 0.641532, 0.665255, 0.642286, 0.604083, 0.565879, 0.509805, 0.452049, 0.397747, 0.433354, 0.46896, 0.503911, 0.53423, 0.564549, 0.584405, 0.554596, 0.524788, 0.49449, 0.46207, 0.42965, 0.401617, 0.396117, 0.390616, 0.384294, 0.370659, 0.357024, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    OliveOil = [0, 0, 0, 0, 0, 0.00369532, 0.0048699, 0.00405688, 0.0042735, 0.00501497, 0.00434522, 0.0044385, 0.00351428, 0.00358106, 0.00548088, 0.0039271, 0.00414494, 0.00417295, 0.00459235, 0.00493898, 0.0059318, 0.00584339, 0.00562196, 0.00566242, 0.00586627, 0.00597717, 0.00662351, 0.00478608, 0.00545468, 0.00536986, 0.00546674, 0.00595359, 0.00607851, 0.00591709, 0.00538822, 0.00619076, 0.00488168, 0.0043258, 0.00437622, 0.00479135, 0.00555284, 0.00522251, 0.00554869, 0.00552922, 0.0051823, 0.0067092, 0.00588267, 0.00518975, 0.00565238, 0.00619812, 0.00606769, 0.0067822, 0.00630227, 0.0070953, 0.00766253, 0.0067953, 0.00639814, 0.00883898, 0.0094692, 0.00825277, 0.00774258, 0.00875395, 0.00909633, 0.0103972, 0.010836, 0.00989591, 0.00978787, 0.00998276, 0.00956224, 0.0104153, 0.0106813, 0.0104382, 0.010929, 0.0124351, 0.0126466, 0.0145263, 0.016716, 0.0170552, 0.0164457, 0.0170197, 0.0171413, 0.0150786, 0.0159244, 0.0183377, 0.0193632, 0.0190205, 0.0193336, 0.0194043, 0.0205607, 0.0220575, 0.0240213, 0.0292309, 0.0361843, 0.0426798, 0.0480026, 0.0534728, 0.0663268, 0.0834347, 0.105511, 0.13417, 0.169889, 0.208361, 0.247149, 0.285474, 0.319797, 0.350196, 0.380531, 0.409508, 0.443131, 0.472317, 0.496407, 0.512778, 0.522937, 0.530453, 0.537148, 0.537106, 0.532643, 0.5251, 0.515685, 0.504936, 0.492791, 0.478535, 0.471864, 0.472934, 0.480585, 0.491592, 0.5008, 0.508219, 0.514131, 0.519125, 0.524104, 0.52834, 0.531674, 0.534245, 0.535495, 0.536896, 0.540766, 0.540587, 0.539269, 0.537669, 0.53734, 0.535628, 0.531241, 0.529802, 0.52541, 0.51387, 0.509428, 0.506883, 0.503658, 0.50013, 0.496424, 0.495222, 0.49631, 0.501215, 0.507014, 0.51281, 0.512632, 0.513979, 0.518, 0.521047, 0.523569, 0.527371, 0.531005, 0.533126, 0.534503, 0.534671, 0.533894, 0.532433, 0.529648, 0.526436, 0.523407, 0.520246, 0.513397, 0.507039, 0.503579, 0.499231, 0.491856, 0.486837, 0.487758, 0.490097, 0.495496, 0.499863, 0.502081, 0.504313, 0.506577, 0.50859, 0.509902, 0.512617, 0.521205, 0.528888, 0.528153, 0.527419, 0.529496, 0.531647, 0.538113, 0.545499, 0.553225, 0.561137, 0.56953, 0.578532, 0.587636, 0.597126, 0.606617, 0.612363, 0.617891, 0.625243, 0.633565, 0.642691, 0.653431, 0.664171, 0.672719, 0.681229, 0.688622, 0.695277, 0.700678, 0.700801, 0.700925, 0.696944, 0.691595, 0.68454, 0.673055, 0.661571, 0.647405, 0.632456, 0.614467, 0.586745, 0.559022, 0.509338, 0.448836, 0.388741, 0.334132, 0.279522, 0.235642, 0.205699, 0.175755, 0.159455, 0.147301, 0.136626, 0.146898, 0.15717, 0.171365, 0.193527, 0.215689, 0.24021, 0.266584, 0.292959, 0.323954, 0.356457, 0.38896, 0.417471, 0.445606, 0.472603, 0.46998, 0.467356, 0.463587, 0.451725, 0.439863, 0.427827, 0.414968, 0.402109, 0.389092, 0.375392, 0.361693, 0.347228, 0.328839, 0.310449, 0.29188, 0.271711, 0.251542, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    PLANTA = [0, 0, 0, 0, 0, 0.123379, 0.171063, 0.139033, 0.156611, 0.211761, 0.413118, 0.551878, 0.538407, 0.553632, 0.441058, 0.286937, 0.221416, 0.20074, 0.17702, 0.175555, 0.17672, 0.174862, 0.17333, 0.178291, 0.181735, 0.187681, 0.193347, 0.194949, 0.202025, 0.208734, 0.216782, 0.225779, 0.243893, 0.256313, 0.281233, 0.381349, 0.504356, 0.608211, 0.676185, 0.501995, 0.445583, 0.408314, 0.413223, 0.427476, 0.462432, 0.490234, 0.518387, 0.536409, 0.54915, 0.554604, 0.554215, 0.57119, 0.6327, 0.740942, 0.809627, 0.735822, 0.738167, 0.739461, 0.665867, 0.606081, 0.571781, 0.543325, 0.504689, 0.469664, 0.436272, 0.418777, 0.406547, 0.407023, 0.42264, 0.438947, 0.4197, 0.404209, 0.391814, 0.383968, 0.372477, 0.373284, 0.367247, 0.371666, 0.363088, 0.365543, 0.365788, 0.368492, 0.369333, 0.363969, 0.364909, 0.357732, 0.35693, 0.352184, 0.353807, 0.34885, 0.33931, 0.325608, 0.335621, 0.342662, 0.316856, 0.299333, 0.293806, 0.283913, 0.320232, 0.380866, 0.366168, 0.301041, 0.252405, 0.222662, 0.202777, 0.194994, 0.195886, 0.199807, 0.20259, 0.204928, 0.211593, 0.214285, 0.21829, 0.2267, 0.237021, 0.252533, 0.267625, 0.274947, 0.280024, 0.288109, 0.302656, 0.310083, 0.312253, 0.301857, 0.278236, 0.248706, 0.23965, 0.227548, 0.212264, 0.204532, 0.201282, 0.200017, 0.200003, 0.199396, 0.210401, 0.227298, 0.244731, 0.2361, 0.223715, 0.216363, 0.221475, 0.230836, 0.244161, 0.270647, 0.331261, 0.458232, 0.553454, 0.61415, 0.576299, 0.492582, 0.380189, 0.299314, 0.245112, 0.235361, 0.229299, 0.224563, 0.218557, 0.212291, 0.20557, 0.199958, 0.194941, 0.191427, 0.18941, 0.194585, 0.198969, 0.202067, 0.208517, 0.217392, 0.27119, 0.339486, 0.375297, 0.40366, 0.328644, 0.258021, 0.213301, 0.193823, 0.260297, 0.33968, 0.451608, 0.537978, 0.569284, 0.567183, 0.495381, 0.426784, 0.365458, 0.319143, 0.314893, 0.326458, 0.404152, 0.480576, 0.545179, 0.609783, 0.614424, 0.617464, 0.582487, 0.539389, 0.512187, 0.493695, 0.489928, 0.504827, 0.520377, 0.538425, 0.556473, 0.563374, 0.569626, 0.569205, 0.565239, 0.56035, 0.553611, 0.546872, 0.541879, 0.536917, 0.527382, 0.514823, 0.50447, 0.5034, 0.502329, 0.497455, 0.491313, 0.482346, 0.466042, 0.449739, 0.437384, 0.426183, 0.416314, 0.410715, 0.405116, 0.400471, 0.396295, 0.392077, 0.387287, 0.382496, 0.378896, 0.376842, 0.374788, 0.371796, 0.36852, 0.365089, 0.359466, 0.353843, 0.348309, 0.342954, 0.3376, 0.332986, 0.328955, 0.324924, 0.321916, 0.319243, 0.31657, 0.310047, 0.303162, 0.296237, 0.28828, 0.280323, 0.272711, 0.26753, 0.262349, 0.257633, 0.255125, 0.252617, 0.249813, 0.245723, 0.241633, 0.238191, 0.238076, 0.237961, 0.239407, 0.254745, 0.270082, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Rb = [0, 0, 0, 0, 0, 0.00392157, 0.00392157, 0.00293961, 0.00351936, 0.0034786, 0.00261438, 0.0027766, 0.00191051, 0.00219045, 0.00246281, 0.00377933, 0.0115769, 0.0353583, 0.106205, 0.402008, 0.585181, 0.537753, 0.611451, 0.279149, 0.0920418, 0.0540064, 0.0267219, 0.0250517, 0.0233877, 0.021311, 0.0227341, 0.0267974, 0.0265491, 0.0280236, 0.030973, 0.0350792, 0.0417295, 0.0447588, 0.0476552, 0.0527149, 0.0552754, 0.0603617, 0.0638055, 0.0691796, 0.0790052, 0.0857014, 0.090089, 0.0928109, 0.0985165, 0.104638, 0.108787, 0.117024, 0.118005, 0.121812, 0.131683, 0.135202, 0.179599, 0.259073, 0.417934, 0.410402, 0.22338, 0.18858, 0.240548, 0.21698, 0.168857, 0.165282, 0.162442, 0.166053, 0.170922, 0.174452, 0.177702, 0.178996, 0.180086, 0.179968, 0.173284, 0.177698, 0.181228, 0.182375, 0.181058, 0.181016, 0.17883, 0.180024, 0.176403, 0.173535, 0.172934, 0.171066, 0.163079, 0.161863, 0.159176, 0.158568, 0.152154, 0.148747, 0.144738, 0.126096, 0.134559, 0.136891, 0.103141, 0.105924, 0.130147, 0.118602, 0.107771, 0.0937084, 0.0822543, 0.137407, 0.211481, 0.166168, 0.0441686, 0.0394491, 0.104405, 0.202424, 0.260481, 0.19872, 0.0995316, 0.0476896, 0.0589387, 0.105894, 0.189884, 0.264437, 0.244842, 0.160758, 0.131632, 0.207364, 0.194871, 0.129283, 0.0641199, 0.124713, 0.173185, 0.255896, 0.332425, 0.265205, 0.119235, 0.0335298, 0.0341644, 0.0525539, 0.0645322, 0.0803573, 0.117768, 0.193015, 0.253631, 0.268642, 0.19727, 0.147383, 0.156388, 0.19135, 0.250623, 0.351467, 0.332717, 0.261071, 0.119285, 0.0510484, 0.0291636, 0.0298114, 0.0289022, 0.025398, 0.0242599, 0.0239937, 0.0232801, 0.0265971, 0.036987, 0.051856, 0.0691367, 0.0686486, 0.0656808, 0.0582157, 0.0759196, 0.134515, 0.210715, 0.299664, 0.296221, 0.262957, 0.173928, 0.0844104, 0.120405, 0.166765, 0.274238, 0.358408, 0.363221, 0.32394, 0.173494, 0.0623824, 0.0360207, 0.0206702, 0.0282939, 0.0441423, 0.0786441, 0.110703, 0.135914, 0.164365, 0.206367, 0.252865, 0.341222, 0.429579, 0.521319, 0.613149, 0.526655, 0.402071, 0.275484, 0.147797, 0.0709518, 0.0585514, 0.0497808, 0.0549151, 0.0600494, 0.0654726, 0.0709127, 0.0818854, 0.0957982, 0.113812, 0.140042, 0.166271, 0.199533, 0.232917, 0.240791, 0.2318, 0.228966, 0.252046, 0.275125, 0.301701, 0.329443, 0.354077, 0.370642, 0.387206, 0.409793, 0.434139, 0.450686, 0.442268, 0.433849, 0.399328, 0.351951, 0.309401, 0.331982, 0.354562, 0.395469, 0.460181, 0.524892, 0.473939, 0.387849, 0.301632, 0.213611, 0.12559, 0.0617648, 0.047063, 0.0323612, 0.02518, 0.0239079, 0.0226357, 0.01984, 0.0165473, 0.0132545, 0.0123005, 0.0115665, 0.0108329, 0.010108, 0.00938312, 0.00864457, 0.00780947, 0.00697436, 0.0062465, 0.00602768, 0.00580887, 0.00551905, 0.00492052, 0.00432199, 0.00370861, 0.00301899, 0.00232937, 0.0016832, 0.00142379, 0.00116438, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    RedGlass = [0, 0, 0, 0, 0, 0.0464555, 0.0423938, 0.0280517, 0.0332328, 0.0231807, 0.0248255, 0.0259949, 0.0243581, 0.0234791, 0.0243272, 0.0228965, 0.0226203, 0.0219036, 0.0221307, 0.0251512, 0.0238456, 0.0212892, 0.019428, 0.0189228, 0.0193343, 0.0200072, 0.0206263, 0.0209197, 0.0199519, 0.0201504, 0.0219165, 0.0198981, 0.0193627, 0.018378, 0.0170324, 0.0166682, 0.0184576, 0.0212337, 0.0231149, 0.0238744, 0.0204986, 0.0168679, 0.0166918, 0.0166918, 0.0168776, 0.0172694, 0.016507, 0.0147415, 0.0146197, 0.0140393, 0.0144589, 0.0159375, 0.0140243, 0.0128331, 0.0123112, 0.0127207, 0.0115715, 0.0137457, 0.0159347, 0.015747, 0.0139029, 0.0123272, 0.0123637, 0.0131095, 0.0134741, 0.0129665, 0.0110865, 0.0100546, 0.00942321, 0.00943414, 0.00975365, 0.00963766, 0.00938677, 0.00948737, 0.0116143, 0.0113867, 0.0117796, 0.0122058, 0.012367, 0.0125714, 0.0133955, 0.0146587, 0.0157588, 0.0173234, 0.0179233, 0.0178299, 0.0174003, 0.0162377, 0.0140081, 0.0163907, 0.0189163, 0.0193968, 0.0185774, 0.0165288, 0.0144815, 0.0154145, 0.0158389, 0.014853, 0.013964, 0.0138833, 0.0143624, 0.0153234, 0.0164238, 0.0168642, 0.0166776, 0.0164205, 0.0159705, 0.0155704, 0.0153011, 0.0149099, 0.0146198, 0.0144441, 0.0161875, 0.0182931, 0.0175086, 0.0175927, 0.0183075, 0.0199, 0.0217784, 0.0235738, 0.0251404, 0.0252197, 0.0252984, 0.0251911, 0.0249861, 0.0252545, 0.0254541, 0.0259889, 0.0269306, 0.0283364, 0.0302228, 0.0317636, 0.0327244, 0.0326531, 0.0338351, 0.0363639, 0.0411405, 0.0442675, 0.0473531, 0.0511315, 0.0545478, 0.0577712, 0.0607618, 0.0648165, 0.0692103, 0.073943, 0.0795236, 0.0858594, 0.0941756, 0.102259, 0.110209, 0.120819, 0.130331, 0.138009, 0.145378, 0.152584, 0.159006, 0.166197, 0.174738, 0.184606, 0.195189, 0.215344, 0.236278, 0.256694, 0.277393, 0.298554, 0.312909, 0.322336, 0.34293, 0.367129, 0.389151, 0.410898, 0.431232, 0.448686, 0.449158, 0.450715, 0.455968, 0.459693, 0.459565, 0.460229, 0.4626, 0.465083, 0.467798, 0.471603, 0.477879, 0.483398, 0.486799, 0.491219, 0.499901, 0.508259, 0.513588, 0.518916, 0.523223, 0.527502, 0.532991, 0.538739, 0.547491, 0.557888, 0.566946, 0.574305, 0.581507, 0.588109, 0.59471, 0.601665, 0.60864, 0.61341, 0.617008, 0.622007, 0.629816, 0.637625, 0.644691, 0.651743, 0.659021, 0.666448, 0.674331, 0.684131, 0.693931, 0.700514, 0.706026, 0.709726, 0.708722, 0.707719, 0.706387, 0.70496, 0.702749, 0.698031, 0.693312, 0.69204, 0.692465, 0.692636, 0.689372, 0.686108, 0.682141, 0.67726, 0.672379, 0.668344, 0.664565, 0.660688, 0.655414, 0.65014, 0.642708, 0.630891, 0.619075, 0.606401, 0.593052, 0.579704, 0.559201, 0.536365, 0.513528, 0.49163, 0.469821, 0.447976, 0.425194, 0.402411, 0.380066, 0.360807, 0.341549, 0.322906, 0.307185, 0.291464, 0.276019, 0.26177, 0.247522, 0.233201, 0.218505, 0.203809, 0.189735, 0.181191, 0.172647, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    RedLaser = [0, 0, 0, 0, 0, 0.00560225, 0, 0, 0, 0.000804424, 0.000804424, 0.000804424, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00309055, 0.00522876, 0.00522876, 0.00522876, 0.00510858, 0.00425487, 0.00355559, 0.00380056, 0.00493397, 0.00603318, 0.00603318, 0.00603318, 0.00603318, 0.00522876, 0.00522876, 0.00522876, 0.00522876, 0.0050851, 0.00437406, 0.00437406, 0.00437406, 0.00437406, 0.00319642, 0.00201106, 0.00201106, 0.00201106, 0.00201106, 0.00161074, 0.00120664, 0.00120664, 0.00120664, 0.00120664, 0.0015221, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00301113, 0.00358392, 0.00375002, 0.00431367, 0.00433683, 0.00367019, 0.00367019, 0.00367019, 0.00367019, 0.00367019, 0.0041463, 0.00582965, 0.00569909, 0.00558621, 0.0056503, 0.00568125, 0.00559062, 0.00547302, 0.00542986, 0.00542986, 0.00542986, 0.00542986, 0.0054386, 0.0057415, 0.00623429, 0.00623429, 0.00623429, 0.00623429, 0.00623429, 0.00623429, 0.0055761, 0.00356963, 0.00356963, 0.00356963, 0.00356963, 0.00356963, 0.00356963, 0.00356963, 0.00308896, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00281549, 0.00247103, 0.00201106, 0.00201106, 0.00201106, 0.00201106, 0.00201106, 0.00201106, 0.00201106, 0.00201106, 0.00201106, 0.0022495, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00241327, 0.00245783, 0.00302916, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.0032177, 0.00350536, 0.0042978, 0.0046317, 0.00471868, 0.00632488, 0.00803115, 0.00952982, 0.0101384, 0.00930096, 0.010452, 0.013043, 0.0157537, 0.018503, 0.0200974, 0.0217855, 0.0286341, 0.0349382, 0.0380314, 0.0416148, 0.0468675, 0.0521239, 0.0573892, 0.0626408, 0.0678627, 0.0727811, 0.0770663, 0.0809891, 0.0840899, 0.087065, 0.0896881, 0.0932402, 0.100676, 0.107775, 0.111729, 0.115684, 0.120889, 0.126127, 0.13266, 0.139469, 0.147006, 0.154941, 0.162325, 0.169009, 0.175496, 0.18123, 0.186965, 0.191074, 0.195088, 0.202254, 0.211096, 0.218518, 0.223096, 0.227675, 0.233129, 0.238597, 0.244152, 0.249764, 0.255532, 0.261956, 0.268379, 0.273783, 0.278848, 0.283877, 0.288816, 0.293756, 0.297388, 0.30064, 0.30527, 0.314315, 0.32336, 0.330451, 0.336578, 0.342878, 0.351506, 0.360133, 0.367426, 0.372985, 0.378544, 0.38495, 0.391614, 0.398398, 0.406888, 0.415378, 0.424672, 0.435598, 0.446524, 0.454573, 0.460361, 0.466148, 0.481347, 0.499616, 0.517886, 0.524169, 0.529324, 0.536398, 0.593388, 0.650378, 0.704177, 0.735434, 0.766691, 0.77636, 0.683549, 0.590739, 0.512865, 0.49993, 0.486995, 0.47346, 0.456844, 0.440227, 0.423838, 0.409473, 0.395109, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    SHPS = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000964613, 0.00241475, 0.00495654, 0.0113513, 0.0210499, 0.0329624, 0.0488588, 0.0583495, 0.0831261, 0.112108, 0.133244, 0.167601, 0.191449, 0.226068, 0.249301, 0.290331, 0.330946, 0.364915, 0.404387, 0.438385, 0.471243, 0.501703, 0.525658, 0.536013, 0.544013, 0.549391, 0.556342, 0.569055, 0.575185, 0.575254, 0.57747, 0.575886, 0.582328, 0.585577, 0.592322, 0.591298, 0.595688, 0.609062, 0.619504, 0.62743, 0.629585, 0.638439, 0.646694, 0.657548, 0.662325, 0.664984, 0.669432, 0.671055, 0.668722, 0.664173, 0.655669, 0.649932, 0.635238, 0.626391, 0.618963, 0.601536, 0.589337, 0.579902, 0.586523, 0.588442, 0.590267, 0.581556, 0.580647, 0.584732, 0.586013, 0.573638, 0.572816, 0.57479, 0.560366, 0.552084, 0.557077, 0.55836, 0.555238, 0.555176, 0.555083, 0.556911, 0.561819, 0.570096, 0.577625, 0.579831, 0.585688, 0.593091, 0.598245, 0.596387, 0.600289, 0.61394, 0.627326, 0.644516, 0.659877, 0.664679, 0.659019, 0.648544, 0.637616, 0.628663, 0.620189, 0.612184, 0.609223, 0.608511, 0.608641, 0.609404, 0.611406, 0.612521, 0.612877, 0.625838, 0.64646, 0.654697, 0.651585, 0.642826, 0.638376, 0.636355, 0.634385, 0.630645, 0.629732, 0.629632, 0.629584, 0.629425, 0.62977, 0.62955, 0.628393, 0.626487, 0.624452, 0.622097, 0.61995, 0.618016, 0.615017, 0.613601, 0.612122, 0.608043, 0.605192, 0.602629, 0.600042, 0.599261, 0.599684, 0.601677, 0.603255, 0.606728, 0.614281, 0.61574, 0.61493, 0.612211, 0.610739, 0.61004, 0.60711, 0.604936, 0.604021, 0.597095, 0.587073, 0.562752, 0.543009, 0.531298, 0.524881, 0.521315, 0.516297, 0.510761, 0.503183, 0.497747, 0.495793, 0.493741, 0.491619, 0.486718, 0.48092, 0.466609, 0.451614, 0.440756, 0.426121, 0.389214, 0.353453, 0.3216, 0.290917, 0.263184, 0.239725, 0.225472, 0.219768, 0.231901, 0.240345, 0.240419, 0.244912, 0.261793, 0.277109, 0.285888, 0.295883, 0.317197, 0.338511, 0.354917, 0.371193, 0.389597, 0.408457, 0.42322, 0.435737, 0.454992, 0.482786, 0.506731, 0.515933, 0.525135, 0.528481, 0.531486, 0.533095, 0.533962, 0.53506, 0.536622, 0.538183, 0.538106, 0.538, 0.537041, 0.535518, 0.534158, 0.533478, 0.532799, 0.5351, 0.538395, 0.542186, 0.547266, 0.552346, 0.555213, 0.557433, 0.560229, 0.56487, 0.56951, 0.572207, 0.573946, 0.575774, 0.57879, 0.581805, 0.585452, 0.589918, 0.594384, 0.599208, 0.604141, 0.608997, 0.612764, 0.616531, 0.619606, 0.621276, 0.622945, 0.62358, 0.623401, 0.623222, 0.624513, 0.626283, 0.628053, 0.626144, 0.62389, 0.621594, 0.618211, 0.614828, 0.611349, 0.607191, 0.603033, 0.598101, 0.5895, 0.580899, 0.57098, 0.555336, 0.539691, 0.522865, 0.499977, 0.477088, 0.454623, 0.435929, 0.417236, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    SS1 = [0, 0, 0, 0, 0, 0.0106443, 0.00784314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000605578, 0.00482655, 0.00241327, 0, 0, 0.00237242, 0.00905366, 0.00989883, 0.0388866, 0.0738004, 0.0268995, 0.00313346, 0.0055752, 0.00537868, 0.00171236, 0.000804424, 0.000804424, 0.000804424, 0.000804424, 0.00120474, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00212147, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00422323, 0.00859476, 0.00884047, 0.0106152, 0.00920944, 0.0100452, 0.00889117, 0.0306556, 0.039846, 0.0292965, 0.0412378, 0.0641882, 0.130906, 0.097593, 0.050419, 0.0429451, 0.0369967, 0.0555991, 0.100587, 0.0842019, 0.0602528, 0.0544974, 0.063771, 0.0654069, 0.111083, 0.168099, 0.172235, 0.160819, 0.210067, 0.197956, 0.138374, 0.1232, 0.13686, 0.137914, 0.145514, 0.194476, 0.278896, 0.236532, 0.156788, 0.136131, 0.13716, 0.148309, 0.157012, 0.164132, 0.172799, 0.186064, 0.204856, 0.21754, 0.217458, 0.217471, 0.227817, 0.237594, 0.24626, 0.254295, 0.265072, 0.27368, 0.280655, 0.283452, 0.287235, 0.30064, 0.315942, 0.32214, 0.321715, 0.320044, 0.320763, 0.325506, 0.3319, 0.336474, 0.345052, 0.355363, 0.350992, 0.352012, 0.360504, 0.370788, 0.366053, 0.358369, 0.358015, 0.36615, 0.369185, 0.374536, 0.380624, 0.38547, 0.382164, 0.383554, 0.397715, 0.37116, 0.350503, 0.350437, 0.509386, 0.642089, 0.665622, 0.639165, 0.579593, 0.447768, 0.380594, 0.354249, 0.36449, 0.371907, 0.374619, 0.392401, 0.414468, 0.411465, 0.403213, 0.38575, 0.374154, 0.365717, 0.363147, 0.359415, 0.34669, 0.335846, 0.328057, 0.327296, 0.331624, 0.341117, 0.352277, 0.361847, 0.369651, 0.337876, 0.313465, 0.332469, 0.361175, 0.422914, 0.4654, 0.459342, 0.446583, 0.419389, 0.392505, 0.366271, 0.362207, 0.408423, 0.48021, 0.623656, 0.744375, 0.770064, 0.792148, 0.780663, 0.769178, 0.701369, 0.632058, 0.564261, 0.496787, 0.474978, 0.478193, 0.482789, 0.489135, 0.49362, 0.490975, 0.48833, 0.488144, 0.4881, 0.491113, 0.495751, 0.497854, 0.49488, 0.491906, 0.50873, 0.525897, 0.535644, 0.540483, 0.54322, 0.537105, 0.530991, 0.539972, 0.553985, 0.563142, 0.559689, 0.556235, 0.529062, 0.494963, 0.467792, 0.462799, 0.457807, 0.465186, 0.478659, 0.492177, 0.506301, 0.520426, 0.527349, 0.524918, 0.522487, 0.494381, 0.458474, 0.424202, 0.413066, 0.40193, 0.395936, 0.400383, 0.40483, 0.408904, 0.412685, 0.416466, 0.426459, 0.43848, 0.4505, 0.454617, 0.457989, 0.460889, 0.451483, 0.442076, 0.432247, 0.419431, 0.406614, 0.393366, 0.378066, 0.362766, 0.346061, 0.323251, 0.30044, 0.277448, 0.253525, 0.229602, 0.204211, 0.165753, 0.127296, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    SS2 = [0, 0, 0, 0, 0, 0.0106443, 0.00784314, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000176627, 0.00140774, 0.0044544, 0.00563097, 0.00249818, 0.00331718, 0.00403343, 0.0279606, 0.0692937, 0.159089, 0.0587284, 0.0120524, 0.00774059, 0.00114634, 0.00151322, 0.0032177, 0.0032177, 0.00267715, 0.000122385, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00186551, 0.00545966, 0.00791831, 0.00293406, 0.00298213, 0.0151429, 0.0286735, 0.0241574, 0.015342, 0.00991725, 0.00980368, 0.0155216, 0.0212819, 0.0236418, 0.0189466, 0.016541, 0.0195004, 0.0242452, 0.0332197, 0.0454649, 0.0520786, 0.0489831, 0.0601834, 0.0620024, 0.0466936, 0.0413042, 0.0478302, 0.0490929, 0.0530775, 0.0871055, 0.147581, 0.125499, 0.0730024, 0.067681, 0.0701037, 0.0969189, 0.128436, 0.117489, 0.0905324, 0.0894102, 0.10369, 0.112549, 0.113382, 0.112974, 0.119009, 0.124111, 0.123345, 0.127161, 0.136549, 0.147852, 0.160161, 0.171676, 0.181542, 0.190152, 0.197718, 0.198365, 0.195554, 0.195069, 0.198865, 0.205498, 0.213917, 0.220289, 0.22465, 0.227662, 0.231305, 0.237121, 0.242039, 0.246179, 0.251284, 0.25511, 0.258387, 0.261835, 0.27144, 0.285815, 0.301713, 0.315066, 0.317144, 0.322465, 0.339246, 0.323675, 0.330731, 0.384563, 0.612114, 0.792535, 0.815355, 0.76871, 0.677196, 0.48975, 0.36287, 0.274485, 0.269395, 0.271047, 0.283937, 0.281853, 0.274656, 0.277362, 0.275154, 0.264324, 0.256311, 0.249817, 0.261354, 0.270735, 0.259962, 0.256984, 0.266671, 0.313376, 0.386889, 0.42841, 0.459605, 0.396409, 0.32565, 0.301388, 0.291343, 0.365133, 0.431476, 0.472463, 0.496112, 0.476047, 0.464118, 0.469719, 0.466652, 0.4455, 0.455233, 0.535016, 0.63045, 0.769743, 0.882283, 0.882954, 0.880404, 0.847864, 0.815325, 0.750205, 0.684214, 0.619245, 0.554495, 0.506238, 0.467021, 0.449435, 0.45927, 0.468693, 0.476539, 0.484385, 0.4906, 0.49672, 0.497981, 0.496659, 0.495977, 0.496576, 0.497175, 0.4987, 0.500242, 0.498306, 0.494071, 0.491044, 0.493103, 0.495161, 0.496225, 0.496957, 0.495945, 0.490404, 0.484862, 0.47583, 0.465779, 0.456601, 0.450219, 0.443836, 0.442701, 0.444151, 0.44541, 0.444093, 0.442775, 0.440269, 0.436217, 0.432166, 0.424826, 0.416487, 0.408128, 0.399491, 0.390855, 0.384703, 0.383595, 0.382488, 0.382683, 0.383902, 0.38512, 0.386061, 0.38691, 0.38776, 0.388648, 0.389539, 0.390034, 0.380231, 0.370428, 0.361094, 0.355078, 0.349062, 0.341601, 0.327277, 0.312952, 0.298714, 0.284848, 0.270983, 0.256032, 0.235507, 0.214983, 0.19295, 0.157492, 0.122034, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    TV = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0.000201859, 0.00160885, 0.00160885, 0.00160885, 0.00160885, 0.00442433, 0.00601339, 0.00764203, 0.00998618, 0.0130062, 0.0260596, 0.0326678, 0.0462934, 0.057873, 0.077768, 0.100831, 0.124588, 0.150762, 0.165904, 0.192024, 0.218453, 0.24222, 0.272694, 0.303112, 0.328169, 0.356513, 0.385819, 0.413671, 0.43953, 0.460521, 0.486593, 0.49454, 0.505507, 0.514914, 0.523855, 0.535189, 0.543538, 0.559771, 0.564954, 0.56021, 0.565348, 0.554767, 0.53427, 0.533567, 0.524217, 0.514582, 0.497992, 0.484075, 0.471297, 0.459797, 0.4468, 0.436318, 0.421498, 0.42007, 0.40462, 0.393331, 0.391371, 0.387929, 0.380921, 0.37276, 0.362177, 0.352768, 0.342949, 0.334794, 0.326608, 0.316804, 0.307729, 0.307506, 0.307376, 0.299313, 0.285917, 0.277339, 0.278307, 0.284885, 0.294577, 0.303626, 0.310859, 0.316236, 0.321428, 0.330903, 0.34083, 0.347948, 0.352078, 0.360654, 0.370089, 0.379676, 0.38567, 0.388109, 0.390357, 0.391114, 0.393757, 0.397782, 0.401773, 0.404893, 0.406899, 0.407336, 0.409646, 0.411254, 0.41128, 0.410551, 0.409863, 0.409246, 0.408663, 0.407998, 0.407585, 0.407069, 0.406162, 0.402663, 0.401106, 0.400841, 0.401608, 0.4014, 0.400052, 0.396988, 0.393697, 0.389545, 0.383996, 0.380337, 0.377573, 0.376018, 0.374526, 0.372947, 0.370955, 0.368997, 0.367056, 0.364496, 0.362188, 0.360298, 0.358427, 0.356614, 0.355722, 0.352789, 0.346273, 0.342616, 0.3405, 0.338251, 0.335873, 0.332876, 0.328681, 0.322539, 0.315611, 0.308113, 0.299349, 0.290176, 0.277757, 0.265148, 0.255857, 0.246397, 0.235938, 0.228, 0.228647, 0.235694, 0.258877, 0.283667, 0.311921, 0.339569, 0.365953, 0.388352, 0.401715, 0.415485, 0.430398, 0.441776, 0.43837, 0.434205, 0.42298, 0.411755, 0.431256, 0.451577, 0.479462, 0.508964, 0.499817, 0.469491, 0.435707, 0.397538, 0.36542, 0.356485, 0.34755, 0.347536, 0.34804, 0.349234, 0.350794, 0.352726, 0.3554, 0.358075, 0.367959, 0.377967, 0.393832, 0.413567, 0.434996, 0.463551, 0.492107, 0.49467, 0.488568, 0.481132, 0.47023, 0.459327, 0.476366, 0.501563, 0.526267, 0.549389, 0.572511, 0.568809, 0.551895, 0.531772, 0.468345, 0.404917, 0.345119, 0.290038, 0.234956, 0.198908, 0.168641, 0.139022, 0.11857, 0.0981174, 0.0812877, 0.0718132, 0.0623388, 0.0559927, 0.0521046, 0.0482165, 0.0452311, 0.0425402, 0.0398493, 0.0345067, 0.0289146, 0.0233193, 0.017641, 0.0119627, 0.00680247, 0.00530269, 0.00380292, 0.00260217, 0.00282099, 0.0030398, 0.00356591, 0.005428, 0.0072901, 0.00985766, 0.0160478, 0.022238, 0.0281501, 0.0315872, 0.0350244, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    UVA = [0, 0, 0, 0, 0, 0.101961, 0.101961, 0.0961323, 0.115133, 0.548726, 0.293335, 0.3118, 0.120334, 0.102586, 0.0993333, 0.0964058, 0.0990992, 0.0982144, 0.10016, 0.0944938, 0.0936731, 0.0899964, 0.091035, 0.0945318, 0.0955938, 0.0937441, 0.0927093, 0.101624, 0.0943768, 0.0909925, 0.0885158, 0.0919177, 0.0871136, 0.0851839, 0.0878544, 0.0917163, 0.0861733, 0.0709832, 0.0665961, 0.0717555, 0.0699506, 0.0668995, 0.0663043, 0.094932, 0.147016, 0.136222, 0.0949237, 0.0852213, 0.0878387, 0.0781909, 0.0755134, 0.0849094, 0.113084, 0.116943, 0.0930188, 0.0763508, 0.0884596, 0.0858977, 0.100274, 0.111659, 0.119208, 0.134517, 0.154017, 0.183497, 0.190146, 0.181915, 0.177311, 0.18191, 0.188686, 0.190683, 0.18791, 0.202507, 0.239482, 0.279748, 0.330411, 0.402758, 0.529936, 0.582657, 0.468828, 0.385829, 0.370369, 0.369958, 0.379322, 0.396438, 0.416259, 0.43703, 0.452924, 0.465379, 0.477788, 0.481986, 0.485774, 0.491309, 0.495408, 0.498364, 0.499642, 0.499154, 0.500228, 0.498362, 0.504402, 0.524558, 0.537674, 0.528839, 0.510038, 0.50157, 0.50583, 0.510131, 0.511891, 0.511261, 0.507714, 0.508489, 0.509863, 0.512588, 0.51557, 0.517365, 0.52176, 0.55043, 0.593133, 0.780113, 0.92742, 0.967994, 0.950173, 0.905576, 0.778334, 0.669623, 0.616592, 0.594771, 0.565093, 0.60891, 0.719411, 0.846121, 0.803796, 0.711987, 0.604063, 0.546573, 0.524103, 0.518623, 0.512347, 0.509755, 0.512535, 0.523836, 0.532507, 0.535463, 0.529416, 0.52186, 0.516665, 0.516892, 0.518034, 0.518794, 0.517023, 0.515649, 0.514502, 0.508919, 0.503293, 0.497595, 0.491098, 0.484361, 0.478712, 0.474484, 0.472753, 0.471129, 0.469564, 0.468881, 0.468025, 0.465819, 0.464454, 0.464454, 0.462871, 0.460143, 0.457254, 0.454315, 0.451505, 0.448667, 0.444791, 0.441067, 0.438236, 0.435196, 0.431444, 0.426697, 0.419438, 0.413104, 0.408765, 0.404339, 0.39973, 0.395898, 0.393831, 0.391222, 0.387093, 0.38403, 0.385421, 0.386532, 0.385041, 0.383549, 0.38351, 0.38351, 0.383453, 0.383384, 0.384036, 0.385085, 0.386465, 0.388265, 0.390236, 0.392859, 0.395482, 0.396663, 0.397759, 0.397928, 0.397603, 0.397429, 0.397557, 0.397685, 0.403499, 0.409412, 0.415759, 0.422393, 0.429188, 0.436661, 0.444135, 0.450594, 0.456716, 0.463112, 0.47022, 0.477328, 0.482694, 0.487551, 0.492258, 0.496487, 0.500716, 0.502591, 0.503306, 0.504168, 0.507012, 0.509856, 0.510709, 0.508975, 0.507242, 0.514519, 0.524533, 0.534058, 0.536667, 0.539277, 0.537258, 0.525841, 0.514425, 0.56814, 0.673029, 0.777917, 0.800703, 0.796703, 0.792702, 0.719092, 0.638933, 0.561429, 0.553041, 0.544653, 0.535936, 0.524892, 0.513848, 0.496895, 0.451887, 0.406879, 0.365328, 0.33881, 0.312291, 0.284943, 0.253336, 0.221728, 0.193125, 0.19126, 0.189396, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Welsbach = [0, 0, 0, 0, 0, 0.0138763, 0.00526935, 0.00805976, 0.00804424, 0.00932638, 0.00784314, 0.00914088, 0.00736471, 0.00653595, 0.00733373, 0.00623429, 0.00623429, 0.00623429, 0.00623429, 0.00732616, 0.00933316, 0.0122417, 0.0164444, 0.0261226, 0.0374148, 0.0510963, 0.0635466, 0.0940492, 0.11761, 0.152643, 0.19694, 0.229139, 0.262461, 0.316002, 0.368197, 0.416616, 0.46594, 0.495432, 0.530667, 0.543317, 0.546277, 0.551429, 0.561544, 0.565268, 0.576808, 0.587112, 0.594456, 0.606814, 0.613939, 0.623902, 0.627437, 0.635269, 0.642629, 0.657947, 0.662348, 0.660089, 0.649314, 0.640356, 0.62762, 0.61591, 0.605864, 0.594108, 0.593401, 0.596339, 0.591355, 0.585611, 0.585516, 0.578173, 0.575748, 0.580682, 0.582454, 0.581916, 0.58258, 0.580293, 0.582307, 0.586021, 0.590018, 0.594845, 0.594633, 0.602184, 0.603769, 0.602803, 0.605042, 0.607197, 0.607168, 0.606646, 0.604208, 0.601593, 0.602246, 0.60324, 0.607341, 0.612372, 0.617366, 0.617141, 0.614952, 0.619831, 0.623166, 0.620111, 0.616171, 0.613841, 0.613066, 0.614715, 0.617578, 0.618185, 0.61789, 0.620906, 0.623835, 0.626203, 0.627235, 0.626968, 0.625098, 0.623618, 0.627232, 0.632725, 0.632333, 0.630651, 0.62899, 0.626278, 0.62466, 0.623591, 0.620424, 0.618955, 0.615383, 0.612115, 0.609783, 0.606907, 0.603269, 0.598746, 0.593484, 0.587861, 0.581025, 0.57541, 0.570817, 0.558926, 0.554695, 0.554323, 0.554219, 0.55002, 0.543784, 0.53558, 0.528254, 0.523385, 0.522455, 0.518974, 0.513538, 0.504915, 0.502941, 0.50378, 0.508017, 0.50666, 0.501789, 0.497563, 0.494168, 0.492157, 0.490666, 0.488654, 0.474056, 0.457278, 0.436673, 0.431328, 0.434198, 0.445239, 0.455505, 0.45771, 0.457363, 0.452869, 0.448903, 0.445319, 0.445679, 0.447312, 0.449881, 0.452343, 0.449874, 0.448037, 0.449924, 0.451495, 0.451986, 0.452556, 0.453323, 0.453127, 0.450857, 0.448418, 0.445628, 0.441899, 0.436041, 0.43037, 0.425221, 0.421186, 0.42181, 0.423069, 0.430245, 0.43742, 0.436924, 0.436222, 0.440074, 0.444899, 0.451011, 0.457828, 0.464418, 0.47072, 0.475827, 0.476361, 0.476894, 0.482458, 0.488315, 0.489215, 0.487481, 0.486838, 0.488378, 0.489919, 0.492187, 0.494467, 0.49908, 0.505234, 0.512052, 0.521667, 0.531281, 0.538154, 0.544113, 0.54922, 0.552111, 0.555003, 0.559185, 0.563745, 0.568594, 0.574369, 0.580145, 0.585703, 0.591154, 0.596445, 0.599575, 0.602705, 0.605704, 0.608531, 0.611357, 0.615285, 0.619548, 0.623528, 0.62351, 0.623491, 0.623377, 0.623068, 0.62276, 0.622213, 0.621478, 0.620744, 0.618107, 0.61485, 0.611592, 0.607079, 0.602449, 0.597849, 0.594051, 0.590254, 0.586038, 0.578863, 0.571688, 0.562973, 0.546949, 0.530925, 0.514248, 0.49473, 0.475211, 0.455563, 0.435252, 0.414942, 0.395822, 0.387311, 0.378799, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    XeI = [0, 0, 0, 0, 0, 0.00249587, 0.00256871, 0.00338777, 0.00271493, 0.00262691, 0.00271493, 0.00272632, 0.0030305, 0.00273664, 0.00251457, 0.00309854, 0.00283156, 0.0034225, 0.00349957, 0.0023002, 0.00251798, 0.00384233, 0.00441652, 0.00297913, 0.00301659, 0.00390398, 0.00463193, 0.00462918, 0.00444131, 0.00631111, 0.00874128, 0.00965486, 0.0111969, 0.0136657, 0.0163986, 0.0186658, 0.0231602, 0.0317566, 0.0450556, 0.052369, 0.0494522, 0.0517822, 0.0575072, 0.0618027, 0.0701638, 0.0764817, 0.0785497, 0.0836194, 0.111651, 0.157517, 0.264587, 0.333346, 0.257697, 0.271535, 0.225283, 0.192397, 0.203571, 0.233136, 0.277113, 0.283801, 0.298559, 0.359687, 0.593105, 0.709461, 0.486427, 0.405694, 0.51275, 0.710742, 0.700814, 0.501354, 0.559173, 0.404816, 0.40998, 0.607886, 0.56487, 0.343147, 0.320907, 0.34006, 0.347942, 0.428974, 0.52904, 0.495541, 0.459863, 0.516206, 0.4532, 0.333845, 0.296323, 0.305378, 0.312621, 0.342245, 0.435977, 0.54151, 0.420651, 0.257877, 0.237978, 0.231389, 0.224358, 0.2328, 0.238444, 0.255136, 0.28087, 0.30008, 0.294793, 0.280866, 0.288017, 0.301028, 0.304686, 0.304114, 0.318074, 0.327728, 0.328468, 0.32726, 0.332596, 0.344661, 0.356116, 0.360615, 0.353097, 0.34782, 0.346192, 0.348527, 0.354774, 0.363392, 0.372017, 0.371496, 0.362715, 0.361718, 0.365549, 0.363953, 0.358266, 0.356749, 0.362526, 0.367417, 0.370126, 0.377089, 0.378725, 0.378184, 0.379021, 0.37462, 0.3687, 0.362335, 0.356972, 0.351415, 0.345267, 0.343887, 0.346597, 0.35616, 0.35029, 0.339735, 0.328478, 0.328009, 0.334363, 0.349075, 0.360556, 0.36665, 0.360909, 0.350286, 0.332774, 0.32033, 0.316778, 0.309919, 0.301279, 0.292952, 0.286117, 0.287022, 0.292985, 0.307166, 0.320236, 0.332502, 0.316769, 0.291998, 0.265891, 0.241189, 0.254381, 0.267945, 0.283699, 0.305804, 0.349534, 0.389984, 0.422164, 0.446014, 0.451917, 0.453833, 0.447431, 0.447407, 0.461853, 0.473189, 0.475812, 0.47967, 0.488689, 0.495556, 0.482389, 0.469221, 0.455828, 0.442428, 0.438263, 0.43607, 0.426854, 0.413789, 0.402973, 0.395006, 0.388012, 0.384744, 0.381477, 0.380302, 0.379249, 0.387912, 0.401738, 0.412563, 0.417377, 0.42219, 0.431343, 0.440571, 0.44717, 0.452031, 0.453899, 0.443172, 0.432446, 0.40638, 0.375201, 0.353142, 0.354768, 0.356394, 0.364404, 0.374277, 0.382038, 0.383036, 0.384035, 0.374806, 0.360541, 0.344157, 0.299187, 0.254216, 0.222095, 0.206661, 0.191228, 0.1929, 0.199769, 0.206601, 0.212922, 0.219244, 0.228199, 0.242501, 0.256804, 0.260639, 0.256249, 0.251859, 0.23013, 0.202743, 0.175357, 0.164121, 0.154405, 0.144726, 0.136027, 0.127328, 0.118732, 0.110858, 0.102984, 0.0948113, 0.0852172, 0.075623, 0.0662685, 0.0579556, 0.0496427, 0.0415072, 0.0342826, 0.027058, 0.0202536, 0.0171893, 0.0141251, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Xe = [0, 0, 0, 0, 0, 0.0347411, 0.0340215, 0.0341582, 0.0343892, 0.0341567, 0.0282872, 0.0235844, 0.0376529, 0.0495285, 0.0622137, 0.0848314, 0.110102, 0.120629, 0.137696, 0.168555, 0.156092, 0.168301, 0.205629, 0.198769, 0.146202, 0.11815, 0.111736, 0.120681, 0.131877, 0.135862, 0.153107, 0.198066, 0.219612, 0.196082, 0.165905, 0.164054, 0.176248, 0.195429, 0.227096, 0.254424, 0.250678, 0.228379, 0.208011, 0.216438, 0.255864, 0.288331, 0.304242, 0.297063, 0.256912, 0.218318, 0.209071, 0.210564, 0.239643, 0.259264, 0.264919, 0.259168, 0.244633, 0.2497, 0.267937, 0.297148, 0.313533, 0.321335, 0.302911, 0.26905, 0.256441, 0.258887, 0.269822, 0.284589, 0.305555, 0.303634, 0.292968, 0.282218, 0.275663, 0.273186, 0.271244, 0.26808, 0.262507, 0.265254, 0.278117, 0.292616, 0.294429, 0.292929, 0.317778, 0.358861, 0.46253, 0.577777, 0.580969, 0.53026, 0.46551, 0.466202, 0.453021, 0.414114, 0.397381, 0.418375, 0.42792, 0.365423, 0.304927, 0.297825, 0.32964, 0.352791, 0.352326, 0.343973, 0.335664, 0.330202, 0.330762, 0.336443, 0.34341, 0.35411, 0.369328, 0.386959, 0.405027, 0.415875, 0.413637, 0.405103, 0.40097, 0.387392, 0.382502, 0.385907, 0.399052, 0.425352, 0.46812, 0.485315, 0.484822, 0.470171, 0.446033, 0.421336, 0.42871, 0.448158, 0.475729, 0.511133, 0.568792, 0.622341, 0.663345, 0.666523, 0.654784, 0.631925, 0.597441, 0.580327, 0.565642, 0.547465, 0.531323, 0.518704, 0.511527, 0.517796, 0.534138, 0.566781, 0.581148, 0.588097, 0.586927, 0.576249, 0.559519, 0.527657, 0.498819, 0.475021, 0.45083, 0.427029, 0.412698, 0.400298, 0.391288, 0.384234, 0.378231, 0.36609, 0.35424, 0.346917, 0.338309, 0.327618, 0.322072, 0.320253, 0.318698, 0.317228, 0.31751, 0.31827, 0.326499, 0.333626, 0.334255, 0.334606, 0.334011, 0.332743, 0.329778, 0.323898, 0.311739, 0.30159, 0.295635, 0.290509, 0.287261, 0.282721, 0.27456, 0.267363, 0.264196, 0.262231, 0.271443, 0.280655, 0.287864, 0.29502, 0.304287, 0.314006, 0.324546, 0.335536, 0.345391, 0.353808, 0.361021, 0.363622, 0.366222, 0.368003, 0.369736, 0.370662, 0.371161, 0.371977, 0.373432, 0.374887, 0.37512, 0.375331, 0.375729, 0.376251, 0.376799, 0.377457, 0.378116, 0.377991, 0.377604, 0.377057, 0.376093, 0.37513, 0.373055, 0.370657, 0.367002, 0.359328, 0.351653, 0.344367, 0.337273, 0.330303, 0.324996, 0.31969, 0.313151, 0.30501, 0.296869, 0.290346, 0.284316, 0.278273, 0.272062, 0.265851, 0.260072, 0.255172, 0.250271, 0.245205, 0.240009, 0.234813, 0.228957, 0.222884, 0.216812, 0.210987, 0.205185, 0.199391, 0.193799, 0.188207, 0.182389, 0.174975, 0.167562, 0.16058, 0.155648, 0.150716, 0.145625, 0.139839, 0.134054, 0.128587, 0.124761, 0.120936, 0.117362, 0.116032, 0.114703, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    Zn = [0, 0, 0, 0, 0, 0.00299504, 0.00331825, 0.0032177, 0.00331825, 0.00351936, 0.00351936, 0.00351936, 0.00357311, 0.00351936, 0.00356889, 0.00291604, 0.00331825, 0.00291604, 0.00262271, 0.00346908, 0.00353722, 0.00356963, 0.00397024, 0.00437406, 0.00456703, 0.00691483, 0.00795649, 0.00804751, 0.00975825, 0.0138315, 0.014657, 0.016441, 0.0180444, 0.020894, 0.0252469, 0.031911, 0.0409976, 0.0357002, 0.0363467, 0.0397647, 0.0413972, 0.0431354, 0.0488403, 0.0541204, 0.0564458, 0.0568611, 0.0556717, 0.0575692, 0.0600258, 0.0629541, 0.066226, 0.0696133, 0.0737745, 0.076301, 0.079646, 0.0851685, 0.0937444, 0.0938481, 0.110249, 0.120545, 0.13916, 0.169051, 0.233592, 0.337177, 0.30181, 0.32505, 0.319935, 0.523407, 0.774504, 0.540334, 0.340516, 0.598034, 0.828482, 0.654425, 0.337101, 0.339494, 0.347318, 0.347305, 0.30399, 0.550283, 0.815809, 0.774203, 0.447651, 0.268314, 0.250547, 0.203622, 0.16996, 0.1427, 0.124907, 0.108465, 0.092221, 0.0802951, 0.0702036, 0.0616026, 0.0543065, 0.0460946, 0.0427571, 0.0400087, 0.0353283, 0.0324918, 0.0296683, 0.0265177, 0.025418, 0.0239529, 0.0217991, 0.0227573, 0.0219137, 0.0200662, 0.0184053, 0.0165128, 0.0156799, 0.0168586, 0.0182214, 0.0213653, 0.0342265, 0.0741619, 0.0855944, 0.0498557, 0.0191703, 0.0112899, 0.0112499, 0.0127193, 0.0130123, 0.0127859, 0.0124756, 0.012514, 0.0121559, 0.0120066, 0.0119692, 0.0114883, 0.0116596, 0.0118828, 0.0121024, 0.0132094, 0.0139529, 0.0148575, 0.01681, 0.0202938, 0.0241371, 0.0279495, 0.0301756, 0.0306461, 0.0285527, 0.0267641, 0.0242318, 0.0200501, 0.0172957, 0.0149834, 0.0127699, 0.0118771, 0.0118145, 0.011722, 0.0110929, 0.00956931, 0.00880131, 0.00834429, 0.00831457, 0.00789078, 0.00677548, 0.00655474, 0.00681569, 0.00628717, 0.00567389, 0.00499524, 0.00463898, 0.00480647, 0.00566019, 0.00701082, 0.00814295, 0.00920455, 0.00964329, 0.0100878, 0.0122115, 0.0139892, 0.013727, 0.0136712, 0.0143181, 0.0154056, 0.0176038, 0.0200567, 0.0230587, 0.027211, 0.0337633, 0.0395607, 0.0436459, 0.046631, 0.0465339, 0.045275, 0.0391583, 0.0333846, 0.0308033, 0.028222, 0.0247384, 0.0212308, 0.0203281, 0.0199818, 0.0204779, 0.0214356, 0.0238268, 0.0280353, 0.0328127, 0.0397696, 0.0467265, 0.0537424, 0.0607619, 0.0748864, 0.0927866, 0.104242, 0.102787, 0.101332, 0.0869849, 0.0724152, 0.0627358, 0.0562895, 0.0510336, 0.0507865, 0.0505395, 0.0530251, 0.0564215, 0.062608, 0.0760405, 0.0894731, 0.113823, 0.14136, 0.171112, 0.207958, 0.244804, 0.318804, 0.411103, 0.501114, 0.560247, 0.619381, 0.594926, 0.461904, 0.328882, 0.234484, 0.151819, 0.0735989, 0.0582734, 0.0429479, 0.0316915, 0.0286967, 0.0257018, 0.02317, 0.021002, 0.018834, 0.0175131, 0.0164686, 0.0154241, 0.0151426, 0.0149329, 0.0147176, 0.0143551, 0.0139927, 0.0135061, 0.0121427, 0.0107793, 0.00950958, 0.00868482, 0.00786007, 0.00708383, 0.00651856, 0.00595328, 0.00543999, 0.0051937, 0.00494741, 0.00471944, 0.00465459, 0.00458974, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

